#include <p32mx/p32mx_core.h>
#include <p32mx/p32mx_port.h>
#include <p32mx/p32mx_intc.h>
#include <p32mx/interrupt.h>
#include <p32mx/ostimer.h>

// Olimex PIC32-PINGUINO-MX220 
//    LED1 (Green) D13 = RB15 Active H (1: Light on)
//    LED2 (Red  ) D9  = RA10 Active H (1: Light on)
//    BUT          D8  = RB7  Active L (0 : Pressed)

void ostimer_entry()
{
	regx_inv(LAT , 0, 10);
}
void ostimer_entry2()
{
	regx_inv(LAT , 1 , 15);
}
void (* ostimer_callback)(void);

int main() {
	int i;
	regx_clr(TRIS , 1, 15);
	regx_clr(TRIS , 0, 10);
	regx_set(LAT , 1, 15);
	regx_clr(LAT , 0, 10);

	ostimer_callback = ostimer_entry;
	interrupt_enable();
	ostimer_start(1);
	regx_set(LAT , 1, 15);
	for (i=0;i<20;i++) {
		delay_us(500000);
		regx_inv(LAT , 1, 15);
	}
	ostimer_callback = ostimer_entry2;
	regx_clr(TRIS , 1, 15);
	regx_clr(TRIS , 0, 10);
	regx_clr(LAT , 1, 15);
	regx_set(LAT , 0, 10);
	for (;;) {
		delay_us(500000);
		regx_inv(LAT , 0, 10);
	}
}
