#include <p32mx/p32mx_core.h>
#include <p32mx/p32mx_port.h>
#include <p32mx/p32mx_intc.h>
#include <p32mx/interrupt.h>
#include <p32mx/ostimer.h>

// Olimex PIC32-PINGUINO-MX220 
//    LED1 (Green) D13 = RB15 Active H (1: Light on)
//    LED2 (Red  ) D9  = RA10 Active H (1: Light on)
//    BUT          D8  = RB7  Active L (0 : Pressed)

void ostimer_entry();
int main();
void intent();
void __intent();

void 
__attribute__((section(".gen_handler0")))
never_return()
{
	uint32_t c0_cause;
	int i,x;
	for (i=0;;i++) {
		__delay_loop_1(2000000);
		c0_cause = read_c0_cause();
		x = (c0_cause >> 2) & 0x1f;
		if (x < 5)
			LAT_INV(0)  = 1 << 10; // red
		c0_cause = read_c0_epc();
		//if ((uint32_t)ostimer_entry >= c0_cause) // lighted
		//if ((uint32_t)intent >= c0_cause) // lighted
		if (0x9d004400 >= c0_cause) // lighted
		//if ((uint32_t)__intent >= c0_cause) // not lighted
			LAT_INV(1)  = 1 << 15; // green
	}
}

void ostimer_entry()
{
	LAT_INV(0)  = 1 << 10;
}
void ostimer_entry2()
{
	LAT_INV(1)  = 1 << 15;
}
void (* ostimer_callback)(void);

int main() {
	static uint32_t sp;
	int i;
	regx_clr(TRIS , 1, 15);
	regx_clr(TRIS , 0, 10);
	regx_set(LAT , 1, 15);
	regx_clr(LAT , 0, 10);

	ostimer_callback = ostimer_entry;
	interrupt_enable();
	ostimer_start(1);
	LAT_SET(1)  = 1 << 15;
	sp = read_sp();
	for (i=0;i<20;i++) {
		if (sp == read_sp())
			delay_us(500000);
		else
			delay_us(1000000);
		regx_inv(LAT , 1, 15);
	}
	ostimer_callback = ostimer_entry2;
	TRIS_CLR(1) = 1 << 15;
	TRIS_CLR(0) = 1 << 10;
	LAT_CLR(1)  = 1 << 15;
	LAT_SET(0)  = 1 << 10;
    for (;;) {
	IEC_SET(0) = 0xffffffff;
	IFS_CLR(0) = 0xffffffff;
	__sei();
	ostimer_stop();
	ostimer_start(1);
	for (i=0;i<20;i++) {
		if (sp == read_sp())
			delay_us(500000);
		else
			delay_us(1000000);
		//IEC_SET(0) = 0xffffffff;
		//__sei();
		//__cli();
		//__irq_enable();
		LAT_INV(0)  = 1 << 10;
	}
    }
}

#define _BUILD_CONFIG
#include <p32mx/p32mx_devcfg.h>
#include <p32mx/p32mx_devcfg_build.h>
