#ifndef _JZ_CONSOLE_H_
#define _JZ_CONSOLE_H_
#include <stdio.h>
#include <p32mx/p32mx_intc.h>

#if (defined(__32MX1XX__) || defined(__32MX2XX__))
  #define serial0_init             _2xx_serial0_init
  #define serial1_init             _2xx_serial1_init
#elif defined(__32MX3XX__) || defined(__32MX4XX__)
  #define serial0_init             _4xx_serial0_init
  #define serial1_init             _4xx_serial1_init
#endif

#define serial_init(ch)				\
  { if ( (ch) == 0 ) serial0_init();		\
    else             serial1_init(); }

#define __serial_init(ch)			\
  { if ( (ch) == 0 ) _4xx_serial0_init();	\
    else             _4xx_serial1_init(); }

extern void _2xx_serial0_init();
extern void _2xx_serial1_init();
extern void _4xx_serial0_init();
extern void _4xx_serial1_init();

extern void jzcon_append(FILE *fp);
extern void jzcon_setup();

#define HEAP_SECTION __attribute__((section(".heap")))
#define HEAP_NV_SECTION __attribute__((section(".heap_nv")))
/*
 * usage:
 *     uint8_t heap_area[256] HEAP_SECTION;
 *     serial_init(0);
 *     jzcon_setup();
 *
 *     printf("hello \n");
 */
#endif /* _JZ_CONSOLE_H_ */
