#ifndef _JZ_P32MX_ADC_H_
#define _JZ_P32MX_ADC_H_
#include <stdint.h>

#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_0;
  #define _adc_base_addr        (_sfrs_base_addr_0 + 0x9000)
#else
  #define _adc_base_addr	((const void *)0xBF809000)
#endif

#define _ADC_ADDR		(_adc_base_addr)
#define _ADC_BUF_ADDR(x)	(_adc_base_addr + 0x70 + (x)*0x10)

  #define AD_CON1          (*(volatile uint16_t *)(_ADC_ADDR + 0x00))
  #define AD_CON1_CLR      (*(volatile uint16_t *)(_ADC_ADDR + 0x04))
  #define AD_CON1_SET      (*(volatile uint16_t *)(_ADC_ADDR + 0x08))
  #define AD_CON1_INV      (*(volatile uint16_t *)(_ADC_ADDR + 0x0C))
  #define AD_CON2          (*(volatile uint16_t *)(_ADC_ADDR + 0x10))
  #define AD_CON2_CLR      (*(volatile uint16_t *)(_ADC_ADDR + 0x14))
  #define AD_CON2_SET      (*(volatile uint16_t *)(_ADC_ADDR + 0x18))
  #define AD_CON2_INV      (*(volatile uint16_t *)(_ADC_ADDR + 0x1C))
  #define AD_CON3          (*(volatile uint16_t *)(_ADC_ADDR + 0x20))
  #define AD_CON3_CLR      (*(volatile uint16_t *)(_ADC_ADDR + 0x24))
  #define AD_CON3_SET      (*(volatile uint16_t *)(_ADC_ADDR + 0x28))
  #define AD_CON3_INV      (*(volatile uint16_t *)(_ADC_ADDR + 0x2C))
  #define AD_CHS           (*(volatile uint32_t *)(_ADC_ADDR + 0x40))
  #define AD_CHS_CLR       (*(volatile uint32_t *)(_ADC_ADDR + 0x44))
  #define AD_CHS_SET       (*(volatile uint32_t *)(_ADC_ADDR + 0x48))
  #define AD_CHS_INV       (*(volatile uint32_t *)(_ADC_ADDR + 0x4C))
  #define AD_CSSL          (*(volatile uint16_t *)(_ADC_ADDR + 0x50))
  #define AD_CSSL_CLR      (*(volatile uint16_t *)(_ADC_ADDR + 0x54))
  #define AD_CSSL_SET      (*(volatile uint16_t *)(_ADC_ADDR + 0x58))
  #define AD_CSSL_INV      (*(volatile uint16_t *)(_ADC_ADDR + 0x5C))

  /* x=0: ADC_BUF0 .. x=16: ADC_BUFF */
  #define ADC_BUF(x)       (*(volatile uint32_t *)(_ADC_BUF_ADDR(x)))

    #define AD_CON1_DONE                   0x00
    #define AD_CON1_SAMP                   0x01
    #define AD_CON1_ASAM                   0x02
    #define AD_CON1_CLRASAM                0x04
    #define AD_CON1_SSRC                   0x05
    #define AD_CON1_FORM                   0x08
    #define AD_CON1_SIDL                   0x0D
    #define AD_CON1_ON                     0x0F
    #define AD_CON1_SSRC0                  0x05
    #define AD_CON1_SSRC1                  0x06
    #define AD_CON1_SSRC2                  0x07
    #define AD_CON1_FORM0                  0x08
    #define AD_CON1_FORM1                  0x09
    #define AD_CON1_FORM2                  0x0A
    #define AD_CON1_ADSIDL                 0x0D
    #define AD_CON1_ADON                   0x0F
    #define AD_CON2_ALTS                   0x00
    #define AD_CON2_BUFM                   0x01
    #define AD_CON2_SMPI                   0x02
    #define AD_CON2_BUFS                   0x07
    #define AD_CON2_CSCNA                  0x0A
    #define AD_CON2_OFFCAL                 0x0C
    #define AD_CON2_VCFG                   0x0D
    #define AD_CON2_SMPI0                  0x02
    #define AD_CON2_SMPI1                  0x03
    #define AD_CON2_SMPI2                  0x04
    #define AD_CON2_SMPI3                  0x05
    #define AD_CON2_VCFG0                  0x0D
    #define AD_CON2_VCFG1                  0x0E
    #define AD_CON2_VCFG2                  0x0F
    #define AD_CON3_ADCS                   0x00
    #define AD_CON3_SAMC                   0x08
    #define AD_CON3_ADRC                   0x0F
    #define AD_CON3_ADCS0                  0x00
    #define AD_CON3_ADCS1                  0x01
    #define AD_CON3_ADCS2                  0x02
    #define AD_CON3_ADCS3                  0x03
    #define AD_CON3_ADCS4                  0x04
    #define AD_CON3_ADCS5                  0x05
    #define AD_CON3_ADCS6                  0x06
    #define AD_CON3_ADCS7                  0x07
    #define AD_CON3_SAMC0                  0x08
    #define AD_CON3_SAMC1                  0x09
    #define AD_CON3_SAMC2                  0x0A
    #define AD_CON3_SAMC3                  0x0B
    #define AD_CON3_SAMC4                  0x0C
    #define AD_CHS_CH0SA                   0x10
    #define AD_CHS_CH0NA                   0x17
    #define AD_CHS_CH0SB                   0x18
    #define AD_CHS_CH0NB                   0x1F
    #define AD_CHS_CH0SA0                  0x10
    #define AD_CHS_CH0SA1                  0x11
    #define AD_CHS_CH0SA2                  0x12
    #define AD_CHS_CH0SA3                  0x13
    #define AD_CHS_CH0SB0                  0x18
    #define AD_CHS_CH0SB1                  0x19
    #define AD_CHS_CH0SB2                  0x1A
    #define AD_CHS_CH0SB3                  0x1B

  /* comparator voltage reference */
  #define CVRCON           (*(volatile uint32_t *)0xBF809800)
  #define CVRCON_CLR       (*(volatile uint32_t *)0xBF809804)
  #define CVRCON_SET       (*(volatile uint32_t *)0xBF809808)
  #define CVRCON_INV       (*(volatile uint32_t *)0xBF80980C)
  /* comparator */
  /* x=0: CM1 x=2: CM3 */
  #define CM_CON(x)        (*(volatile uint16_t *)0xBF80A000 + (x)*0x10))
  #define CM_CON_CLR(x)    (*(volatile uint16_t *)0xBF80A004 + (x)*0x10))
  #define CM_CON_SET(x)    (*(volatile uint16_t *)0xBF80A008 + (x)*0x10))
  #define CM_CON_INV(x)    (*(volatile uint16_t *)0xBF80A00C + (x)*0x10))
  #define CMSTAT           (*(volatile uint16_t *)0xBF80A060)
  #define CMSTAT_CLR       (*(volatile uint16_t *)0xBF80A064)
  #define CMSTAT_SET       (*(volatile uint16_t *)0xBF80A068)
  #define CMSTAT_INV       (*(volatile uint16_t *)0xBF80A06C)

    #define CVRCON_CVR                     0x00
    #define CVRCON_CVRSS                   0x04
    #define CVRCON_CVRR                    0x05
    #define CVRCON_CVROE                   0x06
    #define CVRCON_ON                      0x0F
    #define CVRCON_CVR0                    0x00
    #define CVRCON_CVR1                    0x01
    #define CVRCON_CVR2                    0x02
    #define CVRCON_CVR3                    0x03

    #define CM_CON_CCH                     0x00
    #define CM_CON_CREF                    0x04
    #define CM_CON_EVPOL                   0x06
    #define CM_CON_COUT                    0x08
    #define CM_CON_CPOL                    0x0D
    #define CM_CON_COE                     0x0E
    #define CM_CON_ON                      0x0F
    #define CM_CON_CCH0                    0x00
    #define CM_CON_CCH1                    0x01
    #define CM_CON_EVPOL0                  0x06
    #define CM_CON_EVPOL1                  0x07

    #define CMSTAT_C1OUT                   0x00
    #define CMSTAT_C2OUT                   0x01
    #define CMSTAT_C3OUT                   0x02
    #define CMSTAT_SIDL                    0x0D
  /* Charge Time Measurement Unit (CTMU) */
  #define CTMUCON          (*(volatile unsigned *)0xBF80A200)
  #define CTMUCON_CLR      (*(volatile unsigned *)0xBF80A204)
  #define CTMUCON_SET      (*(volatile unsigned *)0xBF80A208)
  #define CTMUCON_INV      (*(volatile unsigned *)0xBF80A20C)

    #define CTMUCON_IRNG                   0x00
    #define CTMUCON_ITRIM                  0x02
    #define CTMUCON_CTTRIG                 0x08
    #define CTMUCON_IDISSEN                0x09
    #define CTMUCON_EDGSEQEN               0x0A
    #define CTMUCON_EDGEN                  0x0B
    #define CTMUCON_TGEN                   0x0C
    #define CTMUCON_CTMUSIDL               0x0D
    #define CTMUCON_ON                     0x0F
    #define CTMUCON_EDG2SEL                0x12
    #define CTMUCON_EDG2POL                0x16
    #define CTMUCON_EDG2MOD                0x17
    #define CTMUCON_EDG1STAT               0x18
    #define CTMUCON_EDG2STAT               0x19
    #define CTMUCON_EDG1SEL                0x1A
    #define CTMUCON_EDG1POL                0x1E
    #define CTMUCON_EDG1MOD                0x1F

#endif /* _JZ_P32MX_ADC_H_ */
