#ifndef _JZ_P32MX_UART_H_
#define _JZ_P32MX_UART_H_
#include <stdint.h>

#if defined(_USE_SFRS_BASE_ADDR)
  extern const void * _sfrs_base_addr_0;
  #define _uart_base_addr        (_sfrs_base_addr_0 + 0x6000)
#else
  #define _uart_base_addr	((const void *)0xBF806000)
#endif

#if defined(__32MX1XX__) || defined(__32MX2XX__)
  #define UART1	0
  #define UART2	1
#elif defined(__32MX3XX__) || defined(__32MX4XX__)
  #define UART1	0
  #define UART2	1
#elif defined(__32MX5XX__) || defined(__32MX6XX__) || defined(__32MX7XX__)
  #define UART1	0
  #define UART2	4
  #define UART3	2
  #define UART4	1
  #define UART5	5
  #define UART6	3
#endif

#define _UART_ADDR(x)	(_uart_base_addr + (x)*0x200)

  /* x=0:UART1 x=1: UART2 */
  #define U_MODE(x)           (*(volatile uint16_t *)(_UART_ADDR(x) + 0x00))
  #define U_MODE_CLR(x)       (*(volatile uint16_t *)(_UART_ADDR(x) + 0x04))
  #define U_MODE_SET(x)       (*(volatile uint16_t *)(_UART_ADDR(x) + 0x08))
  #define U_MODE_INV(x)       (*(volatile uint16_t *)(_UART_ADDR(x) + 0x0C))
  #define U_STA(x)            (*(volatile uint32_t *)(_UART_ADDR(x) + 0x10))
  #define U_STA_CLR(x)        (*(volatile uint32_t *)(_UART_ADDR(x) + 0x14))
  #define U_STA_SET(x)        (*(volatile uint32_t *)(_UART_ADDR(x) + 0x18))
  #define U_STA_INV(x)        (*(volatile uint32_t *)(_UART_ADDR(x) + 0x1C))
  #define U_TXREG(x)          (*(volatile uint16_t *)(_UART_ADDR(x) + 0x20))
  #define U_RXREG(x)          (*(volatile uint16_t *)(_UART_ADDR(x) + 0x30))
  #define U_BRG(x)            (*(volatile uint16_t *)(_UART_ADDR(x) + 0x40))
  #define U_BRG_CLR(x)        (*(volatile uint16_t *)(_UART_ADDR(x) + 0x44))
  #define U_BRG_SET(x)        (*(volatile uint16_t *)(_UART_ADDR(x) + 0x48))
  #define U_BRG_INV(x)        (*(volatile uint16_t *)(_UART_ADDR(x) + 0x4C))

  #define U_STAh(x)           (*(volatile uint16_t *)(_UART_ADDR(x) + 0x10))
  #define U_STAh_CLR(x)       (*(volatile uint16_t *)(_UART_ADDR(x) + 0x14))
  #define U_STAh_SET(x)       (*(volatile uint16_t *)(_UART_ADDR(x) + 0x18))
  #define U_STAh_INV(x)       (*(volatile uint16_t *)(_UART_ADDR(x) + 0x1C))
  #define U_TXREGb(x)         (*(volatile uint8_t  *)(_UART_ADDR(x) + 0x20))
  #define U_RXREGb(x)         (*(volatile uint8_t  *)(_UART_ADDR(x) + 0x30))

    #define U_MODE_STSEL	0x00
    #define U_MODE_PDSEL	0x01
    #define U_MODE_BRGH		0x03
    #define U_MODE_RXINV	0x04
    #define U_MODE_ABAUD	0x05
    #define U_MODE_LPBACK	0x06
    #define U_MODE_WAKE		0x07
    #define U_MODE_UEN		0x08
    #define U_MODE_RTSMD	0x0B
    #define U_MODE_IREN		0x0C
    #define U_MODE_SIDL		0x0D
    #define U_MODE_ON		0x0F

//  #define U_MODE_USIDL	0x0D
//  #define U_MODE_UARTEN	0x0F

    #define U_STA_URXDA		0x00
    #define U_STA_OERR		0x01
    #define U_STA_FERR		0x02
    #define U_STA_PERR		0x03
    #define U_STA_RIDLE		0x04
    #define U_STA_ADDEN		0x05
    #define U_STA_URXISEL	0x06
    #define U_STA_TRMT		0x08
    #define U_STA_UTXBF		0x09
    #define U_STA_UTXEN		0x0A
    #define U_STA_UTXBRK	0x0B
    #define U_STA_URXEN		0x0C
    #define U_STA_UTXINV	0x0D
    #define U_STA_UTXISEL	0x0E

    #define U_STA_ADDR		0x10	/* can't use with U_STAh(x) */
    #define U_STA_ADM_EN	0x18	/* can't use with U_STAh(x) */

//  #define U_STA_UTXSEL	0x0E

#endif /* _JZ_P32MX_UART_H_ */
