#ifndef _P32MX_7XX_REGS_H_
#define _P32MX_7XX_REGS_H_

#ifdef _USE_SFRS_BASE_ADDR
  extern const void * _sfrs_base_addr_0;
  extern const void * _sfrs_base_addr_1;
#else
#define _sfrs_base_addr_0	((const void *)0xBF800000)
#define _sfrs_base_addr_1	((const void *)0xBF880000)
#endif

#define _SFRS_ADDR(x) ( _sfrs_base_addr_ ## x )

#define _WDTCON           (_SRFS_ADDR(0) + 0x0000)
#define _WDTCONCLR        (_SRFS_ADDR(0) + 0x0004)
#define _WDTCONSET        (_SRFS_ADDR(0) + 0x0008)
#define _WDTCONINV        (_SRFS_ADDR(0) + 0x000C)
#define _RTCCON           (_SRFS_ADDR(0) + 0x0200)
#define _RTCCONCLR        (_SRFS_ADDR(0) + 0x0204)
#define _RTCCONSET        (_SRFS_ADDR(0) + 0x0208)
#define _RTCCONINV        (_SRFS_ADDR(0) + 0x020C)
#define _RTCALRM          (_SRFS_ADDR(0) + 0x0210)
#define _RTCALRMCLR       (_SRFS_ADDR(0) + 0x0214)
#define _RTCALRMSET       (_SRFS_ADDR(0) + 0x0218)
#define _RTCALRMINV       (_SRFS_ADDR(0) + 0x021C)
#define _RTCTIME          (_SRFS_ADDR(0) + 0x0220)
#define _RTCTIMECLR       (_SRFS_ADDR(0) + 0x0224)
#define _RTCTIMESET       (_SRFS_ADDR(0) + 0x0228)
#define _RTCTIMEINV       (_SRFS_ADDR(0) + 0x022C)
#define _RTCDATE          (_SRFS_ADDR(0) + 0x0230)
#define _RTCDATECLR       (_SRFS_ADDR(0) + 0x0234)
#define _RTCDATESET       (_SRFS_ADDR(0) + 0x0238)
#define _RTCDATEINV       (_SRFS_ADDR(0) + 0x023C)
#define _ALRMTIME         (_SRFS_ADDR(0) + 0x0240)
#define _ALRMTIMECLR      (_SRFS_ADDR(0) + 0x0244)
#define _ALRMTIMESET      (_SRFS_ADDR(0) + 0x0248)
#define _ALRMTIMEINV      (_SRFS_ADDR(0) + 0x024C)
#define _ALRMDATE         (_SRFS_ADDR(0) + 0x0250)
#define _ALRMDATECLR      (_SRFS_ADDR(0) + 0x0254)
#define _ALRMDATESET      (_SRFS_ADDR(0) + 0x0258)
#define _ALRMDATEINV      (_SRFS_ADDR(0) + 0x025C)
#define _T1CON            (_SRFS_ADDR(0) + 0x0600)
#define _T1CONCLR         (_SRFS_ADDR(0) + 0x0604)
#define _T1CONSET         (_SRFS_ADDR(0) + 0x0608)
#define _T1CONINV         (_SRFS_ADDR(0) + 0x060C)
#define _TMR1             (_SRFS_ADDR(0) + 0x0610)
#define _TMR1CLR          (_SRFS_ADDR(0) + 0x0614)
#define _TMR1SET          (_SRFS_ADDR(0) + 0x0618)
#define _TMR1INV          (_SRFS_ADDR(0) + 0x061C)
#define _PR1              (_SRFS_ADDR(0) + 0x0620)
#define _PR1CLR           (_SRFS_ADDR(0) + 0x0624)
#define _PR1SET           (_SRFS_ADDR(0) + 0x0628)
#define _PR1INV           (_SRFS_ADDR(0) + 0x062C)
#define _T2CON            (_SRFS_ADDR(0) + 0x0800)
#define _T2CONCLR         (_SRFS_ADDR(0) + 0x0804)
#define _T2CONSET         (_SRFS_ADDR(0) + 0x0808)
#define _T2CONINV         (_SRFS_ADDR(0) + 0x080C)
#define _TMR2             (_SRFS_ADDR(0) + 0x0810)
#define _TMR2CLR          (_SRFS_ADDR(0) + 0x0814)
#define _TMR2SET          (_SRFS_ADDR(0) + 0x0818)
#define _TMR2INV          (_SRFS_ADDR(0) + 0x081C)
#define _PR2              (_SRFS_ADDR(0) + 0x0820)
#define _PR2CLR           (_SRFS_ADDR(0) + 0x0824)
#define _PR2SET           (_SRFS_ADDR(0) + 0x0828)
#define _PR2INV           (_SRFS_ADDR(0) + 0x082C)
#define _T3CON            (_SRFS_ADDR(0) + 0x0A00)
#define _T3CONCLR         (_SRFS_ADDR(0) + 0x0A04)
#define _T3CONSET         (_SRFS_ADDR(0) + 0x0A08)
#define _T3CONINV         (_SRFS_ADDR(0) + 0x0A0C)
#define _TMR3             (_SRFS_ADDR(0) + 0x0A10)
#define _TMR3CLR          (_SRFS_ADDR(0) + 0x0A14)
#define _TMR3SET          (_SRFS_ADDR(0) + 0x0A18)
#define _TMR3INV          (_SRFS_ADDR(0) + 0x0A1C)
#define _PR3              (_SRFS_ADDR(0) + 0x0A20)
#define _PR3CLR           (_SRFS_ADDR(0) + 0x0A24)
#define _PR3SET           (_SRFS_ADDR(0) + 0x0A28)
#define _PR3INV           (_SRFS_ADDR(0) + 0x0A2C)
#define _T4CON            (_SRFS_ADDR(0) + 0x0C00)
#define _T4CONCLR         (_SRFS_ADDR(0) + 0x0C04)
#define _T4CONSET         (_SRFS_ADDR(0) + 0x0C08)
#define _T4CONINV         (_SRFS_ADDR(0) + 0x0C0C)
#define _TMR4             (_SRFS_ADDR(0) + 0x0C10)
#define _TMR4CLR          (_SRFS_ADDR(0) + 0x0C14)
#define _TMR4SET          (_SRFS_ADDR(0) + 0x0C18)
#define _TMR4INV          (_SRFS_ADDR(0) + 0x0C1C)
#define _PR4              (_SRFS_ADDR(0) + 0x0C20)
#define _PR4CLR           (_SRFS_ADDR(0) + 0x0C24)
#define _PR4SET           (_SRFS_ADDR(0) + 0x0C28)
#define _PR4INV           (_SRFS_ADDR(0) + 0x0C2C)
#define _T5CON            (_SRFS_ADDR(0) + 0x0E00)
#define _T5CONCLR         (_SRFS_ADDR(0) + 0x0E04)
#define _T5CONSET         (_SRFS_ADDR(0) + 0x0E08)
#define _T5CONINV         (_SRFS_ADDR(0) + 0x0E0C)
#define _TMR5             (_SRFS_ADDR(0) + 0x0E10)
#define _TMR5CLR          (_SRFS_ADDR(0) + 0x0E14)
#define _TMR5SET          (_SRFS_ADDR(0) + 0x0E18)
#define _TMR5INV          (_SRFS_ADDR(0) + 0x0E1C)
#define _PR5              (_SRFS_ADDR(0) + 0x0E20)
#define _PR5CLR           (_SRFS_ADDR(0) + 0x0E24)
#define _PR5SET           (_SRFS_ADDR(0) + 0x0E28)
#define _PR5INV           (_SRFS_ADDR(0) + 0x0E2C)
#define _IC1CON           (_SRFS_ADDR(0) + 0x2000)
#define _IC1CONCLR        (_SRFS_ADDR(0) + 0x2004)
#define _IC1CONSET        (_SRFS_ADDR(0) + 0x2008)
#define _IC1CONINV        (_SRFS_ADDR(0) + 0x200C)
#define _IC1BUF           (_SRFS_ADDR(0) + 0x2010)
#define _IC2CON           (_SRFS_ADDR(0) + 0x2200)
#define _IC2CONCLR        (_SRFS_ADDR(0) + 0x2204)
#define _IC2CONSET        (_SRFS_ADDR(0) + 0x2208)
#define _IC2CONINV        (_SRFS_ADDR(0) + 0x220C)
#define _IC2BUF           (_SRFS_ADDR(0) + 0x2210)
#define _IC3CON           (_SRFS_ADDR(0) + 0x2400)
#define _IC3CONCLR        (_SRFS_ADDR(0) + 0x2404)
#define _IC3CONSET        (_SRFS_ADDR(0) + 0x2408)
#define _IC3CONINV        (_SRFS_ADDR(0) + 0x240C)
#define _IC3BUF           (_SRFS_ADDR(0) + 0x2410)
#define _IC4CON           (_SRFS_ADDR(0) + 0x2600)
#define _IC4CONCLR        (_SRFS_ADDR(0) + 0x2604)
#define _IC4CONSET        (_SRFS_ADDR(0) + 0x2608)
#define _IC4CONINV        (_SRFS_ADDR(0) + 0x260C)
#define _IC4BUF           (_SRFS_ADDR(0) + 0x2610)
#define _IC5CON           (_SRFS_ADDR(0) + 0x2800)
#define _IC5CONCLR        (_SRFS_ADDR(0) + 0x2804)
#define _IC5CONSET        (_SRFS_ADDR(0) + 0x2808)
#define _IC5CONINV        (_SRFS_ADDR(0) + 0x280C)
#define _IC5BUF           (_SRFS_ADDR(0) + 0x2810)
#define _OC1CON           (_SRFS_ADDR(0) + 0x3000)
#define _OC1CONCLR        (_SRFS_ADDR(0) + 0x3004)
#define _OC1CONSET        (_SRFS_ADDR(0) + 0x3008)
#define _OC1CONINV        (_SRFS_ADDR(0) + 0x300C)
#define _OC1R             (_SRFS_ADDR(0) + 0x3010)
#define _OC1RCLR          (_SRFS_ADDR(0) + 0x3014)
#define _OC1RSET          (_SRFS_ADDR(0) + 0x3018)
#define _OC1RINV          (_SRFS_ADDR(0) + 0x301C)
#define _OC1RS            (_SRFS_ADDR(0) + 0x3020)
#define _OC1RSCLR         (_SRFS_ADDR(0) + 0x3024)
#define _OC1RSSET         (_SRFS_ADDR(0) + 0x3028)
#define _OC1RSINV         (_SRFS_ADDR(0) + 0x302C)
#define _OC2CON           (_SRFS_ADDR(0) + 0x3200)
#define _OC2CONCLR        (_SRFS_ADDR(0) + 0x3204)
#define _OC2CONSET        (_SRFS_ADDR(0) + 0x3208)
#define _OC2CONINV        (_SRFS_ADDR(0) + 0x320C)
#define _OC2R             (_SRFS_ADDR(0) + 0x3210)
#define _OC2RCLR          (_SRFS_ADDR(0) + 0x3214)
#define _OC2RSET          (_SRFS_ADDR(0) + 0x3218)
#define _OC2RINV          (_SRFS_ADDR(0) + 0x321C)
#define _OC2RS            (_SRFS_ADDR(0) + 0x3220)
#define _OC2RSCLR         (_SRFS_ADDR(0) + 0x3224)
#define _OC2RSSET         (_SRFS_ADDR(0) + 0x3228)
#define _OC2RSINV         (_SRFS_ADDR(0) + 0x322C)
#define _OC3CON           (_SRFS_ADDR(0) + 0x3400)
#define _OC3CONCLR        (_SRFS_ADDR(0) + 0x3404)
#define _OC3CONSET        (_SRFS_ADDR(0) + 0x3408)
#define _OC3CONINV        (_SRFS_ADDR(0) + 0x340C)
#define _OC3R             (_SRFS_ADDR(0) + 0x3410)
#define _OC3RCLR          (_SRFS_ADDR(0) + 0x3414)
#define _OC3RSET          (_SRFS_ADDR(0) + 0x3418)
#define _OC3RINV          (_SRFS_ADDR(0) + 0x341C)
#define _OC3RS            (_SRFS_ADDR(0) + 0x3420)
#define _OC3RSCLR         (_SRFS_ADDR(0) + 0x3424)
#define _OC3RSSET         (_SRFS_ADDR(0) + 0x3428)
#define _OC3RSINV         (_SRFS_ADDR(0) + 0x342C)
#define _OC4CON           (_SRFS_ADDR(0) + 0x3600)
#define _OC4CONCLR        (_SRFS_ADDR(0) + 0x3604)
#define _OC4CONSET        (_SRFS_ADDR(0) + 0x3608)
#define _OC4CONINV        (_SRFS_ADDR(0) + 0x360C)
#define _OC4R             (_SRFS_ADDR(0) + 0x3610)
#define _OC4RCLR          (_SRFS_ADDR(0) + 0x3614)
#define _OC4RSET          (_SRFS_ADDR(0) + 0x3618)
#define _OC4RINV          (_SRFS_ADDR(0) + 0x361C)
#define _OC4RS            (_SRFS_ADDR(0) + 0x3620)
#define _OC4RSCLR         (_SRFS_ADDR(0) + 0x3624)
#define _OC4RSSET         (_SRFS_ADDR(0) + 0x3628)
#define _OC4RSINV         (_SRFS_ADDR(0) + 0x362C)
#define _OC5CON           (_SRFS_ADDR(0) + 0x3800)
#define _OC5CONCLR        (_SRFS_ADDR(0) + 0x3804)
#define _OC5CONSET        (_SRFS_ADDR(0) + 0x3808)
#define _OC5CONINV        (_SRFS_ADDR(0) + 0x380C)
#define _OC5R             (_SRFS_ADDR(0) + 0x3810)
#define _OC5RCLR          (_SRFS_ADDR(0) + 0x3814)
#define _OC5RSET          (_SRFS_ADDR(0) + 0x3818)
#define _OC5RINV          (_SRFS_ADDR(0) + 0x381C)
#define _OC5RS            (_SRFS_ADDR(0) + 0x3820)
#define _OC5RSCLR         (_SRFS_ADDR(0) + 0x3824)
#define _OC5RSSET         (_SRFS_ADDR(0) + 0x3828)
#define _OC5RSINV         (_SRFS_ADDR(0) + 0x382C)
#define _I2C1ACON         (_SRFS_ADDR(0) + 0x5000)
#define _I2C3CON          (_SRFS_ADDR(0) + 0x5000)
#define _I2C1ACONCLR      (_SRFS_ADDR(0) + 0x5004)
#define _I2C3CONCLR       (_SRFS_ADDR(0) + 0x5004)
#define _I2C1ACONSET      (_SRFS_ADDR(0) + 0x5008)
#define _I2C3CONSET       (_SRFS_ADDR(0) + 0x5008)
#define _I2C1ACONINV      (_SRFS_ADDR(0) + 0x500C)
#define _I2C3CONINV       (_SRFS_ADDR(0) + 0x500C)
#define _I2C1ASTAT        (_SRFS_ADDR(0) + 0x5010)
#define _I2C3STAT         (_SRFS_ADDR(0) + 0x5010)
#define _I2C1ASTATCLR     (_SRFS_ADDR(0) + 0x5014)
#define _I2C3STATCLR      (_SRFS_ADDR(0) + 0x5014)
#define _I2C1ASTATSET     (_SRFS_ADDR(0) + 0x5018)
#define _I2C3STATSET      (_SRFS_ADDR(0) + 0x5018)
#define _I2C1ASTATINV     (_SRFS_ADDR(0) + 0x501C)
#define _I2C3STATINV      (_SRFS_ADDR(0) + 0x501C)
#define _I2C1AADD         (_SRFS_ADDR(0) + 0x5020)
#define _I2C3ADD          (_SRFS_ADDR(0) + 0x5020)
#define _I2C1AADDCLR      (_SRFS_ADDR(0) + 0x5024)
#define _I2C3ADDCLR       (_SRFS_ADDR(0) + 0x5024)
#define _I2C1AADDSET      (_SRFS_ADDR(0) + 0x5028)
#define _I2C3ADDSET       (_SRFS_ADDR(0) + 0x5028)
#define _I2C1AADDINV      (_SRFS_ADDR(0) + 0x502C)
#define _I2C3ADDINV       (_SRFS_ADDR(0) + 0x502C)
#define _I2C1AMSK         (_SRFS_ADDR(0) + 0x5030)
#define _I2C3MSK          (_SRFS_ADDR(0) + 0x5030)
#define _I2C1AMSKCLR      (_SRFS_ADDR(0) + 0x5034)
#define _I2C3MSKCLR       (_SRFS_ADDR(0) + 0x5034)
#define _I2C1AMSKSET      (_SRFS_ADDR(0) + 0x5038)
#define _I2C3MSKSET       (_SRFS_ADDR(0) + 0x5038)
#define _I2C1AMSKINV      (_SRFS_ADDR(0) + 0x503C)
#define _I2C3MSKINV       (_SRFS_ADDR(0) + 0x503C)
#define _I2C1ABRG         (_SRFS_ADDR(0) + 0x5040)
#define _I2C3BRG          (_SRFS_ADDR(0) + 0x5040)
#define _I2C1ABRGCLR      (_SRFS_ADDR(0) + 0x5044)
#define _I2C3BRGCLR       (_SRFS_ADDR(0) + 0x5044)
#define _I2C1ABRGSET      (_SRFS_ADDR(0) + 0x5048)
#define _I2C3BRGSET       (_SRFS_ADDR(0) + 0x5048)
#define _I2C1ABRGINV      (_SRFS_ADDR(0) + 0x504C)
#define _I2C3BRGINV       (_SRFS_ADDR(0) + 0x504C)
#define _I2C1ATRN         (_SRFS_ADDR(0) + 0x5050)
#define _I2C3TRN          (_SRFS_ADDR(0) + 0x5050)
#define _I2C1ATRNCLR      (_SRFS_ADDR(0) + 0x5054)
#define _I2C3TRNCLR       (_SRFS_ADDR(0) + 0x5054)
#define _I2C1ATRNSET      (_SRFS_ADDR(0) + 0x5058)
#define _I2C3TRNSET       (_SRFS_ADDR(0) + 0x5058)
#define _I2C1ATRNINV      (_SRFS_ADDR(0) + 0x505C)
#define _I2C3TRNINV       (_SRFS_ADDR(0) + 0x505C)
#define _I2C1ARCV         (_SRFS_ADDR(0) + 0x5060)
#define _I2C3RCV          (_SRFS_ADDR(0) + 0x5060)
#define _I2C2ACON         (_SRFS_ADDR(0) + 0x5100)
#define _I2C4CON          (_SRFS_ADDR(0) + 0x5100)
#define _I2C2ACONCLR      (_SRFS_ADDR(0) + 0x5104)
#define _I2C4CONCLR       (_SRFS_ADDR(0) + 0x5104)
#define _I2C2ACONSET      (_SRFS_ADDR(0) + 0x5108)
#define _I2C4CONSET       (_SRFS_ADDR(0) + 0x5108)
#define _I2C2ACONINV      (_SRFS_ADDR(0) + 0x510C)
#define _I2C4CONINV       (_SRFS_ADDR(0) + 0x510C)
#define _I2C2ASTAT        (_SRFS_ADDR(0) + 0x5110)
#define _I2C4STAT         (_SRFS_ADDR(0) + 0x5110)
#define _I2C2ASTATCLR     (_SRFS_ADDR(0) + 0x5114)
#define _I2C4STATCLR      (_SRFS_ADDR(0) + 0x5114)
#define _I2C2ASTATSET     (_SRFS_ADDR(0) + 0x5118)
#define _I2C4STATSET      (_SRFS_ADDR(0) + 0x5118)
#define _I2C2ASTATINV     (_SRFS_ADDR(0) + 0x511C)
#define _I2C4STATINV      (_SRFS_ADDR(0) + 0x511C)
#define _I2C2AADD         (_SRFS_ADDR(0) + 0x5120)
#define _I2C4ADD          (_SRFS_ADDR(0) + 0x5120)
#define _I2C2AADDCLR      (_SRFS_ADDR(0) + 0x5124)
#define _I2C4ADDCLR       (_SRFS_ADDR(0) + 0x5124)
#define _I2C2AADDSET      (_SRFS_ADDR(0) + 0x5128)
#define _I2C4ADDSET       (_SRFS_ADDR(0) + 0x5128)
#define _I2C2AADDINV      (_SRFS_ADDR(0) + 0x512C)
#define _I2C4ADDINV       (_SRFS_ADDR(0) + 0x512C)
#define _I2C2AMSK         (_SRFS_ADDR(0) + 0x5130)
#define _I2C4MSK          (_SRFS_ADDR(0) + 0x5130)
#define _I2C2AMSKCLR      (_SRFS_ADDR(0) + 0x5134)
#define _I2C4MSKCLR       (_SRFS_ADDR(0) + 0x5134)
#define _I2C2AMSKSET      (_SRFS_ADDR(0) + 0x5138)
#define _I2C4MSKSET       (_SRFS_ADDR(0) + 0x5138)
#define _I2C2AMSKINV      (_SRFS_ADDR(0) + 0x513C)
#define _I2C4MSKINV       (_SRFS_ADDR(0) + 0x513C)
#define _I2C2ABRG         (_SRFS_ADDR(0) + 0x5140)
#define _I2C4BRG          (_SRFS_ADDR(0) + 0x5140)
#define _I2C2ABRGCLR      (_SRFS_ADDR(0) + 0x5144)
#define _I2C4BRGCLR       (_SRFS_ADDR(0) + 0x5144)
#define _I2C2ABRGSET      (_SRFS_ADDR(0) + 0x5148)
#define _I2C4BRGSET       (_SRFS_ADDR(0) + 0x5148)
#define _I2C2ABRGINV      (_SRFS_ADDR(0) + 0x514C)
#define _I2C4BRGINV       (_SRFS_ADDR(0) + 0x514C)
#define _I2C2ATRN         (_SRFS_ADDR(0) + 0x5150)
#define _I2C4TRN          (_SRFS_ADDR(0) + 0x5150)
#define _I2C2ATRNCLR      (_SRFS_ADDR(0) + 0x5154)
#define _I2C4TRNCLR       (_SRFS_ADDR(0) + 0x5154)
#define _I2C2ATRNSET      (_SRFS_ADDR(0) + 0x5158)
#define _I2C4TRNSET       (_SRFS_ADDR(0) + 0x5158)
#define _I2C2ATRNINV      (_SRFS_ADDR(0) + 0x515C)
#define _I2C4TRNINV       (_SRFS_ADDR(0) + 0x515C)
#define _I2C2ARCV         (_SRFS_ADDR(0) + 0x5160)
#define _I2C4RCV          (_SRFS_ADDR(0) + 0x5160)
#define _I2C3ACON         (_SRFS_ADDR(0) + 0x5200)
#define _I2C5CON          (_SRFS_ADDR(0) + 0x5200)
#define _I2C3ACONCLR      (_SRFS_ADDR(0) + 0x5204)
#define _I2C5CONCLR       (_SRFS_ADDR(0) + 0x5204)
#define _I2C3ACONSET      (_SRFS_ADDR(0) + 0x5208)
#define _I2C5CONSET       (_SRFS_ADDR(0) + 0x5208)
#define _I2C3ACONINV      (_SRFS_ADDR(0) + 0x520C)
#define _I2C5CONINV       (_SRFS_ADDR(0) + 0x520C)
#define _I2C3ASTAT        (_SRFS_ADDR(0) + 0x5210)
#define _I2C5STAT         (_SRFS_ADDR(0) + 0x5210)
#define _I2C3ASTATCLR     (_SRFS_ADDR(0) + 0x5214)
#define _I2C5STATCLR      (_SRFS_ADDR(0) + 0x5214)
#define _I2C3ASTATSET     (_SRFS_ADDR(0) + 0x5218)
#define _I2C5STATSET      (_SRFS_ADDR(0) + 0x5218)
#define _I2C3ASTATINV     (_SRFS_ADDR(0) + 0x521C)
#define _I2C5STATINV      (_SRFS_ADDR(0) + 0x521C)
#define _I2C3AADD         (_SRFS_ADDR(0) + 0x5220)
#define _I2C5ADD          (_SRFS_ADDR(0) + 0x5220)
#define _I2C3AADDCLR      (_SRFS_ADDR(0) + 0x5224)
#define _I2C5ADDCLR       (_SRFS_ADDR(0) + 0x5224)
#define _I2C3AADDSET      (_SRFS_ADDR(0) + 0x5228)
#define _I2C5ADDSET       (_SRFS_ADDR(0) + 0x5228)
#define _I2C3AADDINV      (_SRFS_ADDR(0) + 0x522C)
#define _I2C5ADDINV       (_SRFS_ADDR(0) + 0x522C)
#define _I2C3AMSK         (_SRFS_ADDR(0) + 0x5230)
#define _I2C5MSK          (_SRFS_ADDR(0) + 0x5230)
#define _I2C3AMSKCLR      (_SRFS_ADDR(0) + 0x5234)
#define _I2C5MSKCLR       (_SRFS_ADDR(0) + 0x5234)
#define _I2C3AMSKSET      (_SRFS_ADDR(0) + 0x5238)
#define _I2C5MSKSET       (_SRFS_ADDR(0) + 0x5238)
#define _I2C3AMSKINV      (_SRFS_ADDR(0) + 0x523C)
#define _I2C5MSKINV       (_SRFS_ADDR(0) + 0x523C)
#define _I2C3ABRG         (_SRFS_ADDR(0) + 0x5240)
#define _I2C5BRG          (_SRFS_ADDR(0) + 0x5240)
#define _I2C3ABRGCLR      (_SRFS_ADDR(0) + 0x5244)
#define _I2C5BRGCLR       (_SRFS_ADDR(0) + 0x5244)
#define _I2C3ABRGSET      (_SRFS_ADDR(0) + 0x5248)
#define _I2C5BRGSET       (_SRFS_ADDR(0) + 0x5248)
#define _I2C3ABRGINV      (_SRFS_ADDR(0) + 0x524C)
#define _I2C5BRGINV       (_SRFS_ADDR(0) + 0x524C)
#define _I2C3ATRN         (_SRFS_ADDR(0) + 0x5250)
#define _I2C5TRN          (_SRFS_ADDR(0) + 0x5250)
#define _I2C3ATRNCLR      (_SRFS_ADDR(0) + 0x5254)
#define _I2C5TRNCLR       (_SRFS_ADDR(0) + 0x5254)
#define _I2C3ATRNSET      (_SRFS_ADDR(0) + 0x5258)
#define _I2C5TRNSET       (_SRFS_ADDR(0) + 0x5258)
#define _I2C3ATRNINV      (_SRFS_ADDR(0) + 0x525C)
#define _I2C5TRNINV       (_SRFS_ADDR(0) + 0x525C)
#define _I2C3ARCV         (_SRFS_ADDR(0) + 0x5260)
#define _I2C5RCV          (_SRFS_ADDR(0) + 0x5260)
#define _I2C1CON          (_SRFS_ADDR(0) + 0x5300)
#define _I2C1CONCLR       (_SRFS_ADDR(0) + 0x5304)
#define _I2C1CONSET       (_SRFS_ADDR(0) + 0x5308)
#define _I2C1CONINV       (_SRFS_ADDR(0) + 0x530C)
#define _I2C1STAT         (_SRFS_ADDR(0) + 0x5310)
#define _I2C1STATCLR      (_SRFS_ADDR(0) + 0x5314)
#define _I2C1STATSET      (_SRFS_ADDR(0) + 0x5318)
#define _I2C1STATINV      (_SRFS_ADDR(0) + 0x531C)
#define _I2C1ADD          (_SRFS_ADDR(0) + 0x5320)
#define _I2C1ADDCLR       (_SRFS_ADDR(0) + 0x5324)
#define _I2C1ADDSET       (_SRFS_ADDR(0) + 0x5328)
#define _I2C1ADDINV       (_SRFS_ADDR(0) + 0x532C)
#define _I2C1MSK          (_SRFS_ADDR(0) + 0x5330)
#define _I2C1MSKCLR       (_SRFS_ADDR(0) + 0x5334)
#define _I2C1MSKSET       (_SRFS_ADDR(0) + 0x5338)
#define _I2C1MSKINV       (_SRFS_ADDR(0) + 0x533C)
#define _I2C1BRG          (_SRFS_ADDR(0) + 0x5340)
#define _I2C1BRGCLR       (_SRFS_ADDR(0) + 0x5344)
#define _I2C1BRGSET       (_SRFS_ADDR(0) + 0x5348)
#define _I2C1BRGINV       (_SRFS_ADDR(0) + 0x534C)
#define _I2C1TRN          (_SRFS_ADDR(0) + 0x5350)
#define _I2C1TRNCLR       (_SRFS_ADDR(0) + 0x5354)
#define _I2C1TRNSET       (_SRFS_ADDR(0) + 0x5358)
#define _I2C1TRNINV       (_SRFS_ADDR(0) + 0x535C)
#define _I2C1RCV          (_SRFS_ADDR(0) + 0x5360)
#define _I2C2CON          (_SRFS_ADDR(0) + 0x5400)
#define _I2C2CONCLR       (_SRFS_ADDR(0) + 0x5404)
#define _I2C2CONSET       (_SRFS_ADDR(0) + 0x5408)
#define _I2C2CONINV       (_SRFS_ADDR(0) + 0x540C)
#define _I2C2STAT         (_SRFS_ADDR(0) + 0x5410)
#define _I2C2STATCLR      (_SRFS_ADDR(0) + 0x5414)
#define _I2C2STATSET      (_SRFS_ADDR(0) + 0x5418)
#define _I2C2STATINV      (_SRFS_ADDR(0) + 0x541C)
#define _I2C2ADD          (_SRFS_ADDR(0) + 0x5420)
#define _I2C2ADDCLR       (_SRFS_ADDR(0) + 0x5424)
#define _I2C2ADDSET       (_SRFS_ADDR(0) + 0x5428)
#define _I2C2ADDINV       (_SRFS_ADDR(0) + 0x542C)
#define _I2C2MSK          (_SRFS_ADDR(0) + 0x5430)
#define _I2C2MSKCLR       (_SRFS_ADDR(0) + 0x5434)
#define _I2C2MSKSET       (_SRFS_ADDR(0) + 0x5438)
#define _I2C2MSKINV       (_SRFS_ADDR(0) + 0x543C)
#define _I2C2BRG          (_SRFS_ADDR(0) + 0x5440)
#define _I2C2BRGCLR       (_SRFS_ADDR(0) + 0x5444)
#define _I2C2BRGSET       (_SRFS_ADDR(0) + 0x5448)
#define _I2C2BRGINV       (_SRFS_ADDR(0) + 0x544C)
#define _I2C2TRN          (_SRFS_ADDR(0) + 0x5450)
#define _I2C2TRNCLR       (_SRFS_ADDR(0) + 0x5454)
#define _I2C2TRNSET       (_SRFS_ADDR(0) + 0x5458)
#define _I2C2TRNINV       (_SRFS_ADDR(0) + 0x545C)
#define _I2C2RCV          (_SRFS_ADDR(0) + 0x5460)
#define _SPI1ACON         (_SRFS_ADDR(0) + 0x5800)
#define _SPI3CON          (_SRFS_ADDR(0) + 0x5800)
#define _SPI1ACONCLR      (_SRFS_ADDR(0) + 0x5804)
#define _SPI3CONCLR       (_SRFS_ADDR(0) + 0x5804)
#define _SPI1ACONSET      (_SRFS_ADDR(0) + 0x5808)
#define _SPI3CONSET       (_SRFS_ADDR(0) + 0x5808)
#define _SPI1ACONINV      (_SRFS_ADDR(0) + 0x580C)
#define _SPI3CONINV       (_SRFS_ADDR(0) + 0x580C)
#define _SPI1ASTAT        (_SRFS_ADDR(0) + 0x5810)
#define _SPI3STAT         (_SRFS_ADDR(0) + 0x5810)
#define _SPI1ASTATCLR     (_SRFS_ADDR(0) + 0x5814)
#define _SPI3STATCLR      (_SRFS_ADDR(0) + 0x5814)
#define _SPI1ASTATSET     (_SRFS_ADDR(0) + 0x5818)
#define _SPI3STATSET      (_SRFS_ADDR(0) + 0x5818)
#define _SPI1ASTATINV     (_SRFS_ADDR(0) + 0x581C)
#define _SPI3STATINV      (_SRFS_ADDR(0) + 0x581C)
#define _SPI1ABUF         (_SRFS_ADDR(0) + 0x5820)
#define _SPI3BUF          (_SRFS_ADDR(0) + 0x5820)
#define _SPI1ABRG         (_SRFS_ADDR(0) + 0x5830)
#define _SPI3BRG          (_SRFS_ADDR(0) + 0x5830)
#define _SPI1ABRGCLR      (_SRFS_ADDR(0) + 0x5834)
#define _SPI3BRGCLR       (_SRFS_ADDR(0) + 0x5834)
#define _SPI1ABRGSET      (_SRFS_ADDR(0) + 0x5838)
#define _SPI3BRGSET       (_SRFS_ADDR(0) + 0x5838)
#define _SPI1ABRGINV      (_SRFS_ADDR(0) + 0x583C)
#define _SPI3BRGINV       (_SRFS_ADDR(0) + 0x583C)
#define _SPI2ACON         (_SRFS_ADDR(0) + 0x5A00)
#define _SPI2CON          (_SRFS_ADDR(0) + 0x5A00)
#define _SPI2ACONCLR      (_SRFS_ADDR(0) + 0x5A04)
#define _SPI2CONCLR       (_SRFS_ADDR(0) + 0x5A04)
#define _SPI2ACONSET      (_SRFS_ADDR(0) + 0x5A08)
#define _SPI2CONSET       (_SRFS_ADDR(0) + 0x5A08)
#define _SPI2ACONINV      (_SRFS_ADDR(0) + 0x5A0C)
#define _SPI2CONINV       (_SRFS_ADDR(0) + 0x5A0C)
#define _SPI2ASTAT        (_SRFS_ADDR(0) + 0x5A10)
#define _SPI2STAT         (_SRFS_ADDR(0) + 0x5A10)
#define _SPI2ASTATCLR     (_SRFS_ADDR(0) + 0x5A14)
#define _SPI2STATCLR      (_SRFS_ADDR(0) + 0x5A14)
#define _SPI2ASTATSET     (_SRFS_ADDR(0) + 0x5A18)
#define _SPI2STATSET      (_SRFS_ADDR(0) + 0x5A18)
#define _SPI2ASTATINV     (_SRFS_ADDR(0) + 0x5A1C)
#define _SPI2STATINV      (_SRFS_ADDR(0) + 0x5A1C)
#define _SPI2ABUF         (_SRFS_ADDR(0) + 0x5A20)
#define _SPI2BUF          (_SRFS_ADDR(0) + 0x5A20)
#define _SPI2ABRG         (_SRFS_ADDR(0) + 0x5A30)
#define _SPI2BRG          (_SRFS_ADDR(0) + 0x5A30)
#define _SPI2ABRGCLR      (_SRFS_ADDR(0) + 0x5A34)
#define _SPI2BRGCLR       (_SRFS_ADDR(0) + 0x5A34)
#define _SPI2ABRGSET      (_SRFS_ADDR(0) + 0x5A38)
#define _SPI2BRGSET       (_SRFS_ADDR(0) + 0x5A38)
#define _SPI2ABRGINV      (_SRFS_ADDR(0) + 0x5A3C)
#define _SPI2BRGINV       (_SRFS_ADDR(0) + 0x5A3C)
#define _SPI3ACON         (_SRFS_ADDR(0) + 0x5C00)
#define _SPI4CON          (_SRFS_ADDR(0) + 0x5C00)
#define _SPI3ACONCLR      (_SRFS_ADDR(0) + 0x5C04)
#define _SPI4CONCLR       (_SRFS_ADDR(0) + 0x5C04)
#define _SPI3ACONSET      (_SRFS_ADDR(0) + 0x5C08)
#define _SPI4CONSET       (_SRFS_ADDR(0) + 0x5C08)
#define _SPI3ACONINV      (_SRFS_ADDR(0) + 0x5C0C)
#define _SPI4CONINV       (_SRFS_ADDR(0) + 0x5C0C)
#define _SPI3ASTAT        (_SRFS_ADDR(0) + 0x5C10)
#define _SPI4STAT         (_SRFS_ADDR(0) + 0x5C10)
#define _SPI3ASTATCLR     (_SRFS_ADDR(0) + 0x5C14)
#define _SPI4STATCLR      (_SRFS_ADDR(0) + 0x5C14)
#define _SPI3ASTATSET     (_SRFS_ADDR(0) + 0x5C18)
#define _SPI4STATSET      (_SRFS_ADDR(0) + 0x5C18)
#define _SPI3ASTATINV     (_SRFS_ADDR(0) + 0x5C1C)
#define _SPI4STATINV      (_SRFS_ADDR(0) + 0x5C1C)
#define _SPI3ABUF         (_SRFS_ADDR(0) + 0x5C20)
#define _SPI4BUF          (_SRFS_ADDR(0) + 0x5C20)
#define _SPI3ABRG         (_SRFS_ADDR(0) + 0x5C30)
#define _SPI4BRG          (_SRFS_ADDR(0) + 0x5C30)
#define _SPI3ABRGCLR      (_SRFS_ADDR(0) + 0x5C34)
#define _SPI4BRGCLR       (_SRFS_ADDR(0) + 0x5C34)
#define _SPI3ABRGSET      (_SRFS_ADDR(0) + 0x5C38)
#define _SPI4BRGSET       (_SRFS_ADDR(0) + 0x5C38)
#define _SPI3ABRGINV      (_SRFS_ADDR(0) + 0x5C3C)
#define _SPI4BRGINV       (_SRFS_ADDR(0) + 0x5C3C)
#define _SPI1CON          (_SRFS_ADDR(0) + 0x5E00)
#define _SPI1CONCLR       (_SRFS_ADDR(0) + 0x5E04)
#define _SPI1CONSET       (_SRFS_ADDR(0) + 0x5E08)
#define _SPI1CONINV       (_SRFS_ADDR(0) + 0x5E0C)
#define _SPI1STAT         (_SRFS_ADDR(0) + 0x5E10)
#define _SPI1STATCLR      (_SRFS_ADDR(0) + 0x5E14)
#define _SPI1STATSET      (_SRFS_ADDR(0) + 0x5E18)
#define _SPI1STATINV      (_SRFS_ADDR(0) + 0x5E1C)
#define _SPI1BUF          (_SRFS_ADDR(0) + 0x5E20)
#define _SPI1BRG          (_SRFS_ADDR(0) + 0x5E30)
#define _SPI1BRGCLR       (_SRFS_ADDR(0) + 0x5E34)
#define _SPI1BRGSET       (_SRFS_ADDR(0) + 0x5E38)
#define _SPI1BRGINV       (_SRFS_ADDR(0) + 0x5E3C)
#define _U1AMODE          (_SRFS_ADDR(0) + 0x6000)
#define _U1MODE           (_SRFS_ADDR(0) + 0x6000)
#define _U1AMODECLR       (_SRFS_ADDR(0) + 0x6004)
#define _U1MODECLR        (_SRFS_ADDR(0) + 0x6004)
#define _U1AMODESET       (_SRFS_ADDR(0) + 0x6008)
#define _U1MODESET        (_SRFS_ADDR(0) + 0x6008)
#define _U1AMODEINV       (_SRFS_ADDR(0) + 0x600C)
#define _U1MODEINV        (_SRFS_ADDR(0) + 0x600C)
#define _U1ASTA           (_SRFS_ADDR(0) + 0x6010)
#define _U1STA            (_SRFS_ADDR(0) + 0x6010)
#define _U1ASTACLR        (_SRFS_ADDR(0) + 0x6014)
#define _U1STACLR         (_SRFS_ADDR(0) + 0x6014)
#define _U1ASTASET        (_SRFS_ADDR(0) + 0x6018)
#define _U1STASET         (_SRFS_ADDR(0) + 0x6018)
#define _U1ASTAINV        (_SRFS_ADDR(0) + 0x601C)
#define _U1STAINV         (_SRFS_ADDR(0) + 0x601C)
#define _U1ATXREG         (_SRFS_ADDR(0) + 0x6020)
#define _U1TXREG          (_SRFS_ADDR(0) + 0x6020)
#define _U1ARXREG         (_SRFS_ADDR(0) + 0x6030)
#define _U1RXREG          (_SRFS_ADDR(0) + 0x6030)
#define _U1ABRG           (_SRFS_ADDR(0) + 0x6040)
#define _U1BRG            (_SRFS_ADDR(0) + 0x6040)
#define _U1ABRGCLR        (_SRFS_ADDR(0) + 0x6044)
#define _U1BRGCLR         (_SRFS_ADDR(0) + 0x6044)
#define _U1ABRGSET        (_SRFS_ADDR(0) + 0x6048)
#define _U1BRGSET         (_SRFS_ADDR(0) + 0x6048)
#define _U1ABRGINV        (_SRFS_ADDR(0) + 0x604C)
#define _U1BRGINV         (_SRFS_ADDR(0) + 0x604C)
#define _U1BMODE          (_SRFS_ADDR(0) + 0x6200)
#define _U4MODE           (_SRFS_ADDR(0) + 0x6200)
#define _U1BMODECLR       (_SRFS_ADDR(0) + 0x6204)
#define _U4MODECLR        (_SRFS_ADDR(0) + 0x6204)
#define _U1BMODESET       (_SRFS_ADDR(0) + 0x6208)
#define _U4MODESET        (_SRFS_ADDR(0) + 0x6208)
#define _U1BMODEINV       (_SRFS_ADDR(0) + 0x620C)
#define _U4MODEINV        (_SRFS_ADDR(0) + 0x620C)
#define _U1BSTA           (_SRFS_ADDR(0) + 0x6210)
#define _U4STA            (_SRFS_ADDR(0) + 0x6210)
#define _U1BSTACLR        (_SRFS_ADDR(0) + 0x6214)
#define _U4STACLR         (_SRFS_ADDR(0) + 0x6214)
#define _U1BSTASET        (_SRFS_ADDR(0) + 0x6218)
#define _U4STASET         (_SRFS_ADDR(0) + 0x6218)
#define _U1BSTAINV        (_SRFS_ADDR(0) + 0x621C)
#define _U4STAINV         (_SRFS_ADDR(0) + 0x621C)
#define _U1BTXREG         (_SRFS_ADDR(0) + 0x6220)
#define _U4TXREG          (_SRFS_ADDR(0) + 0x6220)
#define _U1BRXREG         (_SRFS_ADDR(0) + 0x6230)
#define _U4RXREG          (_SRFS_ADDR(0) + 0x6230)
#define _U1BBRG           (_SRFS_ADDR(0) + 0x6240)
#define _U4BRG            (_SRFS_ADDR(0) + 0x6240)
#define _U1BBRGCLR        (_SRFS_ADDR(0) + 0x6244)
#define _U4BRGCLR         (_SRFS_ADDR(0) + 0x6244)
#define _U1BBRGSET        (_SRFS_ADDR(0) + 0x6248)
#define _U4BRGSET         (_SRFS_ADDR(0) + 0x6248)
#define _U1BBRGINV        (_SRFS_ADDR(0) + 0x624C)
#define _U4BRGINV         (_SRFS_ADDR(0) + 0x624C)
#define _U2AMODE          (_SRFS_ADDR(0) + 0x6400)
#define _U3MODE           (_SRFS_ADDR(0) + 0x6400)
#define _U2AMODECLR       (_SRFS_ADDR(0) + 0x6404)
#define _U3MODECLR        (_SRFS_ADDR(0) + 0x6404)
#define _U2AMODESET       (_SRFS_ADDR(0) + 0x6408)
#define _U3MODESET        (_SRFS_ADDR(0) + 0x6408)
#define _U2AMODEINV       (_SRFS_ADDR(0) + 0x640C)
#define _U3MODEINV        (_SRFS_ADDR(0) + 0x640C)
#define _U2ASTA           (_SRFS_ADDR(0) + 0x6410)
#define _U3STA            (_SRFS_ADDR(0) + 0x6410)
#define _U2ASTACLR        (_SRFS_ADDR(0) + 0x6414)
#define _U3STACLR         (_SRFS_ADDR(0) + 0x6414)
#define _U2ASTASET        (_SRFS_ADDR(0) + 0x6418)
#define _U3STASET         (_SRFS_ADDR(0) + 0x6418)
#define _U2ASTAINV        (_SRFS_ADDR(0) + 0x641C)
#define _U3STAINV         (_SRFS_ADDR(0) + 0x641C)
#define _U2ATXREG         (_SRFS_ADDR(0) + 0x6420)
#define _U3TXREG          (_SRFS_ADDR(0) + 0x6420)
#define _U2ARXREG         (_SRFS_ADDR(0) + 0x6430)
#define _U3RXREG          (_SRFS_ADDR(0) + 0x6430)
#define _U2ABRG           (_SRFS_ADDR(0) + 0x6440)
#define _U3BRG            (_SRFS_ADDR(0) + 0x6440)
#define _U2ABRGCLR        (_SRFS_ADDR(0) + 0x6444)
#define _U3BRGCLR         (_SRFS_ADDR(0) + 0x6444)
#define _U2ABRGSET        (_SRFS_ADDR(0) + 0x6448)
#define _U3BRGSET         (_SRFS_ADDR(0) + 0x6448)
#define _U2ABRGINV        (_SRFS_ADDR(0) + 0x644C)
#define _U3BRGINV         (_SRFS_ADDR(0) + 0x644C)
#define _U2BMODE          (_SRFS_ADDR(0) + 0x6600)
#define _U6MODE           (_SRFS_ADDR(0) + 0x6600)
#define _U2BMODECLR       (_SRFS_ADDR(0) + 0x6604)
#define _U6MODECLR        (_SRFS_ADDR(0) + 0x6604)
#define _U2BMODESET       (_SRFS_ADDR(0) + 0x6608)
#define _U6MODESET        (_SRFS_ADDR(0) + 0x6608)
#define _U2BMODEINV       (_SRFS_ADDR(0) + 0x660C)
#define _U6MODEINV        (_SRFS_ADDR(0) + 0x660C)
#define _U2BSTA           (_SRFS_ADDR(0) + 0x6610)
#define _U6STA            (_SRFS_ADDR(0) + 0x6610)
#define _U2BSTACLR        (_SRFS_ADDR(0) + 0x6614)
#define _U6STACLR         (_SRFS_ADDR(0) + 0x6614)
#define _U2BSTASET        (_SRFS_ADDR(0) + 0x6618)
#define _U6STASET         (_SRFS_ADDR(0) + 0x6618)
#define _U2BSTAINV        (_SRFS_ADDR(0) + 0x661C)
#define _U6STAINV         (_SRFS_ADDR(0) + 0x661C)
#define _U2BTXREG         (_SRFS_ADDR(0) + 0x6620)
#define _U6TXREG          (_SRFS_ADDR(0) + 0x6620)
#define _U2BRXREG         (_SRFS_ADDR(0) + 0x6630)
#define _U6RXREG          (_SRFS_ADDR(0) + 0x6630)
#define _U2BBRG           (_SRFS_ADDR(0) + 0x6640)
#define _U6BRG            (_SRFS_ADDR(0) + 0x6640)
#define _U2BBRGCLR        (_SRFS_ADDR(0) + 0x6644)
#define _U6BRGCLR         (_SRFS_ADDR(0) + 0x6644)
#define _U2BBRGSET        (_SRFS_ADDR(0) + 0x6648)
#define _U6BRGSET         (_SRFS_ADDR(0) + 0x6648)
#define _U2BBRGINV        (_SRFS_ADDR(0) + 0x664C)
#define _U6BRGINV         (_SRFS_ADDR(0) + 0x664C)
#define _U2MODE           (_SRFS_ADDR(0) + 0x6800)
#define _U3AMODE          (_SRFS_ADDR(0) + 0x6800)
#define _U2MODECLR        (_SRFS_ADDR(0) + 0x6804)
#define _U3AMODECLR       (_SRFS_ADDR(0) + 0x6804)
#define _U2MODESET        (_SRFS_ADDR(0) + 0x6808)
#define _U3AMODESET       (_SRFS_ADDR(0) + 0x6808)
#define _U2MODEINV        (_SRFS_ADDR(0) + 0x680C)
#define _U3AMODEINV       (_SRFS_ADDR(0) + 0x680C)
#define _U2STA            (_SRFS_ADDR(0) + 0x6810)
#define _U3ASTA           (_SRFS_ADDR(0) + 0x6810)
#define _U2STACLR         (_SRFS_ADDR(0) + 0x6814)
#define _U3ASTACLR        (_SRFS_ADDR(0) + 0x6814)
#define _U2STASET         (_SRFS_ADDR(0) + 0x6818)
#define _U3ASTASET        (_SRFS_ADDR(0) + 0x6818)
#define _U2STAINV         (_SRFS_ADDR(0) + 0x681C)
#define _U3ASTAINV        (_SRFS_ADDR(0) + 0x681C)
#define _U2TXREG          (_SRFS_ADDR(0) + 0x6820)
#define _U3ATXREG         (_SRFS_ADDR(0) + 0x6820)
#define _U2RXREG          (_SRFS_ADDR(0) + 0x6830)
#define _U3ARXREG         (_SRFS_ADDR(0) + 0x6830)
#define _U2BRG            (_SRFS_ADDR(0) + 0x6840)
#define _U3ABRG           (_SRFS_ADDR(0) + 0x6840)
#define _U2BRGCLR         (_SRFS_ADDR(0) + 0x6844)
#define _U3ABRGCLR        (_SRFS_ADDR(0) + 0x6844)
#define _U2BRGSET         (_SRFS_ADDR(0) + 0x6848)
#define _U3ABRGSET        (_SRFS_ADDR(0) + 0x6848)
#define _U2BRGINV         (_SRFS_ADDR(0) + 0x684C)
#define _U3ABRGINV        (_SRFS_ADDR(0) + 0x684C)
#define _U3BMODE          (_SRFS_ADDR(0) + 0x6A00)
#define _U5MODE           (_SRFS_ADDR(0) + 0x6A00)
#define _U3BMODECLR       (_SRFS_ADDR(0) + 0x6A04)
#define _U5MODECLR        (_SRFS_ADDR(0) + 0x6A04)
#define _U3BMODESET       (_SRFS_ADDR(0) + 0x6A08)
#define _U5MODESET        (_SRFS_ADDR(0) + 0x6A08)
#define _U3BMODEINV       (_SRFS_ADDR(0) + 0x6A0C)
#define _U5MODEINV        (_SRFS_ADDR(0) + 0x6A0C)
#define _U3BSTA           (_SRFS_ADDR(0) + 0x6A10)
#define _U5STA            (_SRFS_ADDR(0) + 0x6A10)
#define _U3BSTACLR        (_SRFS_ADDR(0) + 0x6A14)
#define _U5STACLR         (_SRFS_ADDR(0) + 0x6A14)
#define _U3BSTASET        (_SRFS_ADDR(0) + 0x6A18)
#define _U5STASET         (_SRFS_ADDR(0) + 0x6A18)
#define _U3BSTAINV        (_SRFS_ADDR(0) + 0x6A1C)
#define _U5STAINV         (_SRFS_ADDR(0) + 0x6A1C)
#define _U3BTXREG         (_SRFS_ADDR(0) + 0x6A20)
#define _U5TXREG          (_SRFS_ADDR(0) + 0x6A20)
#define _U3BRXREG         (_SRFS_ADDR(0) + 0x6A30)
#define _U5RXREG          (_SRFS_ADDR(0) + 0x6A30)
#define _U3BBRG           (_SRFS_ADDR(0) + 0x6A40)
#define _U5BRG            (_SRFS_ADDR(0) + 0x6A40)
#define _U3BBRGCLR        (_SRFS_ADDR(0) + 0x6A44)
#define _U5BRGCLR         (_SRFS_ADDR(0) + 0x6A44)
#define _U3BBRGSET        (_SRFS_ADDR(0) + 0x6A48)
#define _U5BRGSET         (_SRFS_ADDR(0) + 0x6A48)
#define _U3BBRGINV        (_SRFS_ADDR(0) + 0x6A4C)
#define _U5BRGINV         (_SRFS_ADDR(0) + 0x6A4C)
#define _PMCON            (_SRFS_ADDR(0) + 0x7000)
#define _PMCONCLR         (_SRFS_ADDR(0) + 0x7004)
#define _PMCONSET         (_SRFS_ADDR(0) + 0x7008)
#define _PMCONINV         (_SRFS_ADDR(0) + 0x700C)
#define _PMMODE           (_SRFS_ADDR(0) + 0x7010)
#define _PMMODECLR        (_SRFS_ADDR(0) + 0x7014)
#define _PMMODESET        (_SRFS_ADDR(0) + 0x7018)
#define _PMMODEINV        (_SRFS_ADDR(0) + 0x701C)
#define _PMADDR           (_SRFS_ADDR(0) + 0x7020)
#define _PMADDRCLR        (_SRFS_ADDR(0) + 0x7024)
#define _PMADDRSET        (_SRFS_ADDR(0) + 0x7028)
#define _PMADDRINV        (_SRFS_ADDR(0) + 0x702C)
#define _PMDOUT           (_SRFS_ADDR(0) + 0x7030)
#define _PMDOUTCLR        (_SRFS_ADDR(0) + 0x7034)
#define _PMDOUTSET        (_SRFS_ADDR(0) + 0x7038)
#define _PMDOUTINV        (_SRFS_ADDR(0) + 0x703C)
#define _PMDIN            (_SRFS_ADDR(0) + 0x7040)
#define _PMDINCLR         (_SRFS_ADDR(0) + 0x7044)
#define _PMDINSET         (_SRFS_ADDR(0) + 0x7048)
#define _PMDININV         (_SRFS_ADDR(0) + 0x704C)
#define _PMAEN            (_SRFS_ADDR(0) + 0x7050)
#define _PMAENCLR         (_SRFS_ADDR(0) + 0x7054)
#define _PMAENSET         (_SRFS_ADDR(0) + 0x7058)
#define _PMAENINV         (_SRFS_ADDR(0) + 0x705C)
#define _PMSTAT           (_SRFS_ADDR(0) + 0x7060)
#define _PMSTATCLR        (_SRFS_ADDR(0) + 0x7064)
#define _PMSTATSET        (_SRFS_ADDR(0) + 0x7068)
#define _PMSTATINV        (_SRFS_ADDR(0) + 0x706C)
#define _AD1CON1          (_SRFS_ADDR(0) + 0x9000)
#define _AD1CON1CLR       (_SRFS_ADDR(0) + 0x9004)
#define _AD1CON1SET       (_SRFS_ADDR(0) + 0x9008)
#define _AD1CON1INV       (_SRFS_ADDR(0) + 0x900C)
#define _AD1CON2          (_SRFS_ADDR(0) + 0x9010)
#define _AD1CON2CLR       (_SRFS_ADDR(0) + 0x9014)
#define _AD1CON2SET       (_SRFS_ADDR(0) + 0x9018)
#define _AD1CON2INV       (_SRFS_ADDR(0) + 0x901C)
#define _AD1CON3          (_SRFS_ADDR(0) + 0x9020)
#define _AD1CON3CLR       (_SRFS_ADDR(0) + 0x9024)
#define _AD1CON3SET       (_SRFS_ADDR(0) + 0x9028)
#define _AD1CON3INV       (_SRFS_ADDR(0) + 0x902C)
#define _AD1CHS           (_SRFS_ADDR(0) + 0x9040)
#define _AD1CHSCLR        (_SRFS_ADDR(0) + 0x9044)
#define _AD1CHSSET        (_SRFS_ADDR(0) + 0x9048)
#define _AD1CHSINV        (_SRFS_ADDR(0) + 0x904C)
#define _AD1CSSL          (_SRFS_ADDR(0) + 0x9050)
#define _AD1CSSLCLR       (_SRFS_ADDR(0) + 0x9054)
#define _AD1CSSLSET       (_SRFS_ADDR(0) + 0x9058)
#define _AD1CSSLINV       (_SRFS_ADDR(0) + 0x905C)
#define _AD1PCFG          (_SRFS_ADDR(0) + 0x9060)
#define _AD1PCFGCLR       (_SRFS_ADDR(0) + 0x9064)
#define _AD1PCFGSET       (_SRFS_ADDR(0) + 0x9068)
#define _AD1PCFGINV       (_SRFS_ADDR(0) + 0x906C)
#define _ADC1BUF0         (_SRFS_ADDR(0) + 0x9070)
#define _ADC1BUF1         (_SRFS_ADDR(0) + 0x9080)
#define _ADC1BUF2         (_SRFS_ADDR(0) + 0x9090)
#define _ADC1BUF3         (_SRFS_ADDR(0) + 0x90A0)
#define _ADC1BUF4         (_SRFS_ADDR(0) + 0x90B0)
#define _ADC1BUF5         (_SRFS_ADDR(0) + 0x90C0)
#define _ADC1BUF6         (_SRFS_ADDR(0) + 0x90D0)
#define _ADC1BUF7         (_SRFS_ADDR(0) + 0x90E0)
#define _ADC1BUF8         (_SRFS_ADDR(0) + 0x90F0)
#define _ADC1BUF9         (_SRFS_ADDR(0) + 0x9100)
#define _ADC1BUFA         (_SRFS_ADDR(0) + 0x9110)
#define _ADC1BUFB         (_SRFS_ADDR(0) + 0x9120)
#define _ADC1BUFC         (_SRFS_ADDR(0) + 0x9130)
#define _ADC1BUFD         (_SRFS_ADDR(0) + 0x9140)
#define _ADC1BUFE         (_SRFS_ADDR(0) + 0x9150)
#define _ADC1BUFF         (_SRFS_ADDR(0) + 0x9160)
#define _CVRCON           (_SRFS_ADDR(0) + 0x9800)
#define _CVRCONCLR        (_SRFS_ADDR(0) + 0x9804)
#define _CVRCONSET        (_SRFS_ADDR(0) + 0x9808)
#define _CVRCONINV        (_SRFS_ADDR(0) + 0x980C)
#define _CM1CON           (_SRFS_ADDR(0) + 0xA000)
#define _CM1CONCLR        (_SRFS_ADDR(0) + 0xA004)
#define _CM1CONSET        (_SRFS_ADDR(0) + 0xA008)
#define _CM1CONINV        (_SRFS_ADDR(0) + 0xA00C)
#define _CM2CON           (_SRFS_ADDR(0) + 0xA010)
#define _CM2CONCLR        (_SRFS_ADDR(0) + 0xA014)
#define _CM2CONSET        (_SRFS_ADDR(0) + 0xA018)
#define _CM2CONINV        (_SRFS_ADDR(0) + 0xA01C)
#define _CMSTAT           (_SRFS_ADDR(0) + 0xA060)
#define _CMSTATCLR        (_SRFS_ADDR(0) + 0xA064)
#define _CMSTATSET        (_SRFS_ADDR(0) + 0xA068)
#define _CMSTATINV        (_SRFS_ADDR(0) + 0xA06C)
#define _OSCCON           (_SRFS_ADDR(0) + 0xF000)
#define _OSCCONCLR        (_SRFS_ADDR(0) + 0xF004)
#define _OSCCONSET        (_SRFS_ADDR(0) + 0xF008)
#define _OSCCONINV        (_SRFS_ADDR(0) + 0xF00C)
#define _OSCTUN           (_SRFS_ADDR(0) + 0xF010)
#define _OSCTUNCLR        (_SRFS_ADDR(0) + 0xF014)
#define _OSCTUNSET        (_SRFS_ADDR(0) + 0xF018)
#define _OSCTUNINV        (_SRFS_ADDR(0) + 0xF01C)
#define _DDPCON           (_SRFS_ADDR(0) + 0xF200)
#define _DEVID            (_SRFS_ADDR(0) + 0xF220)
#define _SYSKEY           (_SRFS_ADDR(0) + 0xF230)
#define _SYSKEYCLR        (_SRFS_ADDR(0) + 0xF234)
#define _SYSKEYSET        (_SRFS_ADDR(0) + 0xF238)
#define _SYSKEYINV        (_SRFS_ADDR(0) + 0xF23C)
#define _NVMCON           (_SRFS_ADDR(0) + 0xF400)
#define _NVMCONCLR        (_SRFS_ADDR(0) + 0xF404)
#define _NVMCONSET        (_SRFS_ADDR(0) + 0xF408)
#define _NVMCONINV        (_SRFS_ADDR(0) + 0xF40C)
#define _NVMKEY           (_SRFS_ADDR(0) + 0xF410)
#define _NVMADDR          (_SRFS_ADDR(0) + 0xF420)
#define _NVMADDRCLR       (_SRFS_ADDR(0) + 0xF424)
#define _NVMADDRSET       (_SRFS_ADDR(0) + 0xF428)
#define _NVMADDRINV       (_SRFS_ADDR(0) + 0xF42C)
#define _NVMDATA          (_SRFS_ADDR(0) + 0xF430)
#define _NVMSRCADDR       (_SRFS_ADDR(0) + 0xF440)
#define _RCON             (_SRFS_ADDR(0) + 0xF600)
#define _RCONCLR          (_SRFS_ADDR(0) + 0xF604)
#define _RCONSET          (_SRFS_ADDR(0) + 0xF608)
#define _RCONINV          (_SRFS_ADDR(0) + 0xF60C)
#define _RSWRST           (_SRFS_ADDR(0) + 0xF610)
#define _RSWRSTCLR        (_SRFS_ADDR(0) + 0xF614)
#define _RSWRSTSET        (_SRFS_ADDR(0) + 0xF618)
#define _RSWRSTINV        (_SRFS_ADDR(0) + 0xF61C)
#define __DDPSTAT         (_SRFS_ADDR(1) + 0x0140)
#define __STRO            (_SRFS_ADDR(1) + 0x0170)
#define __STROCLR         (_SRFS_ADDR(1) + 0x0174)
#define __STROSET         (_SRFS_ADDR(1) + 0x0178)
#define __STROINV         (_SRFS_ADDR(1) + 0x017C)
#define __APPO            (_SRFS_ADDR(1) + 0x0180)
#define __APPOCLR         (_SRFS_ADDR(1) + 0x0184)
#define __APPOSET         (_SRFS_ADDR(1) + 0x0188)
#define __APPOINV         (_SRFS_ADDR(1) + 0x018C)
#define __APPI            (_SRFS_ADDR(1) + 0x0190)
#define _INTCON           (_SRFS_ADDR(1) + 0x1000)
#define _INTCONCLR        (_SRFS_ADDR(1) + 0x1004)
#define _INTCONSET        (_SRFS_ADDR(1) + 0x1008)
#define _INTCONINV        (_SRFS_ADDR(1) + 0x100C)
#define _INTSTAT          (_SRFS_ADDR(1) + 0x1010)
#define _IPTMR            (_SRFS_ADDR(1) + 0x1020)
#define _IPTMRCLR         (_SRFS_ADDR(1) + 0x1024)
#define _IPTMRSET         (_SRFS_ADDR(1) + 0x1028)
#define _IPTMRINV         (_SRFS_ADDR(1) + 0x102C)
#define _IFS0             (_SRFS_ADDR(1) + 0x1030)
#define _IFS0CLR          (_SRFS_ADDR(1) + 0x1034)
#define _IFS0SET          (_SRFS_ADDR(1) + 0x1038)
#define _IFS0INV          (_SRFS_ADDR(1) + 0x103C)
#define _IFS1             (_SRFS_ADDR(1) + 0x1040)
#define _IFS1CLR          (_SRFS_ADDR(1) + 0x1044)
#define _IFS1SET          (_SRFS_ADDR(1) + 0x1048)
#define _IFS1INV          (_SRFS_ADDR(1) + 0x104C)
#define _IFS2             (_SRFS_ADDR(1) + 0x1050)
#define _IFS2CLR          (_SRFS_ADDR(1) + 0x1054)
#define _IFS2SET          (_SRFS_ADDR(1) + 0x1058)
#define _IFS2INV          (_SRFS_ADDR(1) + 0x105C)
#define _IEC0             (_SRFS_ADDR(1) + 0x1060)
#define _IEC0CLR          (_SRFS_ADDR(1) + 0x1064)
#define _IEC0SET          (_SRFS_ADDR(1) + 0x1068)
#define _IEC0INV          (_SRFS_ADDR(1) + 0x106C)
#define _IEC1             (_SRFS_ADDR(1) + 0x1070)
#define _IEC1CLR          (_SRFS_ADDR(1) + 0x1074)
#define _IEC1SET          (_SRFS_ADDR(1) + 0x1078)
#define _IEC1INV          (_SRFS_ADDR(1) + 0x107C)
#define _IEC2             (_SRFS_ADDR(1) + 0x1080)
#define _IEC2CLR          (_SRFS_ADDR(1) + 0x1084)
#define _IEC2SET          (_SRFS_ADDR(1) + 0x1088)
#define _IEC2INV          (_SRFS_ADDR(1) + 0x108C)
#define _IPC0             (_SRFS_ADDR(1) + 0x1090)
#define _IPC0CLR          (_SRFS_ADDR(1) + 0x1094)
#define _IPC0SET          (_SRFS_ADDR(1) + 0x1098)
#define _IPC0INV          (_SRFS_ADDR(1) + 0x109C)
#define _IPC1             (_SRFS_ADDR(1) + 0x10A0)
#define _IPC1CLR          (_SRFS_ADDR(1) + 0x10A4)
#define _IPC1SET          (_SRFS_ADDR(1) + 0x10A8)
#define _IPC1INV          (_SRFS_ADDR(1) + 0x10AC)
#define _IPC2             (_SRFS_ADDR(1) + 0x10B0)
#define _IPC2CLR          (_SRFS_ADDR(1) + 0x10B4)
#define _IPC2SET          (_SRFS_ADDR(1) + 0x10B8)
#define _IPC2INV          (_SRFS_ADDR(1) + 0x10BC)
#define _IPC3             (_SRFS_ADDR(1) + 0x10C0)
#define _IPC3CLR          (_SRFS_ADDR(1) + 0x10C4)
#define _IPC3SET          (_SRFS_ADDR(1) + 0x10C8)
#define _IPC3INV          (_SRFS_ADDR(1) + 0x10CC)
#define _IPC4             (_SRFS_ADDR(1) + 0x10D0)
#define _IPC4CLR          (_SRFS_ADDR(1) + 0x10D4)
#define _IPC4SET          (_SRFS_ADDR(1) + 0x10D8)
#define _IPC4INV          (_SRFS_ADDR(1) + 0x10DC)
#define _IPC5             (_SRFS_ADDR(1) + 0x10E0)
#define _IPC5CLR          (_SRFS_ADDR(1) + 0x10E4)
#define _IPC5SET          (_SRFS_ADDR(1) + 0x10E8)
#define _IPC5INV          (_SRFS_ADDR(1) + 0x10EC)
#define _IPC6             (_SRFS_ADDR(1) + 0x10F0)
#define _IPC6CLR          (_SRFS_ADDR(1) + 0x10F4)
#define _IPC6SET          (_SRFS_ADDR(1) + 0x10F8)
#define _IPC6INV          (_SRFS_ADDR(1) + 0x10FC)
#define _IPC7             (_SRFS_ADDR(1) + 0x1100)
#define _IPC7CLR          (_SRFS_ADDR(1) + 0x1104)
#define _IPC7SET          (_SRFS_ADDR(1) + 0x1108)
#define _IPC7INV          (_SRFS_ADDR(1) + 0x110C)
#define _IPC8             (_SRFS_ADDR(1) + 0x1110)
#define _IPC8CLR          (_SRFS_ADDR(1) + 0x1114)
#define _IPC8SET          (_SRFS_ADDR(1) + 0x1118)
#define _IPC8INV          (_SRFS_ADDR(1) + 0x111C)
#define _IPC9             (_SRFS_ADDR(1) + 0x1120)
#define _IPC9CLR          (_SRFS_ADDR(1) + 0x1124)
#define _IPC9SET          (_SRFS_ADDR(1) + 0x1128)
#define _IPC9INV          (_SRFS_ADDR(1) + 0x112C)
#define _IPC10            (_SRFS_ADDR(1) + 0x1130)
#define _IPC10CLR         (_SRFS_ADDR(1) + 0x1134)
#define _IPC10SET         (_SRFS_ADDR(1) + 0x1138)
#define _IPC10INV         (_SRFS_ADDR(1) + 0x113C)
#define _IPC11            (_SRFS_ADDR(1) + 0x1140)
#define _IPC11CLR         (_SRFS_ADDR(1) + 0x1144)
#define _IPC11SET         (_SRFS_ADDR(1) + 0x1148)
#define _IPC11INV         (_SRFS_ADDR(1) + 0x114C)
#define _IPC12            (_SRFS_ADDR(1) + 0x1150)
#define _IPC12CLR         (_SRFS_ADDR(1) + 0x1154)
#define _IPC12SET         (_SRFS_ADDR(1) + 0x1158)
#define _IPC12INV         (_SRFS_ADDR(1) + 0x115C)
#define _BMXCON           (_SRFS_ADDR(1) + 0x2000)
#define _BMXCONCLR        (_SRFS_ADDR(1) + 0x2004)
#define _BMXCONSET        (_SRFS_ADDR(1) + 0x2008)
#define _BMXCONINV        (_SRFS_ADDR(1) + 0x200C)
#define _BMXDKPBA         (_SRFS_ADDR(1) + 0x2010)
#define _BMXDKPBACLR      (_SRFS_ADDR(1) + 0x2014)
#define _BMXDKPBASET      (_SRFS_ADDR(1) + 0x2018)
#define _BMXDKPBAINV      (_SRFS_ADDR(1) + 0x201C)
#define _BMXDUDBA         (_SRFS_ADDR(1) + 0x2020)
#define _BMXDUDBACLR      (_SRFS_ADDR(1) + 0x2024)
#define _BMXDUDBASET      (_SRFS_ADDR(1) + 0x2028)
#define _BMXDUDBAINV      (_SRFS_ADDR(1) + 0x202C)
#define _BMXDUPBA         (_SRFS_ADDR(1) + 0x2030)
#define _BMXDUPBACLR      (_SRFS_ADDR(1) + 0x2034)
#define _BMXDUPBASET      (_SRFS_ADDR(1) + 0x2038)
#define _BMXDUPBAINV      (_SRFS_ADDR(1) + 0x203C)
#define _BMXDRMSZ         (_SRFS_ADDR(1) + 0x2040)
#define _BMXPUPBA         (_SRFS_ADDR(1) + 0x2050)
#define _BMXPUPBACLR      (_SRFS_ADDR(1) + 0x2054)
#define _BMXPUPBASET      (_SRFS_ADDR(1) + 0x2058)
#define _BMXPUPBAINV      (_SRFS_ADDR(1) + 0x205C)
#define _BMXPFMSZ         (_SRFS_ADDR(1) + 0x2060)
#define _BMXBOOTSZ        (_SRFS_ADDR(1) + 0x2070)
#define _DMACON           (_SRFS_ADDR(1) + 0x3000)
#define _DMACONCLR        (_SRFS_ADDR(1) + 0x3004)
#define _DMACONSET        (_SRFS_ADDR(1) + 0x3008)
#define _DMACONINV        (_SRFS_ADDR(1) + 0x300C)
#define _DMASTAT          (_SRFS_ADDR(1) + 0x3010)
#define _DMASTATCLR       (_SRFS_ADDR(1) + 0x3014)
#define _DMASTATSET       (_SRFS_ADDR(1) + 0x3018)
#define _DMASTATINV       (_SRFS_ADDR(1) + 0x301C)
#define _DMAADDR          (_SRFS_ADDR(1) + 0x3020)
#define _DMAADDRCLR       (_SRFS_ADDR(1) + 0x3024)
#define _DMAADDRSET       (_SRFS_ADDR(1) + 0x3028)
#define _DMAADDRINV       (_SRFS_ADDR(1) + 0x302C)
#define _DCRCCON          (_SRFS_ADDR(1) + 0x3030)
#define _DCRCCONCLR       (_SRFS_ADDR(1) + 0x3034)
#define _DCRCCONSET       (_SRFS_ADDR(1) + 0x3038)
#define _DCRCCONINV       (_SRFS_ADDR(1) + 0x303C)
#define _DCRCDATA         (_SRFS_ADDR(1) + 0x3040)
#define _DCRCDATACLR      (_SRFS_ADDR(1) + 0x3044)
#define _DCRCDATASET      (_SRFS_ADDR(1) + 0x3048)
#define _DCRCDATAINV      (_SRFS_ADDR(1) + 0x304C)
#define _DCRCXOR          (_SRFS_ADDR(1) + 0x3050)
#define _DCRCXORCLR       (_SRFS_ADDR(1) + 0x3054)
#define _DCRCXORSET       (_SRFS_ADDR(1) + 0x3058)
#define _DCRCXORINV       (_SRFS_ADDR(1) + 0x305C)
#define _DCH0CON          (_SRFS_ADDR(1) + 0x3060)
#define _DCH0CONCLR       (_SRFS_ADDR(1) + 0x3064)
#define _DCH0CONSET       (_SRFS_ADDR(1) + 0x3068)
#define _DCH0CONINV       (_SRFS_ADDR(1) + 0x306C)
#define _DCH0ECON         (_SRFS_ADDR(1) + 0x3070)
#define _DCH0ECONCLR      (_SRFS_ADDR(1) + 0x3074)
#define _DCH0ECONSET      (_SRFS_ADDR(1) + 0x3078)
#define _DCH0ECONINV      (_SRFS_ADDR(1) + 0x307C)
#define _DCH0INT          (_SRFS_ADDR(1) + 0x3080)
#define _DCH0INTCLR       (_SRFS_ADDR(1) + 0x3084)
#define _DCH0INTSET       (_SRFS_ADDR(1) + 0x3088)
#define _DCH0INTINV       (_SRFS_ADDR(1) + 0x308C)
#define _DCH0SSA          (_SRFS_ADDR(1) + 0x3090)
#define _DCH0SSACLR       (_SRFS_ADDR(1) + 0x3094)
#define _DCH0SSASET       (_SRFS_ADDR(1) + 0x3098)
#define _DCH0SSAINV       (_SRFS_ADDR(1) + 0x309C)
#define _DCH0DSA          (_SRFS_ADDR(1) + 0x30A0)
#define _DCH0DSACLR       (_SRFS_ADDR(1) + 0x30A4)
#define _DCH0DSASET       (_SRFS_ADDR(1) + 0x30A8)
#define _DCH0DSAINV       (_SRFS_ADDR(1) + 0x30AC)
#define _DCH0SSIZ         (_SRFS_ADDR(1) + 0x30B0)
#define _DCH0SSIZCLR      (_SRFS_ADDR(1) + 0x30B4)
#define _DCH0SSIZSET      (_SRFS_ADDR(1) + 0x30B8)
#define _DCH0SSIZINV      (_SRFS_ADDR(1) + 0x30BC)
#define _DCH0DSIZ         (_SRFS_ADDR(1) + 0x30C0)
#define _DCH0DSIZCLR      (_SRFS_ADDR(1) + 0x30C4)
#define _DCH0DSIZSET      (_SRFS_ADDR(1) + 0x30C8)
#define _DCH0DSIZINV      (_SRFS_ADDR(1) + 0x30CC)
#define _DCH0SPTR         (_SRFS_ADDR(1) + 0x30D0)
#define _DCH0SPTRCLR      (_SRFS_ADDR(1) + 0x30D4)
#define _DCH0SPTRSET      (_SRFS_ADDR(1) + 0x30D8)
#define _DCH0SPTRINV      (_SRFS_ADDR(1) + 0x30DC)
#define _DCH0DPTR         (_SRFS_ADDR(1) + 0x30E0)
#define _DCH0DPTRCLR      (_SRFS_ADDR(1) + 0x30E4)
#define _DCH0DPTRSET      (_SRFS_ADDR(1) + 0x30E8)
#define _DCH0DPTRINV      (_SRFS_ADDR(1) + 0x30EC)
#define _DCH0CSIZ         (_SRFS_ADDR(1) + 0x30F0)
#define _DCH0CSIZCLR      (_SRFS_ADDR(1) + 0x30F4)
#define _DCH0CSIZSET      (_SRFS_ADDR(1) + 0x30F8)
#define _DCH0CSIZINV      (_SRFS_ADDR(1) + 0x30FC)
#define _DCH0CPTR         (_SRFS_ADDR(1) + 0x3100)
#define _DCH0CPTRCLR      (_SRFS_ADDR(1) + 0x3104)
#define _DCH0CPTRSET      (_SRFS_ADDR(1) + 0x3108)
#define _DCH0CPTRINV      (_SRFS_ADDR(1) + 0x310C)
#define _DCH0DAT          (_SRFS_ADDR(1) + 0x3110)
#define _DCH0DATCLR       (_SRFS_ADDR(1) + 0x3114)
#define _DCH0DATSET       (_SRFS_ADDR(1) + 0x3118)
#define _DCH0DATINV       (_SRFS_ADDR(1) + 0x311C)
#define _DCH1CON          (_SRFS_ADDR(1) + 0x3120)
#define _DCH1CONCLR       (_SRFS_ADDR(1) + 0x3124)
#define _DCH1CONSET       (_SRFS_ADDR(1) + 0x3128)
#define _DCH1CONINV       (_SRFS_ADDR(1) + 0x312C)
#define _DCH1ECON         (_SRFS_ADDR(1) + 0x3130)
#define _DCH1ECONCLR      (_SRFS_ADDR(1) + 0x3134)
#define _DCH1ECONSET      (_SRFS_ADDR(1) + 0x3138)
#define _DCH1ECONINV      (_SRFS_ADDR(1) + 0x313C)
#define _DCH1INT          (_SRFS_ADDR(1) + 0x3140)
#define _DCH1INTCLR       (_SRFS_ADDR(1) + 0x3144)
#define _DCH1INTSET       (_SRFS_ADDR(1) + 0x3148)
#define _DCH1INTINV       (_SRFS_ADDR(1) + 0x314C)
#define _DCH1SSA          (_SRFS_ADDR(1) + 0x3150)
#define _DCH1SSACLR       (_SRFS_ADDR(1) + 0x3154)
#define _DCH1SSASET       (_SRFS_ADDR(1) + 0x3158)
#define _DCH1SSAINV       (_SRFS_ADDR(1) + 0x315C)
#define _DCH1DSA          (_SRFS_ADDR(1) + 0x3160)
#define _DCH1DSACLR       (_SRFS_ADDR(1) + 0x3164)
#define _DCH1DSASET       (_SRFS_ADDR(1) + 0x3168)
#define _DCH1DSAINV       (_SRFS_ADDR(1) + 0x316C)
#define _DCH1SSIZ         (_SRFS_ADDR(1) + 0x3170)
#define _DCH1SSIZCLR      (_SRFS_ADDR(1) + 0x3174)
#define _DCH1SSIZSET      (_SRFS_ADDR(1) + 0x3178)
#define _DCH1SSIZINV      (_SRFS_ADDR(1) + 0x317C)
#define _DCH1DSIZ         (_SRFS_ADDR(1) + 0x3180)
#define _DCH1DSIZCLR      (_SRFS_ADDR(1) + 0x3184)
#define _DCH1DSIZSET      (_SRFS_ADDR(1) + 0x3188)
#define _DCH1DSIZINV      (_SRFS_ADDR(1) + 0x318C)
#define _DCH1SPTR         (_SRFS_ADDR(1) + 0x3190)
#define _DCH1SPTRCLR      (_SRFS_ADDR(1) + 0x3194)
#define _DCH1SPTRSET      (_SRFS_ADDR(1) + 0x3198)
#define _DCH1SPTRINV      (_SRFS_ADDR(1) + 0x319C)
#define _DCH1DPTR         (_SRFS_ADDR(1) + 0x31A0)
#define _DCH1DPTRCLR      (_SRFS_ADDR(1) + 0x31A4)
#define _DCH1DPTRSET      (_SRFS_ADDR(1) + 0x31A8)
#define _DCH1DPTRINV      (_SRFS_ADDR(1) + 0x31AC)
#define _DCH1CSIZ         (_SRFS_ADDR(1) + 0x31B0)
#define _DCH1CSIZCLR      (_SRFS_ADDR(1) + 0x31B4)
#define _DCH1CSIZSET      (_SRFS_ADDR(1) + 0x31B8)
#define _DCH1CSIZINV      (_SRFS_ADDR(1) + 0x31BC)
#define _DCH1CPTR         (_SRFS_ADDR(1) + 0x31C0)
#define _DCH1CPTRCLR      (_SRFS_ADDR(1) + 0x31C4)
#define _DCH1CPTRSET      (_SRFS_ADDR(1) + 0x31C8)
#define _DCH1CPTRINV      (_SRFS_ADDR(1) + 0x31CC)
#define _DCH1DAT          (_SRFS_ADDR(1) + 0x31D0)
#define _DCH1DATCLR       (_SRFS_ADDR(1) + 0x31D4)
#define _DCH1DATSET       (_SRFS_ADDR(1) + 0x31D8)
#define _DCH1DATINV       (_SRFS_ADDR(1) + 0x31DC)
#define _DCH2CON          (_SRFS_ADDR(1) + 0x31E0)
#define _DCH2CONCLR       (_SRFS_ADDR(1) + 0x31E4)
#define _DCH2CONSET       (_SRFS_ADDR(1) + 0x31E8)
#define _DCH2CONINV       (_SRFS_ADDR(1) + 0x31EC)
#define _DCH2ECON         (_SRFS_ADDR(1) + 0x31F0)
#define _DCH2ECONCLR      (_SRFS_ADDR(1) + 0x31F4)
#define _DCH2ECONSET      (_SRFS_ADDR(1) + 0x31F8)
#define _DCH2ECONINV      (_SRFS_ADDR(1) + 0x31FC)
#define _DCH2INT          (_SRFS_ADDR(1) + 0x3200)
#define _DCH2INTCLR       (_SRFS_ADDR(1) + 0x3204)
#define _DCH2INTSET       (_SRFS_ADDR(1) + 0x3208)
#define _DCH2INTINV       (_SRFS_ADDR(1) + 0x320C)
#define _DCH2SSA          (_SRFS_ADDR(1) + 0x3210)
#define _DCH2SSACLR       (_SRFS_ADDR(1) + 0x3214)
#define _DCH2SSASET       (_SRFS_ADDR(1) + 0x3218)
#define _DCH2SSAINV       (_SRFS_ADDR(1) + 0x321C)
#define _DCH2DSA          (_SRFS_ADDR(1) + 0x3220)
#define _DCH2DSACLR       (_SRFS_ADDR(1) + 0x3224)
#define _DCH2DSASET       (_SRFS_ADDR(1) + 0x3228)
#define _DCH2DSAINV       (_SRFS_ADDR(1) + 0x322C)
#define _DCH2SSIZ         (_SRFS_ADDR(1) + 0x3230)
#define _DCH2SSIZCLR      (_SRFS_ADDR(1) + 0x3234)
#define _DCH2SSIZSET      (_SRFS_ADDR(1) + 0x3238)
#define _DCH2SSIZINV      (_SRFS_ADDR(1) + 0x323C)
#define _DCH2DSIZ         (_SRFS_ADDR(1) + 0x3240)
#define _DCH2DSIZCLR      (_SRFS_ADDR(1) + 0x3244)
#define _DCH2DSIZSET      (_SRFS_ADDR(1) + 0x3248)
#define _DCH2DSIZINV      (_SRFS_ADDR(1) + 0x324C)
#define _DCH2SPTR         (_SRFS_ADDR(1) + 0x3250)
#define _DCH2SPTRCLR      (_SRFS_ADDR(1) + 0x3254)
#define _DCH2SPTRSET      (_SRFS_ADDR(1) + 0x3258)
#define _DCH2SPTRINV      (_SRFS_ADDR(1) + 0x325C)
#define _DCH2DPTR         (_SRFS_ADDR(1) + 0x3260)
#define _DCH2DPTRCLR      (_SRFS_ADDR(1) + 0x3264)
#define _DCH2DPTRSET      (_SRFS_ADDR(1) + 0x3268)
#define _DCH2DPTRINV      (_SRFS_ADDR(1) + 0x326C)
#define _DCH2CSIZ         (_SRFS_ADDR(1) + 0x3270)
#define _DCH2CSIZCLR      (_SRFS_ADDR(1) + 0x3274)
#define _DCH2CSIZSET      (_SRFS_ADDR(1) + 0x3278)
#define _DCH2CSIZINV      (_SRFS_ADDR(1) + 0x327C)
#define _DCH2CPTR         (_SRFS_ADDR(1) + 0x3280)
#define _DCH2CPTRCLR      (_SRFS_ADDR(1) + 0x3284)
#define _DCH2CPTRSET      (_SRFS_ADDR(1) + 0x3288)
#define _DCH2CPTRINV      (_SRFS_ADDR(1) + 0x328C)
#define _DCH2DAT          (_SRFS_ADDR(1) + 0x3290)
#define _DCH2DATCLR       (_SRFS_ADDR(1) + 0x3294)
#define _DCH2DATSET       (_SRFS_ADDR(1) + 0x3298)
#define _DCH2DATINV       (_SRFS_ADDR(1) + 0x329C)
#define _DCH3CON          (_SRFS_ADDR(1) + 0x32A0)
#define _DCH3CONCLR       (_SRFS_ADDR(1) + 0x32A4)
#define _DCH3CONSET       (_SRFS_ADDR(1) + 0x32A8)
#define _DCH3CONINV       (_SRFS_ADDR(1) + 0x32AC)
#define _DCH3ECON         (_SRFS_ADDR(1) + 0x32B0)
#define _DCH3ECONCLR      (_SRFS_ADDR(1) + 0x32B4)
#define _DCH3ECONSET      (_SRFS_ADDR(1) + 0x32B8)
#define _DCH3ECONINV      (_SRFS_ADDR(1) + 0x32BC)
#define _DCH3INT          (_SRFS_ADDR(1) + 0x32C0)
#define _DCH3INTCLR       (_SRFS_ADDR(1) + 0x32C4)
#define _DCH3INTSET       (_SRFS_ADDR(1) + 0x32C8)
#define _DCH3INTINV       (_SRFS_ADDR(1) + 0x32CC)
#define _DCH3SSA          (_SRFS_ADDR(1) + 0x32D0)
#define _DCH3SSACLR       (_SRFS_ADDR(1) + 0x32D4)
#define _DCH3SSASET       (_SRFS_ADDR(1) + 0x32D8)
#define _DCH3SSAINV       (_SRFS_ADDR(1) + 0x32DC)
#define _DCH3DSA          (_SRFS_ADDR(1) + 0x32E0)
#define _DCH3DSACLR       (_SRFS_ADDR(1) + 0x32E4)
#define _DCH3DSASET       (_SRFS_ADDR(1) + 0x32E8)
#define _DCH3DSAINV       (_SRFS_ADDR(1) + 0x32EC)
#define _DCH3SSIZ         (_SRFS_ADDR(1) + 0x32F0)
#define _DCH3SSIZCLR      (_SRFS_ADDR(1) + 0x32F4)
#define _DCH3SSIZSET      (_SRFS_ADDR(1) + 0x32F8)
#define _DCH3SSIZINV      (_SRFS_ADDR(1) + 0x32FC)
#define _DCH3DSIZ         (_SRFS_ADDR(1) + 0x3300)
#define _DCH3DSIZCLR      (_SRFS_ADDR(1) + 0x3304)
#define _DCH3DSIZSET      (_SRFS_ADDR(1) + 0x3308)
#define _DCH3DSIZINV      (_SRFS_ADDR(1) + 0x330C)
#define _DCH3SPTR         (_SRFS_ADDR(1) + 0x3310)
#define _DCH3SPTRCLR      (_SRFS_ADDR(1) + 0x3314)
#define _DCH3SPTRSET      (_SRFS_ADDR(1) + 0x3318)
#define _DCH3SPTRINV      (_SRFS_ADDR(1) + 0x331C)
#define _DCH3DPTR         (_SRFS_ADDR(1) + 0x3320)
#define _DCH3DPTRCLR      (_SRFS_ADDR(1) + 0x3324)
#define _DCH3DPTRSET      (_SRFS_ADDR(1) + 0x3328)
#define _DCH3DPTRINV      (_SRFS_ADDR(1) + 0x332C)
#define _DCH3CSIZ         (_SRFS_ADDR(1) + 0x3330)
#define _DCH3CSIZCLR      (_SRFS_ADDR(1) + 0x3334)
#define _DCH3CSIZSET      (_SRFS_ADDR(1) + 0x3338)
#define _DCH3CSIZINV      (_SRFS_ADDR(1) + 0x333C)
#define _DCH3CPTR         (_SRFS_ADDR(1) + 0x3340)
#define _DCH3CPTRCLR      (_SRFS_ADDR(1) + 0x3344)
#define _DCH3CPTRSET      (_SRFS_ADDR(1) + 0x3348)
#define _DCH3CPTRINV      (_SRFS_ADDR(1) + 0x334C)
#define _DCH3DAT          (_SRFS_ADDR(1) + 0x3350)
#define _DCH3DATCLR       (_SRFS_ADDR(1) + 0x3354)
#define _DCH3DATSET       (_SRFS_ADDR(1) + 0x3358)
#define _DCH3DATINV       (_SRFS_ADDR(1) + 0x335C)
#define _DCH4CON          (_SRFS_ADDR(1) + 0x3360)
#define _DCH4CONCLR       (_SRFS_ADDR(1) + 0x3364)
#define _DCH4CONSET       (_SRFS_ADDR(1) + 0x3368)
#define _DCH4CONINV       (_SRFS_ADDR(1) + 0x336C)
#define _DCH4ECON         (_SRFS_ADDR(1) + 0x3370)
#define _DCH4ECONCLR      (_SRFS_ADDR(1) + 0x3374)
#define _DCH4ECONSET      (_SRFS_ADDR(1) + 0x3378)
#define _DCH4ECONINV      (_SRFS_ADDR(1) + 0x337C)
#define _DCH4INT          (_SRFS_ADDR(1) + 0x3380)
#define _DCH4INTCLR       (_SRFS_ADDR(1) + 0x3384)
#define _DCH4INTSET       (_SRFS_ADDR(1) + 0x3388)
#define _DCH4INTINV       (_SRFS_ADDR(1) + 0x338C)
#define _DCH4SSA          (_SRFS_ADDR(1) + 0x3390)
#define _DCH4SSACLR       (_SRFS_ADDR(1) + 0x3394)
#define _DCH4SSASET       (_SRFS_ADDR(1) + 0x3398)
#define _DCH4SSAINV       (_SRFS_ADDR(1) + 0x339C)
#define _DCH4DSA          (_SRFS_ADDR(1) + 0x33A0)
#define _DCH4DSACLR       (_SRFS_ADDR(1) + 0x33A4)
#define _DCH4DSASET       (_SRFS_ADDR(1) + 0x33A8)
#define _DCH4DSAINV       (_SRFS_ADDR(1) + 0x33AC)
#define _DCH4SSIZ         (_SRFS_ADDR(1) + 0x33B0)
#define _DCH4SSIZCLR      (_SRFS_ADDR(1) + 0x33B4)
#define _DCH4SSIZSET      (_SRFS_ADDR(1) + 0x33B8)
#define _DCH4SSIZINV      (_SRFS_ADDR(1) + 0x33BC)
#define _DCH4DSIZ         (_SRFS_ADDR(1) + 0x33C0)
#define _DCH4DSIZCLR      (_SRFS_ADDR(1) + 0x33C4)
#define _DCH4DSIZSET      (_SRFS_ADDR(1) + 0x33C8)
#define _DCH4DSIZINV      (_SRFS_ADDR(1) + 0x33CC)
#define _DCH4SPTR         (_SRFS_ADDR(1) + 0x33D0)
#define _DCH4SPTRCLR      (_SRFS_ADDR(1) + 0x33D4)
#define _DCH4SPTRSET      (_SRFS_ADDR(1) + 0x33D8)
#define _DCH4SPTRINV      (_SRFS_ADDR(1) + 0x33DC)
#define _DCH4DPTR         (_SRFS_ADDR(1) + 0x33E0)
#define _DCH4DPTRCLR      (_SRFS_ADDR(1) + 0x33E4)
#define _DCH4DPTRSET      (_SRFS_ADDR(1) + 0x33E8)
#define _DCH4DPTRINV      (_SRFS_ADDR(1) + 0x33EC)
#define _DCH4CSIZ         (_SRFS_ADDR(1) + 0x33F0)
#define _DCH4CSIZCLR      (_SRFS_ADDR(1) + 0x33F4)
#define _DCH4CSIZSET      (_SRFS_ADDR(1) + 0x33F8)
#define _DCH4CSIZINV      (_SRFS_ADDR(1) + 0x33FC)
#define _DCH4CPTR         (_SRFS_ADDR(1) + 0x3400)
#define _DCH4CPTRCLR      (_SRFS_ADDR(1) + 0x3404)
#define _DCH4CPTRSET      (_SRFS_ADDR(1) + 0x3408)
#define _DCH4CPTRINV      (_SRFS_ADDR(1) + 0x340C)
#define _DCH4DAT          (_SRFS_ADDR(1) + 0x3410)
#define _DCH4DATCLR       (_SRFS_ADDR(1) + 0x3414)
#define _DCH4DATSET       (_SRFS_ADDR(1) + 0x3418)
#define _DCH4DATINV       (_SRFS_ADDR(1) + 0x341C)
#define _DCH5CON          (_SRFS_ADDR(1) + 0x3420)
#define _DCH5CONCLR       (_SRFS_ADDR(1) + 0x3424)
#define _DCH5CONSET       (_SRFS_ADDR(1) + 0x3428)
#define _DCH5CONINV       (_SRFS_ADDR(1) + 0x342C)
#define _DCH5ECON         (_SRFS_ADDR(1) + 0x3430)
#define _DCH5ECONCLR      (_SRFS_ADDR(1) + 0x3434)
#define _DCH5ECONSET      (_SRFS_ADDR(1) + 0x3438)
#define _DCH5ECONINV      (_SRFS_ADDR(1) + 0x343C)
#define _DCH5INT          (_SRFS_ADDR(1) + 0x3440)
#define _DCH5INTCLR       (_SRFS_ADDR(1) + 0x3444)
#define _DCH5INTSET       (_SRFS_ADDR(1) + 0x3448)
#define _DCH5INTINV       (_SRFS_ADDR(1) + 0x344C)
#define _DCH5SSA          (_SRFS_ADDR(1) + 0x3450)
#define _DCH5SSACLR       (_SRFS_ADDR(1) + 0x3454)
#define _DCH5SSASET       (_SRFS_ADDR(1) + 0x3458)
#define _DCH5SSAINV       (_SRFS_ADDR(1) + 0x345C)
#define _DCH5DSA          (_SRFS_ADDR(1) + 0x3460)
#define _DCH5DSACLR       (_SRFS_ADDR(1) + 0x3464)
#define _DCH5DSASET       (_SRFS_ADDR(1) + 0x3468)
#define _DCH5DSAINV       (_SRFS_ADDR(1) + 0x346C)
#define _DCH5SSIZ         (_SRFS_ADDR(1) + 0x3470)
#define _DCH5SSIZCLR      (_SRFS_ADDR(1) + 0x3474)
#define _DCH5SSIZSET      (_SRFS_ADDR(1) + 0x3478)
#define _DCH5SSIZINV      (_SRFS_ADDR(1) + 0x347C)
#define _DCH5DSIZ         (_SRFS_ADDR(1) + 0x3480)
#define _DCH5DSIZCLR      (_SRFS_ADDR(1) + 0x3484)
#define _DCH5DSIZSET      (_SRFS_ADDR(1) + 0x3488)
#define _DCH5DSIZINV      (_SRFS_ADDR(1) + 0x348C)
#define _DCH5SPTR         (_SRFS_ADDR(1) + 0x3490)
#define _DCH5SPTRCLR      (_SRFS_ADDR(1) + 0x3494)
#define _DCH5SPTRSET      (_SRFS_ADDR(1) + 0x3498)
#define _DCH5SPTRINV      (_SRFS_ADDR(1) + 0x349C)
#define _DCH5DPTR         (_SRFS_ADDR(1) + 0x34A0)
#define _DCH5DPTRCLR      (_SRFS_ADDR(1) + 0x34A4)
#define _DCH5DPTRSET      (_SRFS_ADDR(1) + 0x34A8)
#define _DCH5DPTRINV      (_SRFS_ADDR(1) + 0x34AC)
#define _DCH5CSIZ         (_SRFS_ADDR(1) + 0x34B0)
#define _DCH5CSIZCLR      (_SRFS_ADDR(1) + 0x34B4)
#define _DCH5CSIZSET      (_SRFS_ADDR(1) + 0x34B8)
#define _DCH5CSIZINV      (_SRFS_ADDR(1) + 0x34BC)
#define _DCH5CPTR         (_SRFS_ADDR(1) + 0x34C0)
#define _DCH5CPTRCLR      (_SRFS_ADDR(1) + 0x34C4)
#define _DCH5CPTRSET      (_SRFS_ADDR(1) + 0x34C8)
#define _DCH5CPTRINV      (_SRFS_ADDR(1) + 0x34CC)
#define _DCH5DAT          (_SRFS_ADDR(1) + 0x34D0)
#define _DCH5DATCLR       (_SRFS_ADDR(1) + 0x34D4)
#define _DCH5DATSET       (_SRFS_ADDR(1) + 0x34D8)
#define _DCH5DATINV       (_SRFS_ADDR(1) + 0x34DC)
#define _DCH6CON          (_SRFS_ADDR(1) + 0x34E0)
#define _DCH6CONCLR       (_SRFS_ADDR(1) + 0x34E4)
#define _DCH6CONSET       (_SRFS_ADDR(1) + 0x34E8)
#define _DCH6CONINV       (_SRFS_ADDR(1) + 0x34EC)
#define _DCH6ECON         (_SRFS_ADDR(1) + 0x34F0)
#define _DCH6ECONCLR      (_SRFS_ADDR(1) + 0x34F4)
#define _DCH6ECONSET      (_SRFS_ADDR(1) + 0x34F8)
#define _DCH6ECONINV      (_SRFS_ADDR(1) + 0x34FC)
#define _DCH6INT          (_SRFS_ADDR(1) + 0x3500)
#define _DCH6INTCLR       (_SRFS_ADDR(1) + 0x3504)
#define _DCH6INTSET       (_SRFS_ADDR(1) + 0x3508)
#define _DCH6INTINV       (_SRFS_ADDR(1) + 0x350C)
#define _DCH6SSA          (_SRFS_ADDR(1) + 0x3510)
#define _DCH6SSACLR       (_SRFS_ADDR(1) + 0x3514)
#define _DCH6SSASET       (_SRFS_ADDR(1) + 0x3518)
#define _DCH6SSAINV       (_SRFS_ADDR(1) + 0x351C)
#define _DCH6DSA          (_SRFS_ADDR(1) + 0x3520)
#define _DCH6DSACLR       (_SRFS_ADDR(1) + 0x3524)
#define _DCH6DSASET       (_SRFS_ADDR(1) + 0x3528)
#define _DCH6DSAINV       (_SRFS_ADDR(1) + 0x352C)
#define _DCH6SSIZ         (_SRFS_ADDR(1) + 0x3530)
#define _DCH6SSIZCLR      (_SRFS_ADDR(1) + 0x3534)
#define _DCH6SSIZSET      (_SRFS_ADDR(1) + 0x3538)
#define _DCH6SSIZINV      (_SRFS_ADDR(1) + 0x353C)
#define _DCH6DSIZ         (_SRFS_ADDR(1) + 0x3540)
#define _DCH6DSIZCLR      (_SRFS_ADDR(1) + 0x3544)
#define _DCH6DSIZSET      (_SRFS_ADDR(1) + 0x3548)
#define _DCH6DSIZINV      (_SRFS_ADDR(1) + 0x354C)
#define _DCH6SPTR         (_SRFS_ADDR(1) + 0x3550)
#define _DCH6SPTRCLR      (_SRFS_ADDR(1) + 0x3554)
#define _DCH6SPTRSET      (_SRFS_ADDR(1) + 0x3558)
#define _DCH6SPTRINV      (_SRFS_ADDR(1) + 0x355C)
#define _DCH6DPTR         (_SRFS_ADDR(1) + 0x3560)
#define _DCH6DPTRCLR      (_SRFS_ADDR(1) + 0x3564)
#define _DCH6DPTRSET      (_SRFS_ADDR(1) + 0x3568)
#define _DCH6DPTRINV      (_SRFS_ADDR(1) + 0x356C)
#define _DCH6CSIZ         (_SRFS_ADDR(1) + 0x3570)
#define _DCH6CSIZCLR      (_SRFS_ADDR(1) + 0x3574)
#define _DCH6CSIZSET      (_SRFS_ADDR(1) + 0x3578)
#define _DCH6CSIZINV      (_SRFS_ADDR(1) + 0x357C)
#define _DCH6CPTR         (_SRFS_ADDR(1) + 0x3580)
#define _DCH6CPTRCLR      (_SRFS_ADDR(1) + 0x3584)
#define _DCH6CPTRSET      (_SRFS_ADDR(1) + 0x3588)
#define _DCH6CPTRINV      (_SRFS_ADDR(1) + 0x358C)
#define _DCH6DAT          (_SRFS_ADDR(1) + 0x3590)
#define _DCH6DATCLR       (_SRFS_ADDR(1) + 0x3594)
#define _DCH6DATSET       (_SRFS_ADDR(1) + 0x3598)
#define _DCH6DATINV       (_SRFS_ADDR(1) + 0x359C)
#define _DCH7CON          (_SRFS_ADDR(1) + 0x35A0)
#define _DCH7CONCLR       (_SRFS_ADDR(1) + 0x35A4)
#define _DCH7CONSET       (_SRFS_ADDR(1) + 0x35A8)
#define _DCH7CONINV       (_SRFS_ADDR(1) + 0x35AC)
#define _DCH7ECON         (_SRFS_ADDR(1) + 0x35B0)
#define _DCH7ECONCLR      (_SRFS_ADDR(1) + 0x35B4)
#define _DCH7ECONSET      (_SRFS_ADDR(1) + 0x35B8)
#define _DCH7ECONINV      (_SRFS_ADDR(1) + 0x35BC)
#define _DCH7INT          (_SRFS_ADDR(1) + 0x35C0)
#define _DCH7INTCLR       (_SRFS_ADDR(1) + 0x35C4)
#define _DCH7INTSET       (_SRFS_ADDR(1) + 0x35C8)
#define _DCH7INTINV       (_SRFS_ADDR(1) + 0x35CC)
#define _DCH7SSA          (_SRFS_ADDR(1) + 0x35D0)
#define _DCH7SSACLR       (_SRFS_ADDR(1) + 0x35D4)
#define _DCH7SSASET       (_SRFS_ADDR(1) + 0x35D8)
#define _DCH7SSAINV       (_SRFS_ADDR(1) + 0x35DC)
#define _DCH7DSA          (_SRFS_ADDR(1) + 0x35E0)
#define _DCH7DSACLR       (_SRFS_ADDR(1) + 0x35E4)
#define _DCH7DSASET       (_SRFS_ADDR(1) + 0x35E8)
#define _DCH7DSAINV       (_SRFS_ADDR(1) + 0x35EC)
#define _DCH7SSIZ         (_SRFS_ADDR(1) + 0x35F0)
#define _DCH7SSIZCLR      (_SRFS_ADDR(1) + 0x35F4)
#define _DCH7SSIZSET      (_SRFS_ADDR(1) + 0x35F8)
#define _DCH7SSIZINV      (_SRFS_ADDR(1) + 0x35FC)
#define _DCH7DSIZ         (_SRFS_ADDR(1) + 0x3600)
#define _DCH7DSIZCLR      (_SRFS_ADDR(1) + 0x3604)
#define _DCH7DSIZSET      (_SRFS_ADDR(1) + 0x3608)
#define _DCH7DSIZINV      (_SRFS_ADDR(1) + 0x360C)
#define _DCH7SPTR         (_SRFS_ADDR(1) + 0x3610)
#define _DCH7SPTRCLR      (_SRFS_ADDR(1) + 0x3614)
#define _DCH7SPTRSET      (_SRFS_ADDR(1) + 0x3618)
#define _DCH7SPTRINV      (_SRFS_ADDR(1) + 0x361C)
#define _DCH7DPTR         (_SRFS_ADDR(1) + 0x3620)
#define _DCH7DPTRCLR      (_SRFS_ADDR(1) + 0x3624)
#define _DCH7DPTRSET      (_SRFS_ADDR(1) + 0x3628)
#define _DCH7DPTRINV      (_SRFS_ADDR(1) + 0x362C)
#define _DCH7CSIZ         (_SRFS_ADDR(1) + 0x3630)
#define _DCH7CSIZCLR      (_SRFS_ADDR(1) + 0x3634)
#define _DCH7CSIZSET      (_SRFS_ADDR(1) + 0x3638)
#define _DCH7CSIZINV      (_SRFS_ADDR(1) + 0x363C)
#define _DCH7CPTR         (_SRFS_ADDR(1) + 0x3640)
#define _DCH7CPTRCLR      (_SRFS_ADDR(1) + 0x3644)
#define _DCH7CPTRSET      (_SRFS_ADDR(1) + 0x3648)
#define _DCH7CPTRINV      (_SRFS_ADDR(1) + 0x364C)
#define _DCH7DAT          (_SRFS_ADDR(1) + 0x3650)
#define _DCH7DATCLR       (_SRFS_ADDR(1) + 0x3654)
#define _DCH7DATSET       (_SRFS_ADDR(1) + 0x3658)
#define _DCH7DATINV       (_SRFS_ADDR(1) + 0x365C)
#define _CHECON           (_SRFS_ADDR(1) + 0x4000)
#define _CHECONCLR        (_SRFS_ADDR(1) + 0x4004)
#define _CHECONSET        (_SRFS_ADDR(1) + 0x4008)
#define _CHECONINV        (_SRFS_ADDR(1) + 0x400C)
#define _CHEACC           (_SRFS_ADDR(1) + 0x4010)
#define _CHEACCCLR        (_SRFS_ADDR(1) + 0x4014)
#define _CHEACCSET        (_SRFS_ADDR(1) + 0x4018)
#define _CHEACCINV        (_SRFS_ADDR(1) + 0x401C)
#define _CHETAG           (_SRFS_ADDR(1) + 0x4020)
#define _CHETAGCLR        (_SRFS_ADDR(1) + 0x4024)
#define _CHETAGSET        (_SRFS_ADDR(1) + 0x4028)
#define _CHETAGINV        (_SRFS_ADDR(1) + 0x402C)
#define _CHEMSK           (_SRFS_ADDR(1) + 0x4030)
#define _CHEMSKCLR        (_SRFS_ADDR(1) + 0x4034)
#define _CHEMSKSET        (_SRFS_ADDR(1) + 0x4038)
#define _CHEMSKINV        (_SRFS_ADDR(1) + 0x403C)
#define _CHEW0            (_SRFS_ADDR(1) + 0x4040)
#define _CHEW1            (_SRFS_ADDR(1) + 0x4050)
#define _CHEW2            (_SRFS_ADDR(1) + 0x4060)
#define _CHEW3            (_SRFS_ADDR(1) + 0x4070)
#define _CHELRU           (_SRFS_ADDR(1) + 0x4080)
#define _CHEHIT           (_SRFS_ADDR(1) + 0x4090)
#define _CHEMIS           (_SRFS_ADDR(1) + 0x40A0)
#define _CHEPFABT         (_SRFS_ADDR(1) + 0x40C0)
#define _U1OTGIR          (_SRFS_ADDR(1) + 0x5040)
#define _U1OTGIRCLR       (_SRFS_ADDR(1) + 0x5044)
#define _U1OTGIE          (_SRFS_ADDR(1) + 0x5050)
#define _U1OTGIECLR       (_SRFS_ADDR(1) + 0x5054)
#define _U1OTGIESET       (_SRFS_ADDR(1) + 0x5058)
#define _U1OTGIEINV       (_SRFS_ADDR(1) + 0x505C)
#define _U1OTGSTAT        (_SRFS_ADDR(1) + 0x5060)
#define _U1OTGCON         (_SRFS_ADDR(1) + 0x5070)
#define _U1OTGCONCLR      (_SRFS_ADDR(1) + 0x5074)
#define _U1OTGCONSET      (_SRFS_ADDR(1) + 0x5078)
#define _U1OTGCONINV      (_SRFS_ADDR(1) + 0x507C)
#define _U1PWRC           (_SRFS_ADDR(1) + 0x5080)
#define _U1PWRCCLR        (_SRFS_ADDR(1) + 0x5084)
#define _U1PWRCSET        (_SRFS_ADDR(1) + 0x5088)
#define _U1PWRCINV        (_SRFS_ADDR(1) + 0x508C)
#define _U1IR             (_SRFS_ADDR(1) + 0x5200)
#define _U1IRCLR          (_SRFS_ADDR(1) + 0x5204)
#define _U1IE             (_SRFS_ADDR(1) + 0x5210)
#define _U1IECLR          (_SRFS_ADDR(1) + 0x5214)
#define _U1IESET          (_SRFS_ADDR(1) + 0x5218)
#define _U1IEINV          (_SRFS_ADDR(1) + 0x521C)
#define _U1EIR            (_SRFS_ADDR(1) + 0x5220)
#define _U1EIRCLR         (_SRFS_ADDR(1) + 0x5224)
#define _U1EIE            (_SRFS_ADDR(1) + 0x5230)
#define _U1EIECLR         (_SRFS_ADDR(1) + 0x5234)
#define _U1EIESET         (_SRFS_ADDR(1) + 0x5238)
#define _U1EIEINV         (_SRFS_ADDR(1) + 0x523C)
#define _U1STAT           (_SRFS_ADDR(1) + 0x5240)
#define _U1STATCLR        (_SRFS_ADDR(1) + 0x5244)
#define _U1STATSET        (_SRFS_ADDR(1) + 0x5248)
#define _U1STATINV        (_SRFS_ADDR(1) + 0x524C)
#define _U1CON            (_SRFS_ADDR(1) + 0x5250)
#define _U1CONCLR         (_SRFS_ADDR(1) + 0x5254)
#define _U1CONSET         (_SRFS_ADDR(1) + 0x5258)
#define _U1CONINV         (_SRFS_ADDR(1) + 0x525C)
#define _U1ADDR           (_SRFS_ADDR(1) + 0x5260)
#define _U1ADDRCLR        (_SRFS_ADDR(1) + 0x5264)
#define _U1ADDRSET        (_SRFS_ADDR(1) + 0x5268)
#define _U1ADDRINV        (_SRFS_ADDR(1) + 0x526C)
#define _U1BDTP1          (_SRFS_ADDR(1) + 0x5270)
#define _U1BDTP1CLR       (_SRFS_ADDR(1) + 0x5274)
#define _U1BDTP1SET       (_SRFS_ADDR(1) + 0x5278)
#define _U1BDTP1INV       (_SRFS_ADDR(1) + 0x527C)
#define _U1FRML           (_SRFS_ADDR(1) + 0x5280)
#define _U1FRMLCLR        (_SRFS_ADDR(1) + 0x5284)
#define _U1FRMLSET        (_SRFS_ADDR(1) + 0x5288)
#define _U1FRMLINV        (_SRFS_ADDR(1) + 0x528C)
#define _U1FRMH           (_SRFS_ADDR(1) + 0x5290)
#define _U1FRMHCLR        (_SRFS_ADDR(1) + 0x5294)
#define _U1FRMHSET        (_SRFS_ADDR(1) + 0x5298)
#define _U1FRMHINV        (_SRFS_ADDR(1) + 0x529C)
#define _U1TOK            (_SRFS_ADDR(1) + 0x52A0)
#define _U1TOKCLR         (_SRFS_ADDR(1) + 0x52A4)
#define _U1TOKSET         (_SRFS_ADDR(1) + 0x52A8)
#define _U1TOKINV         (_SRFS_ADDR(1) + 0x52AC)
#define _U1SOF            (_SRFS_ADDR(1) + 0x52B0)
#define _U1SOFCLR         (_SRFS_ADDR(1) + 0x52B4)
#define _U1SOFSET         (_SRFS_ADDR(1) + 0x52B8)
#define _U1SOFINV         (_SRFS_ADDR(1) + 0x52BC)
#define _U1BDTP2          (_SRFS_ADDR(1) + 0x52C0)
#define _U1BDTP2CLR       (_SRFS_ADDR(1) + 0x52C4)
#define _U1BDTP2SET       (_SRFS_ADDR(1) + 0x52C8)
#define _U1BDTP2INV       (_SRFS_ADDR(1) + 0x52CC)
#define _U1BDTP3          (_SRFS_ADDR(1) + 0x52D0)
#define _U1BDTP3CLR       (_SRFS_ADDR(1) + 0x52D4)
#define _U1BDTP3SET       (_SRFS_ADDR(1) + 0x52D8)
#define _U1BDTP3INV       (_SRFS_ADDR(1) + 0x52DC)
#define _U1CNFG1          (_SRFS_ADDR(1) + 0x52E0)
#define _U1CNFG1CLR       (_SRFS_ADDR(1) + 0x52E4)
#define _U1CNFG1SET       (_SRFS_ADDR(1) + 0x52E8)
#define _U1CNFG1INV       (_SRFS_ADDR(1) + 0x52EC)
#define _U1EP0            (_SRFS_ADDR(1) + 0x5300)
#define _U1EP0CLR         (_SRFS_ADDR(1) + 0x5304)
#define _U1EP0SET         (_SRFS_ADDR(1) + 0x5308)
#define _U1EP0INV         (_SRFS_ADDR(1) + 0x530C)
#define _U1EP1            (_SRFS_ADDR(1) + 0x5310)
#define _U1EP1CLR         (_SRFS_ADDR(1) + 0x5314)
#define _U1EP1SET         (_SRFS_ADDR(1) + 0x5318)
#define _U1EP1INV         (_SRFS_ADDR(1) + 0x531C)
#define _U1EP2            (_SRFS_ADDR(1) + 0x5320)
#define _U1EP2CLR         (_SRFS_ADDR(1) + 0x5324)
#define _U1EP2SET         (_SRFS_ADDR(1) + 0x5328)
#define _U1EP2INV         (_SRFS_ADDR(1) + 0x532C)
#define _U1EP3            (_SRFS_ADDR(1) + 0x5330)
#define _U1EP3CLR         (_SRFS_ADDR(1) + 0x5334)
#define _U1EP3SET         (_SRFS_ADDR(1) + 0x5338)
#define _U1EP3INV         (_SRFS_ADDR(1) + 0x533C)
#define _U1EP4            (_SRFS_ADDR(1) + 0x5340)
#define _U1EP4CLR         (_SRFS_ADDR(1) + 0x5344)
#define _U1EP4SET         (_SRFS_ADDR(1) + 0x5348)
#define _U1EP4INV         (_SRFS_ADDR(1) + 0x534C)
#define _U1EP5            (_SRFS_ADDR(1) + 0x5350)
#define _U1EP5CLR         (_SRFS_ADDR(1) + 0x5354)
#define _U1EP5SET         (_SRFS_ADDR(1) + 0x5358)
#define _U1EP5INV         (_SRFS_ADDR(1) + 0x535C)
#define _U1EP6            (_SRFS_ADDR(1) + 0x5360)
#define _U1EP6CLR         (_SRFS_ADDR(1) + 0x5364)
#define _U1EP6SET         (_SRFS_ADDR(1) + 0x5368)
#define _U1EP6INV         (_SRFS_ADDR(1) + 0x536C)
#define _U1EP7            (_SRFS_ADDR(1) + 0x5370)
#define _U1EP7CLR         (_SRFS_ADDR(1) + 0x5374)
#define _U1EP7SET         (_SRFS_ADDR(1) + 0x5378)
#define _U1EP7INV         (_SRFS_ADDR(1) + 0x537C)
#define _U1EP8            (_SRFS_ADDR(1) + 0x5380)
#define _U1EP8CLR         (_SRFS_ADDR(1) + 0x5384)
#define _U1EP8SET         (_SRFS_ADDR(1) + 0x5388)
#define _U1EP8INV         (_SRFS_ADDR(1) + 0x538C)
#define _U1EP9            (_SRFS_ADDR(1) + 0x5390)
#define _U1EP9CLR         (_SRFS_ADDR(1) + 0x5394)
#define _U1EP9SET         (_SRFS_ADDR(1) + 0x5398)
#define _U1EP9INV         (_SRFS_ADDR(1) + 0x539C)
#define _U1EP10           (_SRFS_ADDR(1) + 0x53A0)
#define _U1EP10CLR        (_SRFS_ADDR(1) + 0x53A4)
#define _U1EP10SET        (_SRFS_ADDR(1) + 0x53A8)
#define _U1EP10INV        (_SRFS_ADDR(1) + 0x53AC)
#define _U1EP11           (_SRFS_ADDR(1) + 0x53B0)
#define _U1EP11CLR        (_SRFS_ADDR(1) + 0x53B4)
#define _U1EP11SET        (_SRFS_ADDR(1) + 0x53B8)
#define _U1EP11INV        (_SRFS_ADDR(1) + 0x53BC)
#define _U1EP12           (_SRFS_ADDR(1) + 0x53C0)
#define _U1EP12CLR        (_SRFS_ADDR(1) + 0x53C4)
#define _U1EP12SET        (_SRFS_ADDR(1) + 0x53C8)
#define _U1EP12INV        (_SRFS_ADDR(1) + 0x53CC)
#define _U1EP13           (_SRFS_ADDR(1) + 0x53D0)
#define _U1EP13CLR        (_SRFS_ADDR(1) + 0x53D4)
#define _U1EP13SET        (_SRFS_ADDR(1) + 0x53D8)
#define _U1EP13INV        (_SRFS_ADDR(1) + 0x53DC)
#define _U1EP14           (_SRFS_ADDR(1) + 0x53E0)
#define _U1EP14CLR        (_SRFS_ADDR(1) + 0x53E4)
#define _U1EP14SET        (_SRFS_ADDR(1) + 0x53E8)
#define _U1EP14INV        (_SRFS_ADDR(1) + 0x53EC)
#define _U1EP15           (_SRFS_ADDR(1) + 0x53F0)
#define _U1EP15CLR        (_SRFS_ADDR(1) + 0x53F4)
#define _U1EP15SET        (_SRFS_ADDR(1) + 0x53F8)
#define _U1EP15INV        (_SRFS_ADDR(1) + 0x53FC)
#define _TRISA            (_SRFS_ADDR(1) + 0x6000)
#define _TRISACLR         (_SRFS_ADDR(1) + 0x6004)
#define _TRISASET         (_SRFS_ADDR(1) + 0x6008)
#define _TRISAINV         (_SRFS_ADDR(1) + 0x600C)
#define _PORTA            (_SRFS_ADDR(1) + 0x6010)
#define _PORTACLR         (_SRFS_ADDR(1) + 0x6014)
#define _PORTASET         (_SRFS_ADDR(1) + 0x6018)
#define _PORTAINV         (_SRFS_ADDR(1) + 0x601C)
#define _LATA             (_SRFS_ADDR(1) + 0x6020)
#define _LATACLR          (_SRFS_ADDR(1) + 0x6024)
#define _LATASET          (_SRFS_ADDR(1) + 0x6028)
#define _LATAINV          (_SRFS_ADDR(1) + 0x602C)
#define _ODCA             (_SRFS_ADDR(1) + 0x6030)
#define _ODCACLR          (_SRFS_ADDR(1) + 0x6034)
#define _ODCASET          (_SRFS_ADDR(1) + 0x6038)
#define _ODCAINV          (_SRFS_ADDR(1) + 0x603C)
#define _TRISB            (_SRFS_ADDR(1) + 0x6040)
#define _TRISBCLR         (_SRFS_ADDR(1) + 0x6044)
#define _TRISBSET         (_SRFS_ADDR(1) + 0x6048)
#define _TRISBINV         (_SRFS_ADDR(1) + 0x604C)
#define _PORTB            (_SRFS_ADDR(1) + 0x6050)
#define _PORTBCLR         (_SRFS_ADDR(1) + 0x6054)
#define _PORTBSET         (_SRFS_ADDR(1) + 0x6058)
#define _PORTBINV         (_SRFS_ADDR(1) + 0x605C)
#define _LATB             (_SRFS_ADDR(1) + 0x6060)
#define _LATBCLR          (_SRFS_ADDR(1) + 0x6064)
#define _LATBSET          (_SRFS_ADDR(1) + 0x6068)
#define _LATBINV          (_SRFS_ADDR(1) + 0x606C)
#define _ODCB             (_SRFS_ADDR(1) + 0x6070)
#define _ODCBCLR          (_SRFS_ADDR(1) + 0x6074)
#define _ODCBSET          (_SRFS_ADDR(1) + 0x6078)
#define _ODCBINV          (_SRFS_ADDR(1) + 0x607C)
#define _TRISC            (_SRFS_ADDR(1) + 0x6080)
#define _TRISCCLR         (_SRFS_ADDR(1) + 0x6084)
#define _TRISCSET         (_SRFS_ADDR(1) + 0x6088)
#define _TRISCINV         (_SRFS_ADDR(1) + 0x608C)
#define _PORTC            (_SRFS_ADDR(1) + 0x6090)
#define _PORTCCLR         (_SRFS_ADDR(1) + 0x6094)
#define _PORTCSET         (_SRFS_ADDR(1) + 0x6098)
#define _PORTCINV         (_SRFS_ADDR(1) + 0x609C)
#define _LATC             (_SRFS_ADDR(1) + 0x60A0)
#define _LATCCLR          (_SRFS_ADDR(1) + 0x60A4)
#define _LATCSET          (_SRFS_ADDR(1) + 0x60A8)
#define _LATCINV          (_SRFS_ADDR(1) + 0x60AC)
#define _ODCC             (_SRFS_ADDR(1) + 0x60B0)
#define _ODCCCLR          (_SRFS_ADDR(1) + 0x60B4)
#define _ODCCSET          (_SRFS_ADDR(1) + 0x60B8)
#define _ODCCINV          (_SRFS_ADDR(1) + 0x60BC)
#define _TRISD            (_SRFS_ADDR(1) + 0x60C0)
#define _TRISDCLR         (_SRFS_ADDR(1) + 0x60C4)
#define _TRISDSET         (_SRFS_ADDR(1) + 0x60C8)
#define _TRISDINV         (_SRFS_ADDR(1) + 0x60CC)
#define _PORTD            (_SRFS_ADDR(1) + 0x60D0)
#define _PORTDCLR         (_SRFS_ADDR(1) + 0x60D4)
#define _PORTDSET         (_SRFS_ADDR(1) + 0x60D8)
#define _PORTDINV         (_SRFS_ADDR(1) + 0x60DC)
#define _LATD             (_SRFS_ADDR(1) + 0x60E0)
#define _LATDCLR          (_SRFS_ADDR(1) + 0x60E4)
#define _LATDSET          (_SRFS_ADDR(1) + 0x60E8)
#define _LATDINV          (_SRFS_ADDR(1) + 0x60EC)
#define _ODCD             (_SRFS_ADDR(1) + 0x60F0)
#define _ODCDCLR          (_SRFS_ADDR(1) + 0x60F4)
#define _ODCDSET          (_SRFS_ADDR(1) + 0x60F8)
#define _ODCDINV          (_SRFS_ADDR(1) + 0x60FC)
#define _TRISE            (_SRFS_ADDR(1) + 0x6100)
#define _TRISECLR         (_SRFS_ADDR(1) + 0x6104)
#define _TRISESET         (_SRFS_ADDR(1) + 0x6108)
#define _TRISEINV         (_SRFS_ADDR(1) + 0x610C)
#define _PORTE            (_SRFS_ADDR(1) + 0x6110)
#define _PORTECLR         (_SRFS_ADDR(1) + 0x6114)
#define _PORTESET         (_SRFS_ADDR(1) + 0x6118)
#define _PORTEINV         (_SRFS_ADDR(1) + 0x611C)
#define _LATE             (_SRFS_ADDR(1) + 0x6120)
#define _LATECLR          (_SRFS_ADDR(1) + 0x6124)
#define _LATESET          (_SRFS_ADDR(1) + 0x6128)
#define _LATEINV          (_SRFS_ADDR(1) + 0x612C)
#define _ODCE             (_SRFS_ADDR(1) + 0x6130)
#define _ODCECLR          (_SRFS_ADDR(1) + 0x6134)
#define _ODCESET          (_SRFS_ADDR(1) + 0x6138)
#define _ODCEINV          (_SRFS_ADDR(1) + 0x613C)
#define _TRISF            (_SRFS_ADDR(1) + 0x6140)
#define _TRISFCLR         (_SRFS_ADDR(1) + 0x6144)
#define _TRISFSET         (_SRFS_ADDR(1) + 0x6148)
#define _TRISFINV         (_SRFS_ADDR(1) + 0x614C)
#define _PORTF            (_SRFS_ADDR(1) + 0x6150)
#define _PORTFCLR         (_SRFS_ADDR(1) + 0x6154)
#define _PORTFSET         (_SRFS_ADDR(1) + 0x6158)
#define _PORTFINV         (_SRFS_ADDR(1) + 0x615C)
#define _LATF             (_SRFS_ADDR(1) + 0x6160)
#define _LATFCLR          (_SRFS_ADDR(1) + 0x6164)
#define _LATFSET          (_SRFS_ADDR(1) + 0x6168)
#define _LATFINV          (_SRFS_ADDR(1) + 0x616C)
#define _ODCF             (_SRFS_ADDR(1) + 0x6170)
#define _ODCFCLR          (_SRFS_ADDR(1) + 0x6174)
#define _ODCFSET          (_SRFS_ADDR(1) + 0x6178)
#define _ODCFINV          (_SRFS_ADDR(1) + 0x617C)
#define _TRISG            (_SRFS_ADDR(1) + 0x6180)
#define _TRISGCLR         (_SRFS_ADDR(1) + 0x6184)
#define _TRISGSET         (_SRFS_ADDR(1) + 0x6188)
#define _TRISGINV         (_SRFS_ADDR(1) + 0x618C)
#define _PORTG            (_SRFS_ADDR(1) + 0x6190)
#define _PORTGCLR         (_SRFS_ADDR(1) + 0x6194)
#define _PORTGSET         (_SRFS_ADDR(1) + 0x6198)
#define _PORTGINV         (_SRFS_ADDR(1) + 0x619C)
#define _LATG             (_SRFS_ADDR(1) + 0x61A0)
#define _LATGCLR          (_SRFS_ADDR(1) + 0x61A4)
#define _LATGSET          (_SRFS_ADDR(1) + 0x61A8)
#define _LATGINV          (_SRFS_ADDR(1) + 0x61AC)
#define _ODCG             (_SRFS_ADDR(1) + 0x61B0)
#define _ODCGCLR          (_SRFS_ADDR(1) + 0x61B4)
#define _ODCGSET          (_SRFS_ADDR(1) + 0x61B8)
#define _ODCGINV          (_SRFS_ADDR(1) + 0x61BC)
#define _CNCON            (_SRFS_ADDR(1) + 0x61C0)
#define _CNCONCLR         (_SRFS_ADDR(1) + 0x61C4)
#define _CNCONSET         (_SRFS_ADDR(1) + 0x61C8)
#define _CNCONINV         (_SRFS_ADDR(1) + 0x61CC)
#define _CNEN             (_SRFS_ADDR(1) + 0x61D0)
#define _CNENCLR          (_SRFS_ADDR(1) + 0x61D4)
#define _CNENSET          (_SRFS_ADDR(1) + 0x61D8)
#define _CNENINV          (_SRFS_ADDR(1) + 0x61DC)
#define _CNPUE            (_SRFS_ADDR(1) + 0x61E0)
#define _CNPUECLR         (_SRFS_ADDR(1) + 0x61E4)
#define _CNPUESET         (_SRFS_ADDR(1) + 0x61E8)
#define _CNPUEINV         (_SRFS_ADDR(1) + 0x61EC)
#define _ETHCON1          (_SRFS_ADDR(1) + 0x9000)
#define _ETHCON1CLR       (_SRFS_ADDR(1) + 0x9004)
#define _ETHCON1SET       (_SRFS_ADDR(1) + 0x9008)
#define _ETHCON1INV       (_SRFS_ADDR(1) + 0x900C)
#define _ETHCON2          (_SRFS_ADDR(1) + 0x9010)
#define _ETHCON2CLR       (_SRFS_ADDR(1) + 0x9014)
#define _ETHCON2SET       (_SRFS_ADDR(1) + 0x9018)
#define _ETHCON2INV       (_SRFS_ADDR(1) + 0x901C)
#define _ETHTXST          (_SRFS_ADDR(1) + 0x9020)
#define _ETHTXSTCLR       (_SRFS_ADDR(1) + 0x9024)
#define _ETHTXSTSET       (_SRFS_ADDR(1) + 0x9028)
#define _ETHTXSTINV       (_SRFS_ADDR(1) + 0x902C)
#define _ETHRXST          (_SRFS_ADDR(1) + 0x9030)
#define _ETHRXSTCLR       (_SRFS_ADDR(1) + 0x9034)
#define _ETHRXSTSET       (_SRFS_ADDR(1) + 0x9038)
#define _ETHRXSTINV       (_SRFS_ADDR(1) + 0x903C)
#define _ETHHT0           (_SRFS_ADDR(1) + 0x9040)
#define _ETHHT0CLR        (_SRFS_ADDR(1) + 0x9044)
#define _ETHHT0SET        (_SRFS_ADDR(1) + 0x9048)
#define _ETHHT0INV        (_SRFS_ADDR(1) + 0x904C)
#define _ETHHT1           (_SRFS_ADDR(1) + 0x9050)
#define _ETHHT1CLR        (_SRFS_ADDR(1) + 0x9054)
#define _ETHHT1SET        (_SRFS_ADDR(1) + 0x9058)
#define _ETHHT1INV        (_SRFS_ADDR(1) + 0x905C)
#define _ETHPMM0          (_SRFS_ADDR(1) + 0x9060)
#define _ETHPMM0CLR       (_SRFS_ADDR(1) + 0x9064)
#define _ETHPMM0SET       (_SRFS_ADDR(1) + 0x9068)
#define _ETHPMM0INV       (_SRFS_ADDR(1) + 0x906C)
#define _ETHPMM1          (_SRFS_ADDR(1) + 0x9070)
#define _ETHPMM1CLR       (_SRFS_ADDR(1) + 0x9074)
#define _ETHPMM1SET       (_SRFS_ADDR(1) + 0x9078)
#define _ETHPMM1INV       (_SRFS_ADDR(1) + 0x907C)
#define _ETHPMCS          (_SRFS_ADDR(1) + 0x9080)
#define _ETHPMCSCLR       (_SRFS_ADDR(1) + 0x9084)
#define _ETHPMCSSET       (_SRFS_ADDR(1) + 0x9088)
#define _ETHPMCSINV       (_SRFS_ADDR(1) + 0x908C)
#define _ETHPMO           (_SRFS_ADDR(1) + 0x9090)
#define _ETHPMOCLR        (_SRFS_ADDR(1) + 0x9094)
#define _ETHPMOSET        (_SRFS_ADDR(1) + 0x9098)
#define _ETHPMOINV        (_SRFS_ADDR(1) + 0x909C)
#define _ETHRXFC          (_SRFS_ADDR(1) + 0x90A0)
#define _ETHRXFCCLR       (_SRFS_ADDR(1) + 0x90A4)
#define _ETHRXFCSET       (_SRFS_ADDR(1) + 0x90A8)
#define _ETHRXFCINV       (_SRFS_ADDR(1) + 0x90AC)
#define _ETHRXWM          (_SRFS_ADDR(1) + 0x90B0)
#define _ETHRXWMCLR       (_SRFS_ADDR(1) + 0x90B4)
#define _ETHRXWMSET       (_SRFS_ADDR(1) + 0x90B8)
#define _ETHRXWMINV       (_SRFS_ADDR(1) + 0x90BC)
#define _ETHIEN           (_SRFS_ADDR(1) + 0x90C0)
#define _ETHIENCLR        (_SRFS_ADDR(1) + 0x90C4)
#define _ETHIENSET        (_SRFS_ADDR(1) + 0x90C8)
#define _ETHIENINV        (_SRFS_ADDR(1) + 0x90CC)
#define _ETHIRQ           (_SRFS_ADDR(1) + 0x90D0)
#define _ETHIRQCLR        (_SRFS_ADDR(1) + 0x90D4)
#define _ETHIRQSET        (_SRFS_ADDR(1) + 0x90D8)
#define _ETHIRQINV        (_SRFS_ADDR(1) + 0x90DC)
#define _ETHSTAT          (_SRFS_ADDR(1) + 0x90E0)
#define _ETHSTATCLR       (_SRFS_ADDR(1) + 0x90E4)
#define _ETHSTATSET       (_SRFS_ADDR(1) + 0x90E8)
#define _ETHSTATINV       (_SRFS_ADDR(1) + 0x90EC)
#define _ETHRXOVFLOW      (_SRFS_ADDR(1) + 0x9100)
#define _ETHRXOVFLOWCLR   (_SRFS_ADDR(1) + 0x9104)
#define _ETHRXOVFLOWSET   (_SRFS_ADDR(1) + 0x9108)
#define _ETHRXOVFLOWINV   (_SRFS_ADDR(1) + 0x910C)
#define _ETHFRMTXOK       (_SRFS_ADDR(1) + 0x9110)
#define _ETHFRMTXOKCLR    (_SRFS_ADDR(1) + 0x9114)
#define _ETHFRMTXOKSET    (_SRFS_ADDR(1) + 0x9118)
#define _ETHFRMTXOKINV    (_SRFS_ADDR(1) + 0x911C)
#define _ETHSCOLFRM       (_SRFS_ADDR(1) + 0x9120)
#define _ETHSCOLFRMCLR    (_SRFS_ADDR(1) + 0x9124)
#define _ETHSCOLFRMSET    (_SRFS_ADDR(1) + 0x9128)
#define _ETHSCOLFRMINV    (_SRFS_ADDR(1) + 0x912C)
#define _ETHMCOLFRM       (_SRFS_ADDR(1) + 0x9130)
#define _ETHMCOLFRMCLR    (_SRFS_ADDR(1) + 0x9134)
#define _ETHMCOLFRMSET    (_SRFS_ADDR(1) + 0x9138)
#define _ETHMCOLFRMINV    (_SRFS_ADDR(1) + 0x913C)
#define _ETHFRMRXOK       (_SRFS_ADDR(1) + 0x9140)
#define _ETHFRMRXOKCLR    (_SRFS_ADDR(1) + 0x9144)
#define _ETHFRMRXOKSET    (_SRFS_ADDR(1) + 0x9148)
#define _ETHFRMRXOKINV    (_SRFS_ADDR(1) + 0x914C)
#define _ETHFCSERR        (_SRFS_ADDR(1) + 0x9150)
#define _ETHFCSERRCLR     (_SRFS_ADDR(1) + 0x9154)
#define _ETHFCSERRSET     (_SRFS_ADDR(1) + 0x9158)
#define _ETHFCSERRINV     (_SRFS_ADDR(1) + 0x915C)
#define _ETHALGNERR       (_SRFS_ADDR(1) + 0x9160)
#define _ETHALGNERRCLR    (_SRFS_ADDR(1) + 0x9164)
#define _ETHALGNERRSET    (_SRFS_ADDR(1) + 0x9168)
#define _ETHALGNERRINV    (_SRFS_ADDR(1) + 0x916C)
#define _EMAC1CFG1        (_SRFS_ADDR(1) + 0x9200)
#define _EMACxCFG1        (_SRFS_ADDR(1) + 0x9200)
#define _EMAC1CFG1CLR     (_SRFS_ADDR(1) + 0x9204)
#define _EMACxCFG1CLR     (_SRFS_ADDR(1) + 0x9204)
#define _EMAC1CFG1SET     (_SRFS_ADDR(1) + 0x9208)
#define _EMACxCFG1SET     (_SRFS_ADDR(1) + 0x9208)
#define _EMAC1CFG1INV     (_SRFS_ADDR(1) + 0x920C)
#define _EMACxCFG1INV     (_SRFS_ADDR(1) + 0x920C)
#define _EMAC1CFG2        (_SRFS_ADDR(1) + 0x9210)
#define _EMACxCFG2        (_SRFS_ADDR(1) + 0x9210)
#define _EMAC1CFG2CLR     (_SRFS_ADDR(1) + 0x9214)
#define _EMACxCFG2CLR     (_SRFS_ADDR(1) + 0x9214)
#define _EMAC1CFG2SET     (_SRFS_ADDR(1) + 0x9218)
#define _EMACxCFG2SET     (_SRFS_ADDR(1) + 0x9218)
#define _EMAC1CFG2INV     (_SRFS_ADDR(1) + 0x921C)
#define _EMACxCFG2INV     (_SRFS_ADDR(1) + 0x921C)
#define _EMAC1IPGT        (_SRFS_ADDR(1) + 0x9220)
#define _EMACxIPGT        (_SRFS_ADDR(1) + 0x9220)
#define _EMAC1IPGTCLR     (_SRFS_ADDR(1) + 0x9224)
#define _EMACxIPGTCLR     (_SRFS_ADDR(1) + 0x9224)
#define _EMAC1IPGTSET     (_SRFS_ADDR(1) + 0x9228)
#define _EMACxIPGTSET     (_SRFS_ADDR(1) + 0x9228)
#define _EMAC1IPGTINV     (_SRFS_ADDR(1) + 0x922C)
#define _EMACxIPGTINV     (_SRFS_ADDR(1) + 0x922C)
#define _EMAC1IPGR        (_SRFS_ADDR(1) + 0x9230)
#define _EMACxIPGR        (_SRFS_ADDR(1) + 0x9230)
#define _EMAC1IPGRCLR     (_SRFS_ADDR(1) + 0x9234)
#define _EMACxIPGRCLR     (_SRFS_ADDR(1) + 0x9234)
#define _EMAC1IPGRSET     (_SRFS_ADDR(1) + 0x9238)
#define _EMACxIPGRSET     (_SRFS_ADDR(1) + 0x9238)
#define _EMAC1IPGRINV     (_SRFS_ADDR(1) + 0x923C)
#define _EMACxIPGRINV     (_SRFS_ADDR(1) + 0x923C)
#define _EMAC1CLRT        (_SRFS_ADDR(1) + 0x9240)
#define _EMACxCLRT        (_SRFS_ADDR(1) + 0x9240)
#define _EMAC1CLRTCLR     (_SRFS_ADDR(1) + 0x9244)
#define _EMACxCLRTCLR     (_SRFS_ADDR(1) + 0x9244)
#define _EMAC1CLRTSET     (_SRFS_ADDR(1) + 0x9248)
#define _EMACxCLRTSET     (_SRFS_ADDR(1) + 0x9248)
#define _EMAC1CLRTINV     (_SRFS_ADDR(1) + 0x924C)
#define _EMACxCLRTINV     (_SRFS_ADDR(1) + 0x924C)
#define _EMAC1MAXF        (_SRFS_ADDR(1) + 0x9250)
#define _EMACxMAXF        (_SRFS_ADDR(1) + 0x9250)
#define _EMAC1MAXFCLR     (_SRFS_ADDR(1) + 0x9254)
#define _EMACxMAXFCLR     (_SRFS_ADDR(1) + 0x9254)
#define _EMAC1MAXFSET     (_SRFS_ADDR(1) + 0x9258)
#define _EMACxMAXFSET     (_SRFS_ADDR(1) + 0x9258)
#define _EMAC1MAXFINV     (_SRFS_ADDR(1) + 0x925C)
#define _EMACxMAXFINV     (_SRFS_ADDR(1) + 0x925C)
#define _EMAC1SUPP        (_SRFS_ADDR(1) + 0x9260)
#define _EMACxSUPP        (_SRFS_ADDR(1) + 0x9260)
#define _EMAC1SUPPCLR     (_SRFS_ADDR(1) + 0x9264)
#define _EMACxSUPPCLR     (_SRFS_ADDR(1) + 0x9264)
#define _EMAC1SUPPSET     (_SRFS_ADDR(1) + 0x9268)
#define _EMACxSUPPSET     (_SRFS_ADDR(1) + 0x9268)
#define _EMAC1SUPPINV     (_SRFS_ADDR(1) + 0x926C)
#define _EMACxSUPPINV     (_SRFS_ADDR(1) + 0x926C)
#define _EMAC1TEST        (_SRFS_ADDR(1) + 0x9270)
#define _EMACxTEST        (_SRFS_ADDR(1) + 0x9270)
#define _EMAC1TESTCLR     (_SRFS_ADDR(1) + 0x9274)
#define _EMACxTESTCLR     (_SRFS_ADDR(1) + 0x9274)
#define _EMAC1TESTSET     (_SRFS_ADDR(1) + 0x9278)
#define _EMACxTESTSET     (_SRFS_ADDR(1) + 0x9278)
#define _EMAC1TESTINV     (_SRFS_ADDR(1) + 0x927C)
#define _EMACxTESTINV     (_SRFS_ADDR(1) + 0x927C)
#define _EMAC1MCFG        (_SRFS_ADDR(1) + 0x9280)
#define _EMACxMCFG        (_SRFS_ADDR(1) + 0x9280)
#define _EMAC1MCFGCLR     (_SRFS_ADDR(1) + 0x9284)
#define _EMACxMCFGCLR     (_SRFS_ADDR(1) + 0x9284)
#define _EMAC1MCFGSET     (_SRFS_ADDR(1) + 0x9288)
#define _EMACxMCFGSET     (_SRFS_ADDR(1) + 0x9288)
#define _EMAC1MCFGINV     (_SRFS_ADDR(1) + 0x928C)
#define _EMACxMCFGINV     (_SRFS_ADDR(1) + 0x928C)
#define _EMAC1MCMD        (_SRFS_ADDR(1) + 0x9290)
#define _EMACxMCMD        (_SRFS_ADDR(1) + 0x9290)
#define _EMAC1MCMDCLR     (_SRFS_ADDR(1) + 0x9294)
#define _EMACxMCMDCLR     (_SRFS_ADDR(1) + 0x9294)
#define _EMAC1MCMDSET     (_SRFS_ADDR(1) + 0x9298)
#define _EMACxMCMDSET     (_SRFS_ADDR(1) + 0x9298)
#define _EMAC1MCMDINV     (_SRFS_ADDR(1) + 0x929C)
#define _EMACxMCMDINV     (_SRFS_ADDR(1) + 0x929C)
#define _EMAC1MADR        (_SRFS_ADDR(1) + 0x92A0)
#define _EMACxMADR        (_SRFS_ADDR(1) + 0x92A0)
#define _EMAC1MADRCLR     (_SRFS_ADDR(1) + 0x92A4)
#define _EMACxMADRCLR     (_SRFS_ADDR(1) + 0x92A4)
#define _EMAC1MADRSET     (_SRFS_ADDR(1) + 0x92A8)
#define _EMACxMADRSET     (_SRFS_ADDR(1) + 0x92A8)
#define _EMAC1MADRINV     (_SRFS_ADDR(1) + 0x92AC)
#define _EMACxMADRINV     (_SRFS_ADDR(1) + 0x92AC)
#define _EMAC1MWTD        (_SRFS_ADDR(1) + 0x92B0)
#define _EMACxMWTD        (_SRFS_ADDR(1) + 0x92B0)
#define _EMAC1MWTDCLR     (_SRFS_ADDR(1) + 0x92B4)
#define _EMACxMWTDCLR     (_SRFS_ADDR(1) + 0x92B4)
#define _EMAC1MWTDSET     (_SRFS_ADDR(1) + 0x92B8)
#define _EMACxMWTDSET     (_SRFS_ADDR(1) + 0x92B8)
#define _EMAC1MWTDINV     (_SRFS_ADDR(1) + 0x92BC)
#define _EMACxMWTDINV     (_SRFS_ADDR(1) + 0x92BC)
#define _EMAC1MRDD        (_SRFS_ADDR(1) + 0x92C0)
#define _EMACxMRDD        (_SRFS_ADDR(1) + 0x92C0)
#define _EMAC1MRDDCLR     (_SRFS_ADDR(1) + 0x92C4)
#define _EMACxMRDDCLR     (_SRFS_ADDR(1) + 0x92C4)
#define _EMAC1MRDDSET     (_SRFS_ADDR(1) + 0x92C8)
#define _EMACxMRDDSET     (_SRFS_ADDR(1) + 0x92C8)
#define _EMAC1MRDDINV     (_SRFS_ADDR(1) + 0x92CC)
#define _EMACxMRDDINV     (_SRFS_ADDR(1) + 0x92CC)
#define _EMAC1MIND        (_SRFS_ADDR(1) + 0x92D0)
#define _EMACxMIND        (_SRFS_ADDR(1) + 0x92D0)
#define _EMAC1MINDCLR     (_SRFS_ADDR(1) + 0x92D4)
#define _EMACxMINDCLR     (_SRFS_ADDR(1) + 0x92D4)
#define _EMAC1MINDSET     (_SRFS_ADDR(1) + 0x92D8)
#define _EMACxMINDSET     (_SRFS_ADDR(1) + 0x92D8)
#define _EMAC1MINDINV     (_SRFS_ADDR(1) + 0x92DC)
#define _EMACxMINDINV     (_SRFS_ADDR(1) + 0x92DC)
#define _EMAC1SA0         (_SRFS_ADDR(1) + 0x9300)
#define _EMACxSA0         (_SRFS_ADDR(1) + 0x9300)
#define _EMAC1SA0CLR      (_SRFS_ADDR(1) + 0x9304)
#define _EMACxSA0CLR      (_SRFS_ADDR(1) + 0x9304)
#define _EMAC1SA0SET      (_SRFS_ADDR(1) + 0x9308)
#define _EMACxSA0SET      (_SRFS_ADDR(1) + 0x9308)
#define _EMAC1SA0INV      (_SRFS_ADDR(1) + 0x930C)
#define _EMACxSA0INV      (_SRFS_ADDR(1) + 0x930C)
#define _EMAC1SA1         (_SRFS_ADDR(1) + 0x9310)
#define _EMACxSA1         (_SRFS_ADDR(1) + 0x9310)
#define _EMAC1SA1CLR      (_SRFS_ADDR(1) + 0x9314)
#define _EMACxSA1CLR      (_SRFS_ADDR(1) + 0x9314)
#define _EMAC1SA1SET      (_SRFS_ADDR(1) + 0x9318)
#define _EMACxSA1SET      (_SRFS_ADDR(1) + 0x9318)
#define _EMAC1SA1INV      (_SRFS_ADDR(1) + 0x931C)
#define _EMACxSA1INV      (_SRFS_ADDR(1) + 0x931C)
#define _EMAC1SA2         (_SRFS_ADDR(1) + 0x9320)
#define _EMACxSA2         (_SRFS_ADDR(1) + 0x9320)
#define _EMAC1SA2CLR      (_SRFS_ADDR(1) + 0x9324)
#define _EMACxSA2CLR      (_SRFS_ADDR(1) + 0x9324)
#define _EMAC1SA2SET      (_SRFS_ADDR(1) + 0x9328)
#define _EMACxSA2SET      (_SRFS_ADDR(1) + 0x9328)
#define _EMAC1SA2INV      (_SRFS_ADDR(1) + 0x932C)
#define _EMACxSA2INV      (_SRFS_ADDR(1) + 0x932C)
#define _C1CON            (_SRFS_ADDR(1) + 0xB000)
#define _C1CONCLR         (_SRFS_ADDR(1) + 0xB004)
#define _C1CONSET         (_SRFS_ADDR(1) + 0xB008)
#define _C1CONINV         (_SRFS_ADDR(1) + 0xB00C)
#define _C1CFG            (_SRFS_ADDR(1) + 0xB010)
#define _C1CFGCLR         (_SRFS_ADDR(1) + 0xB014)
#define _C1CFGSET         (_SRFS_ADDR(1) + 0xB018)
#define _C1CFGINV         (_SRFS_ADDR(1) + 0xB01C)
#define _C1INT            (_SRFS_ADDR(1) + 0xB020)
#define _C1INTCLR         (_SRFS_ADDR(1) + 0xB024)
#define _C1INTSET         (_SRFS_ADDR(1) + 0xB028)
#define _C1INTINV         (_SRFS_ADDR(1) + 0xB02C)
#define _C1VEC            (_SRFS_ADDR(1) + 0xB030)
#define _C1VECCLR         (_SRFS_ADDR(1) + 0xB034)
#define _C1VECSET         (_SRFS_ADDR(1) + 0xB038)
#define _C1VECINV         (_SRFS_ADDR(1) + 0xB03C)
#define _C1TREC           (_SRFS_ADDR(1) + 0xB040)
#define _C1TRECCLR        (_SRFS_ADDR(1) + 0xB044)
#define _C1TRECSET        (_SRFS_ADDR(1) + 0xB048)
#define _C1TRECINV        (_SRFS_ADDR(1) + 0xB04C)
#define _C1FSTAT          (_SRFS_ADDR(1) + 0xB050)
#define _C1FSTATCLR       (_SRFS_ADDR(1) + 0xB054)
#define _C1FSTATSET       (_SRFS_ADDR(1) + 0xB058)
#define _C1FSTATINV       (_SRFS_ADDR(1) + 0xB05C)
#define _C1RXOVF          (_SRFS_ADDR(1) + 0xB060)
#define _C1RXOVFCLR       (_SRFS_ADDR(1) + 0xB064)
#define _C1RXOVFSET       (_SRFS_ADDR(1) + 0xB068)
#define _C1RXOVFINV       (_SRFS_ADDR(1) + 0xB06C)
#define _C1TMR            (_SRFS_ADDR(1) + 0xB070)
#define _C1TMRCLR         (_SRFS_ADDR(1) + 0xB074)
#define _C1TMRSET         (_SRFS_ADDR(1) + 0xB078)
#define _C1TMRINV         (_SRFS_ADDR(1) + 0xB07C)
#define _C1RXM0           (_SRFS_ADDR(1) + 0xB080)
#define _C1RXM0CLR        (_SRFS_ADDR(1) + 0xB084)
#define _C1RXM0SET        (_SRFS_ADDR(1) + 0xB088)
#define _C1RXM0INV        (_SRFS_ADDR(1) + 0xB08C)
#define _C1RXM1           (_SRFS_ADDR(1) + 0xB090)
#define _C1RXM1CLR        (_SRFS_ADDR(1) + 0xB094)
#define _C1RXM1SET        (_SRFS_ADDR(1) + 0xB098)
#define _C1RXM1INV        (_SRFS_ADDR(1) + 0xB09C)
#define _C1RXM2           (_SRFS_ADDR(1) + 0xB0A0)
#define _C1RXM2CLR        (_SRFS_ADDR(1) + 0xB0A4)
#define _C1RXM2SET        (_SRFS_ADDR(1) + 0xB0A8)
#define _C1RXM2INV        (_SRFS_ADDR(1) + 0xB0AC)
#define _C1RXM3           (_SRFS_ADDR(1) + 0xB0B0)
#define _C1RXM3CLR        (_SRFS_ADDR(1) + 0xB0B4)
#define _C1RXM3SET        (_SRFS_ADDR(1) + 0xB0B8)
#define _C1RXM3INV        (_SRFS_ADDR(1) + 0xB0BC)
#define _C1FLTCON0        (_SRFS_ADDR(1) + 0xB0C0)
#define _C1FLTCON0CLR     (_SRFS_ADDR(1) + 0xB0C4)
#define _C1FLTCON0SET     (_SRFS_ADDR(1) + 0xB0C8)
#define _C1FLTCON0INV     (_SRFS_ADDR(1) + 0xB0CC)
#define _C1FLTCON1        (_SRFS_ADDR(1) + 0xB0D0)
#define _C1FLTCON1CLR     (_SRFS_ADDR(1) + 0xB0D4)
#define _C1FLTCON1SET     (_SRFS_ADDR(1) + 0xB0D8)
#define _C1FLTCON1INV     (_SRFS_ADDR(1) + 0xB0DC)
#define _C1FLTCON2        (_SRFS_ADDR(1) + 0xB0E0)
#define _C1FLTCON2CLR     (_SRFS_ADDR(1) + 0xB0E4)
#define _C1FLTCON2SET     (_SRFS_ADDR(1) + 0xB0E8)
#define _C1FLTCON2INV     (_SRFS_ADDR(1) + 0xB0EC)
#define _C1FLTCON3        (_SRFS_ADDR(1) + 0xB0F0)
#define _C1FLTCON3CLR     (_SRFS_ADDR(1) + 0xB0F4)
#define _C1FLTCON3SET     (_SRFS_ADDR(1) + 0xB0F8)
#define _C1FLTCON3INV     (_SRFS_ADDR(1) + 0xB0FC)
#define _C1FLTCON4        (_SRFS_ADDR(1) + 0xB100)
#define _C1FLTCON4CLR     (_SRFS_ADDR(1) + 0xB104)
#define _C1FLTCON4SET     (_SRFS_ADDR(1) + 0xB108)
#define _C1FLTCON4INV     (_SRFS_ADDR(1) + 0xB10C)
#define _C1FLTCON5        (_SRFS_ADDR(1) + 0xB110)
#define _C1FLTCON5CLR     (_SRFS_ADDR(1) + 0xB114)
#define _C1FLTCON5SET     (_SRFS_ADDR(1) + 0xB118)
#define _C1FLTCON5INV     (_SRFS_ADDR(1) + 0xB11C)
#define _C1FLTCON6        (_SRFS_ADDR(1) + 0xB120)
#define _C1FLTCON6CLR     (_SRFS_ADDR(1) + 0xB124)
#define _C1FLTCON6SET     (_SRFS_ADDR(1) + 0xB128)
#define _C1FLTCON6INV     (_SRFS_ADDR(1) + 0xB12C)
#define _C1FLTCON7        (_SRFS_ADDR(1) + 0xB130)
#define _C1FLTCON7CLR     (_SRFS_ADDR(1) + 0xB134)
#define _C1FLTCON7SET     (_SRFS_ADDR(1) + 0xB138)
#define _C1FLTCON7INV     (_SRFS_ADDR(1) + 0xB13C)
#define _C1RXF0           (_SRFS_ADDR(1) + 0xB140)
#define _C1RXF0CLR        (_SRFS_ADDR(1) + 0xB144)
#define _C1RXF0SET        (_SRFS_ADDR(1) + 0xB148)
#define _C1RXF0INV        (_SRFS_ADDR(1) + 0xB14C)
#define _C1RXF1           (_SRFS_ADDR(1) + 0xB150)
#define _C1RXF1CLR        (_SRFS_ADDR(1) + 0xB154)
#define _C1RXF1SET        (_SRFS_ADDR(1) + 0xB158)
#define _C1RXF1INV        (_SRFS_ADDR(1) + 0xB15C)
#define _C1RXF2           (_SRFS_ADDR(1) + 0xB160)
#define _C1RXF2CLR        (_SRFS_ADDR(1) + 0xB164)
#define _C1RXF2SET        (_SRFS_ADDR(1) + 0xB168)
#define _C1RXF2INV        (_SRFS_ADDR(1) + 0xB16C)
#define _C1RXF3           (_SRFS_ADDR(1) + 0xB170)
#define _C1RXF3CLR        (_SRFS_ADDR(1) + 0xB174)
#define _C1RXF3SET        (_SRFS_ADDR(1) + 0xB178)
#define _C1RXF3INV        (_SRFS_ADDR(1) + 0xB17C)
#define _C1RXF4           (_SRFS_ADDR(1) + 0xB180)
#define _C1RXF4CLR        (_SRFS_ADDR(1) + 0xB184)
#define _C1RXF4SET        (_SRFS_ADDR(1) + 0xB188)
#define _C1RXF4INV        (_SRFS_ADDR(1) + 0xB18C)
#define _C1RXF5           (_SRFS_ADDR(1) + 0xB190)
#define _C1RXF5CLR        (_SRFS_ADDR(1) + 0xB194)
#define _C1RXF5SET        (_SRFS_ADDR(1) + 0xB198)
#define _C1RXF5INV        (_SRFS_ADDR(1) + 0xB19C)
#define _C1RXF6           (_SRFS_ADDR(1) + 0xB1A0)
#define _C1RXF6CLR        (_SRFS_ADDR(1) + 0xB1A4)
#define _C1RXF6SET        (_SRFS_ADDR(1) + 0xB1A8)
#define _C1RXF6INV        (_SRFS_ADDR(1) + 0xB1AC)
#define _C1RXF7           (_SRFS_ADDR(1) + 0xB1B0)
#define _C1RXF7CLR        (_SRFS_ADDR(1) + 0xB1B4)
#define _C1RXF7SET        (_SRFS_ADDR(1) + 0xB1B8)
#define _C1RXF7INV        (_SRFS_ADDR(1) + 0xB1BC)
#define _C1RXF8           (_SRFS_ADDR(1) + 0xB1C0)
#define _C1RXF8CLR        (_SRFS_ADDR(1) + 0xB1C4)
#define _C1RXF8SET        (_SRFS_ADDR(1) + 0xB1C8)
#define _C1RXF8INV        (_SRFS_ADDR(1) + 0xB1CC)
#define _C1RXF9           (_SRFS_ADDR(1) + 0xB1D0)
#define _C1RXF9CLR        (_SRFS_ADDR(1) + 0xB1D4)
#define _C1RXF9SET        (_SRFS_ADDR(1) + 0xB1D8)
#define _C1RXF9INV        (_SRFS_ADDR(1) + 0xB1DC)
#define _C1RXF10          (_SRFS_ADDR(1) + 0xB1E0)
#define _C1RXF10CLR       (_SRFS_ADDR(1) + 0xB1E4)
#define _C1RXF10SET       (_SRFS_ADDR(1) + 0xB1E8)
#define _C1RXF10INV       (_SRFS_ADDR(1) + 0xB1EC)
#define _C1RXF11          (_SRFS_ADDR(1) + 0xB1F0)
#define _C1RXF11CLR       (_SRFS_ADDR(1) + 0xB1F4)
#define _C1RXF11SET       (_SRFS_ADDR(1) + 0xB1F8)
#define _C1RXF11INV       (_SRFS_ADDR(1) + 0xB1FC)
#define _C1RXF12          (_SRFS_ADDR(1) + 0xB200)
#define _C1RXF12CLR       (_SRFS_ADDR(1) + 0xB204)
#define _C1RXF12SET       (_SRFS_ADDR(1) + 0xB208)
#define _C1RXF12INV       (_SRFS_ADDR(1) + 0xB20C)
#define _C1RXF13          (_SRFS_ADDR(1) + 0xB210)
#define _C1RXF13CLR       (_SRFS_ADDR(1) + 0xB214)
#define _C1RXF13SET       (_SRFS_ADDR(1) + 0xB218)
#define _C1RXF13INV       (_SRFS_ADDR(1) + 0xB21C)
#define _C1RXF14          (_SRFS_ADDR(1) + 0xB220)
#define _C1RXF14CLR       (_SRFS_ADDR(1) + 0xB224)
#define _C1RXF14SET       (_SRFS_ADDR(1) + 0xB228)
#define _C1RXF14INV       (_SRFS_ADDR(1) + 0xB22C)
#define _C1RXF15          (_SRFS_ADDR(1) + 0xB230)
#define _C1RXF15CLR       (_SRFS_ADDR(1) + 0xB234)
#define _C1RXF15SET       (_SRFS_ADDR(1) + 0xB238)
#define _C1RXF15INV       (_SRFS_ADDR(1) + 0xB23C)
#define _C1RXF16          (_SRFS_ADDR(1) + 0xB240)
#define _C1RXF16CLR       (_SRFS_ADDR(1) + 0xB244)
#define _C1RXF16SET       (_SRFS_ADDR(1) + 0xB248)
#define _C1RXF16INV       (_SRFS_ADDR(1) + 0xB24C)
#define _C1RXF17          (_SRFS_ADDR(1) + 0xB250)
#define _C1RXF17CLR       (_SRFS_ADDR(1) + 0xB254)
#define _C1RXF17SET       (_SRFS_ADDR(1) + 0xB258)
#define _C1RXF17INV       (_SRFS_ADDR(1) + 0xB25C)
#define _C1RXF18          (_SRFS_ADDR(1) + 0xB260)
#define _C1RXF18CLR       (_SRFS_ADDR(1) + 0xB264)
#define _C1RXF18SET       (_SRFS_ADDR(1) + 0xB268)
#define _C1RXF18INV       (_SRFS_ADDR(1) + 0xB26C)
#define _C1RXF19          (_SRFS_ADDR(1) + 0xB270)
#define _C1RXF19CLR       (_SRFS_ADDR(1) + 0xB274)
#define _C1RXF19SET       (_SRFS_ADDR(1) + 0xB278)
#define _C1RXF19INV       (_SRFS_ADDR(1) + 0xB27C)
#define _C1RXF20          (_SRFS_ADDR(1) + 0xB280)
#define _C1RXF20CLR       (_SRFS_ADDR(1) + 0xB284)
#define _C1RXF20SET       (_SRFS_ADDR(1) + 0xB288)
#define _C1RXF20INV       (_SRFS_ADDR(1) + 0xB28C)
#define _C1RXF21          (_SRFS_ADDR(1) + 0xB290)
#define _C1RXF21CLR       (_SRFS_ADDR(1) + 0xB294)
#define _C1RXF21SET       (_SRFS_ADDR(1) + 0xB298)
#define _C1RXF21INV       (_SRFS_ADDR(1) + 0xB29C)
#define _C1RXF22          (_SRFS_ADDR(1) + 0xB2A0)
#define _C1RXF22CLR       (_SRFS_ADDR(1) + 0xB2A4)
#define _C1RXF22SET       (_SRFS_ADDR(1) + 0xB2A8)
#define _C1RXF22INV       (_SRFS_ADDR(1) + 0xB2AC)
#define _C1RXF23          (_SRFS_ADDR(1) + 0xB2B0)
#define _C1RXF23CLR       (_SRFS_ADDR(1) + 0xB2B4)
#define _C1RXF23SET       (_SRFS_ADDR(1) + 0xB2B8)
#define _C1RXF23INV       (_SRFS_ADDR(1) + 0xB2BC)
#define _C1RXF24          (_SRFS_ADDR(1) + 0xB2C0)
#define _C1RXF24CLR       (_SRFS_ADDR(1) + 0xB2C4)
#define _C1RXF24SET       (_SRFS_ADDR(1) + 0xB2C8)
#define _C1RXF24INV       (_SRFS_ADDR(1) + 0xB2CC)
#define _C1RXF25          (_SRFS_ADDR(1) + 0xB2D0)
#define _C1RXF25CLR       (_SRFS_ADDR(1) + 0xB2D4)
#define _C1RXF25SET       (_SRFS_ADDR(1) + 0xB2D8)
#define _C1RXF25INV       (_SRFS_ADDR(1) + 0xB2DC)
#define _C1RXF26          (_SRFS_ADDR(1) + 0xB2E0)
#define _C1RXF26CLR       (_SRFS_ADDR(1) + 0xB2E4)
#define _C1RXF26SET       (_SRFS_ADDR(1) + 0xB2E8)
#define _C1RXF26INV       (_SRFS_ADDR(1) + 0xB2EC)
#define _C1RXF27          (_SRFS_ADDR(1) + 0xB2F0)
#define _C1RXF27CLR       (_SRFS_ADDR(1) + 0xB2F4)
#define _C1RXF27SET       (_SRFS_ADDR(1) + 0xB2F8)
#define _C1RXF27INV       (_SRFS_ADDR(1) + 0xB2FC)
#define _C1RXF28          (_SRFS_ADDR(1) + 0xB300)
#define _C1RXF28CLR       (_SRFS_ADDR(1) + 0xB304)
#define _C1RXF28SET       (_SRFS_ADDR(1) + 0xB308)
#define _C1RXF28INV       (_SRFS_ADDR(1) + 0xB30C)
#define _C1RXF29          (_SRFS_ADDR(1) + 0xB310)
#define _C1RXF29CLR       (_SRFS_ADDR(1) + 0xB314)
#define _C1RXF29SET       (_SRFS_ADDR(1) + 0xB318)
#define _C1RXF29INV       (_SRFS_ADDR(1) + 0xB31C)
#define _C1RXF30          (_SRFS_ADDR(1) + 0xB320)
#define _C1RXF30CLR       (_SRFS_ADDR(1) + 0xB324)
#define _C1RXF30SET       (_SRFS_ADDR(1) + 0xB328)
#define _C1RXF30INV       (_SRFS_ADDR(1) + 0xB32C)
#define _C1RXF31          (_SRFS_ADDR(1) + 0xB330)
#define _C1RXF31CLR       (_SRFS_ADDR(1) + 0xB334)
#define _C1RXF31SET       (_SRFS_ADDR(1) + 0xB338)
#define _C1RXF31INV       (_SRFS_ADDR(1) + 0xB33C)
#define _C1FIFOBA         (_SRFS_ADDR(1) + 0xB340)
#define _C1FIFOBACLR      (_SRFS_ADDR(1) + 0xB344)
#define _C1FIFOBASET      (_SRFS_ADDR(1) + 0xB348)
#define _C1FIFOBAINV      (_SRFS_ADDR(1) + 0xB34C)
#define _C1FIFOCON0       (_SRFS_ADDR(1) + 0xB350)
#define _C1FIFOCON0CLR    (_SRFS_ADDR(1) + 0xB354)
#define _C1FIFOCON0SET    (_SRFS_ADDR(1) + 0xB358)
#define _C1FIFOCON0INV    (_SRFS_ADDR(1) + 0xB35C)
#define _C1FIFOINT0       (_SRFS_ADDR(1) + 0xB360)
#define _C1FIFOINT0CLR    (_SRFS_ADDR(1) + 0xB364)
#define _C1FIFOINT0SET    (_SRFS_ADDR(1) + 0xB368)
#define _C1FIFOINT0INV    (_SRFS_ADDR(1) + 0xB36C)
#define _C1FIFOUA0        (_SRFS_ADDR(1) + 0xB370)
#define _C1FIFOUA0CLR     (_SRFS_ADDR(1) + 0xB374)
#define _C1FIFOUA0SET     (_SRFS_ADDR(1) + 0xB378)
#define _C1FIFOUA0INV     (_SRFS_ADDR(1) + 0xB37C)
#define _C1FIFOCI0        (_SRFS_ADDR(1) + 0xB380)
#define _C1FIFOCI0CLR     (_SRFS_ADDR(1) + 0xB384)
#define _C1FIFOCI0SET     (_SRFS_ADDR(1) + 0xB388)
#define _C1FIFOCI0INV     (_SRFS_ADDR(1) + 0xB38C)
#define _C1FIFOCON1       (_SRFS_ADDR(1) + 0xB390)
#define _C1FIFOCON1CLR    (_SRFS_ADDR(1) + 0xB394)
#define _C1FIFOCON1SET    (_SRFS_ADDR(1) + 0xB398)
#define _C1FIFOCON1INV    (_SRFS_ADDR(1) + 0xB39C)
#define _C1FIFOINT1       (_SRFS_ADDR(1) + 0xB3A0)
#define _C1FIFOINT1CLR    (_SRFS_ADDR(1) + 0xB3A4)
#define _C1FIFOINT1SET    (_SRFS_ADDR(1) + 0xB3A8)
#define _C1FIFOINT1INV    (_SRFS_ADDR(1) + 0xB3AC)
#define _C1FIFOUA1        (_SRFS_ADDR(1) + 0xB3B0)
#define _C1FIFOUA1CLR     (_SRFS_ADDR(1) + 0xB3B4)
#define _C1FIFOUA1SET     (_SRFS_ADDR(1) + 0xB3B8)
#define _C1FIFOUA1INV     (_SRFS_ADDR(1) + 0xB3BC)
#define _C1FIFOCI1        (_SRFS_ADDR(1) + 0xB3C0)
#define _C1FIFOCI1CLR     (_SRFS_ADDR(1) + 0xB3C4)
#define _C1FIFOCI1SET     (_SRFS_ADDR(1) + 0xB3C8)
#define _C1FIFOCI1INV     (_SRFS_ADDR(1) + 0xB3CC)
#define _C1FIFOCON2       (_SRFS_ADDR(1) + 0xB3D0)
#define _C1FIFOCON2CLR    (_SRFS_ADDR(1) + 0xB3D4)
#define _C1FIFOCON2SET    (_SRFS_ADDR(1) + 0xB3D8)
#define _C1FIFOCON2INV    (_SRFS_ADDR(1) + 0xB3DC)
#define _C1FIFOINT2       (_SRFS_ADDR(1) + 0xB3E0)
#define _C1FIFOINT2CLR    (_SRFS_ADDR(1) + 0xB3E4)
#define _C1FIFOINT2SET    (_SRFS_ADDR(1) + 0xB3E8)
#define _C1FIFOINT2INV    (_SRFS_ADDR(1) + 0xB3EC)
#define _C1FIFOUA2        (_SRFS_ADDR(1) + 0xB3F0)
#define _C1FIFOUA2CLR     (_SRFS_ADDR(1) + 0xB3F4)
#define _C1FIFOUA2SET     (_SRFS_ADDR(1) + 0xB3F8)
#define _C1FIFOUA2INV     (_SRFS_ADDR(1) + 0xB3FC)
#define _C1FIFOCI2        (_SRFS_ADDR(1) + 0xB400)
#define _C1FIFOCI2CLR     (_SRFS_ADDR(1) + 0xB404)
#define _C1FIFOCI2SET     (_SRFS_ADDR(1) + 0xB408)
#define _C1FIFOCI2INV     (_SRFS_ADDR(1) + 0xB40C)
#define _C1FIFOCON3       (_SRFS_ADDR(1) + 0xB410)
#define _C1FIFOCON3CLR    (_SRFS_ADDR(1) + 0xB414)
#define _C1FIFOCON3SET    (_SRFS_ADDR(1) + 0xB418)
#define _C1FIFOCON3INV    (_SRFS_ADDR(1) + 0xB41C)
#define _C1FIFOINT3       (_SRFS_ADDR(1) + 0xB420)
#define _C1FIFOINT3CLR    (_SRFS_ADDR(1) + 0xB424)
#define _C1FIFOINT3SET    (_SRFS_ADDR(1) + 0xB428)
#define _C1FIFOINT3INV    (_SRFS_ADDR(1) + 0xB42C)
#define _C1FIFOUA3        (_SRFS_ADDR(1) + 0xB430)
#define _C1FIFOUA3CLR     (_SRFS_ADDR(1) + 0xB434)
#define _C1FIFOUA3SET     (_SRFS_ADDR(1) + 0xB438)
#define _C1FIFOUA3INV     (_SRFS_ADDR(1) + 0xB43C)
#define _C1FIFOCI3        (_SRFS_ADDR(1) + 0xB440)
#define _C1FIFOCI3CLR     (_SRFS_ADDR(1) + 0xB444)
#define _C1FIFOCI3SET     (_SRFS_ADDR(1) + 0xB448)
#define _C1FIFOCI3INV     (_SRFS_ADDR(1) + 0xB44C)
#define _C1FIFOCON4       (_SRFS_ADDR(1) + 0xB450)
#define _C1FIFOCON4CLR    (_SRFS_ADDR(1) + 0xB454)
#define _C1FIFOCON4SET    (_SRFS_ADDR(1) + 0xB458)
#define _C1FIFOCON4INV    (_SRFS_ADDR(1) + 0xB45C)
#define _C1FIFOINT4       (_SRFS_ADDR(1) + 0xB460)
#define _C1FIFOINT4CLR    (_SRFS_ADDR(1) + 0xB464)
#define _C1FIFOINT4SET    (_SRFS_ADDR(1) + 0xB468)
#define _C1FIFOINT4INV    (_SRFS_ADDR(1) + 0xB46C)
#define _C1FIFOUA4        (_SRFS_ADDR(1) + 0xB470)
#define _C1FIFOUA4CLR     (_SRFS_ADDR(1) + 0xB474)
#define _C1FIFOUA4SET     (_SRFS_ADDR(1) + 0xB478)
#define _C1FIFOUA4INV     (_SRFS_ADDR(1) + 0xB47C)
#define _C1FIFOCI4        (_SRFS_ADDR(1) + 0xB480)
#define _C1FIFOCI4CLR     (_SRFS_ADDR(1) + 0xB484)
#define _C1FIFOCI4SET     (_SRFS_ADDR(1) + 0xB488)
#define _C1FIFOCI4INV     (_SRFS_ADDR(1) + 0xB48C)
#define _C1FIFOCON5       (_SRFS_ADDR(1) + 0xB490)
#define _C1FIFOCON5CLR    (_SRFS_ADDR(1) + 0xB494)
#define _C1FIFOCON5SET    (_SRFS_ADDR(1) + 0xB498)
#define _C1FIFOCON5INV    (_SRFS_ADDR(1) + 0xB49C)
#define _C1FIFOINT5       (_SRFS_ADDR(1) + 0xB4A0)
#define _C1FIFOINT5CLR    (_SRFS_ADDR(1) + 0xB4A4)
#define _C1FIFOINT5SET    (_SRFS_ADDR(1) + 0xB4A8)
#define _C1FIFOINT5INV    (_SRFS_ADDR(1) + 0xB4AC)
#define _C1FIFOUA5        (_SRFS_ADDR(1) + 0xB4B0)
#define _C1FIFOUA5CLR     (_SRFS_ADDR(1) + 0xB4B4)
#define _C1FIFOUA5SET     (_SRFS_ADDR(1) + 0xB4B8)
#define _C1FIFOUA5INV     (_SRFS_ADDR(1) + 0xB4BC)
#define _C1FIFOCI5        (_SRFS_ADDR(1) + 0xB4C0)
#define _C1FIFOCI5CLR     (_SRFS_ADDR(1) + 0xB4C4)
#define _C1FIFOCI5SET     (_SRFS_ADDR(1) + 0xB4C8)
#define _C1FIFOCI5INV     (_SRFS_ADDR(1) + 0xB4CC)
#define _C1FIFOCON6       (_SRFS_ADDR(1) + 0xB4D0)
#define _C1FIFOCON6CLR    (_SRFS_ADDR(1) + 0xB4D4)
#define _C1FIFOCON6SET    (_SRFS_ADDR(1) + 0xB4D8)
#define _C1FIFOCON6INV    (_SRFS_ADDR(1) + 0xB4DC)
#define _C1FIFOINT6       (_SRFS_ADDR(1) + 0xB4E0)
#define _C1FIFOINT6CLR    (_SRFS_ADDR(1) + 0xB4E4)
#define _C1FIFOINT6SET    (_SRFS_ADDR(1) + 0xB4E8)
#define _C1FIFOINT6INV    (_SRFS_ADDR(1) + 0xB4EC)
#define _C1FIFOUA6        (_SRFS_ADDR(1) + 0xB4F0)
#define _C1FIFOUA6CLR     (_SRFS_ADDR(1) + 0xB4F4)
#define _C1FIFOUA6SET     (_SRFS_ADDR(1) + 0xB4F8)
#define _C1FIFOUA6INV     (_SRFS_ADDR(1) + 0xB4FC)
#define _C1FIFOCI6        (_SRFS_ADDR(1) + 0xB500)
#define _C1FIFOCI6CLR     (_SRFS_ADDR(1) + 0xB504)
#define _C1FIFOCI6SET     (_SRFS_ADDR(1) + 0xB508)
#define _C1FIFOCI6INV     (_SRFS_ADDR(1) + 0xB50C)
#define _C1FIFOCON7       (_SRFS_ADDR(1) + 0xB510)
#define _C1FIFOCON7CLR    (_SRFS_ADDR(1) + 0xB514)
#define _C1FIFOCON7SET    (_SRFS_ADDR(1) + 0xB518)
#define _C1FIFOCON7INV    (_SRFS_ADDR(1) + 0xB51C)
#define _C1FIFOINT7       (_SRFS_ADDR(1) + 0xB520)
#define _C1FIFOINT7CLR    (_SRFS_ADDR(1) + 0xB524)
#define _C1FIFOINT7SET    (_SRFS_ADDR(1) + 0xB528)
#define _C1FIFOINT7INV    (_SRFS_ADDR(1) + 0xB52C)
#define _C1FIFOUA7        (_SRFS_ADDR(1) + 0xB530)
#define _C1FIFOUA7CLR     (_SRFS_ADDR(1) + 0xB534)
#define _C1FIFOUA7SET     (_SRFS_ADDR(1) + 0xB538)
#define _C1FIFOUA7INV     (_SRFS_ADDR(1) + 0xB53C)
#define _C1FIFOCI7        (_SRFS_ADDR(1) + 0xB540)
#define _C1FIFOCI7CLR     (_SRFS_ADDR(1) + 0xB544)
#define _C1FIFOCI7SET     (_SRFS_ADDR(1) + 0xB548)
#define _C1FIFOCI7INV     (_SRFS_ADDR(1) + 0xB54C)
#define _C1FIFOCON8       (_SRFS_ADDR(1) + 0xB550)
#define _C1FIFOCON8CLR    (_SRFS_ADDR(1) + 0xB554)
#define _C1FIFOCON8SET    (_SRFS_ADDR(1) + 0xB558)
#define _C1FIFOCON8INV    (_SRFS_ADDR(1) + 0xB55C)
#define _C1FIFOINT8       (_SRFS_ADDR(1) + 0xB560)
#define _C1FIFOINT8CLR    (_SRFS_ADDR(1) + 0xB564)
#define _C1FIFOINT8SET    (_SRFS_ADDR(1) + 0xB568)
#define _C1FIFOINT8INV    (_SRFS_ADDR(1) + 0xB56C)
#define _C1FIFOUA8        (_SRFS_ADDR(1) + 0xB570)
#define _C1FIFOUA8CLR     (_SRFS_ADDR(1) + 0xB574)
#define _C1FIFOUA8SET     (_SRFS_ADDR(1) + 0xB578)
#define _C1FIFOUA8INV     (_SRFS_ADDR(1) + 0xB57C)
#define _C1FIFOCI8        (_SRFS_ADDR(1) + 0xB580)
#define _C1FIFOCI8CLR     (_SRFS_ADDR(1) + 0xB584)
#define _C1FIFOCI8SET     (_SRFS_ADDR(1) + 0xB588)
#define _C1FIFOCI8INV     (_SRFS_ADDR(1) + 0xB58C)
#define _C1FIFOCON9       (_SRFS_ADDR(1) + 0xB590)
#define _C1FIFOCON9CLR    (_SRFS_ADDR(1) + 0xB594)
#define _C1FIFOCON9SET    (_SRFS_ADDR(1) + 0xB598)
#define _C1FIFOCON9INV    (_SRFS_ADDR(1) + 0xB59C)
#define _C1FIFOINT9       (_SRFS_ADDR(1) + 0xB5A0)
#define _C1FIFOINT9CLR    (_SRFS_ADDR(1) + 0xB5A4)
#define _C1FIFOINT9SET    (_SRFS_ADDR(1) + 0xB5A8)
#define _C1FIFOINT9INV    (_SRFS_ADDR(1) + 0xB5AC)
#define _C1FIFOUA9        (_SRFS_ADDR(1) + 0xB5B0)
#define _C1FIFOUA9CLR     (_SRFS_ADDR(1) + 0xB5B4)
#define _C1FIFOUA9SET     (_SRFS_ADDR(1) + 0xB5B8)
#define _C1FIFOUA9INV     (_SRFS_ADDR(1) + 0xB5BC)
#define _C1FIFOCI9        (_SRFS_ADDR(1) + 0xB5C0)
#define _C1FIFOCI9CLR     (_SRFS_ADDR(1) + 0xB5C4)
#define _C1FIFOCI9SET     (_SRFS_ADDR(1) + 0xB5C8)
#define _C1FIFOCI9INV     (_SRFS_ADDR(1) + 0xB5CC)
#define _C1FIFOCON10      (_SRFS_ADDR(1) + 0xB5D0)
#define _C1FIFOCON10CLR   (_SRFS_ADDR(1) + 0xB5D4)
#define _C1FIFOCON10SET   (_SRFS_ADDR(1) + 0xB5D8)
#define _C1FIFOCON10INV   (_SRFS_ADDR(1) + 0xB5DC)
#define _C1FIFOINT10      (_SRFS_ADDR(1) + 0xB5E0)
#define _C1FIFOINT10CLR   (_SRFS_ADDR(1) + 0xB5E4)
#define _C1FIFOINT10SET   (_SRFS_ADDR(1) + 0xB5E8)
#define _C1FIFOINT10INV   (_SRFS_ADDR(1) + 0xB5EC)
#define _C1FIFOUA10       (_SRFS_ADDR(1) + 0xB5F0)
#define _C1FIFOUA10CLR    (_SRFS_ADDR(1) + 0xB5F4)
#define _C1FIFOUA10SET    (_SRFS_ADDR(1) + 0xB5F8)
#define _C1FIFOUA10INV    (_SRFS_ADDR(1) + 0xB5FC)
#define _C1FIFOCI10       (_SRFS_ADDR(1) + 0xB600)
#define _C1FIFOCI10CLR    (_SRFS_ADDR(1) + 0xB604)
#define _C1FIFOCI10SET    (_SRFS_ADDR(1) + 0xB608)
#define _C1FIFOCI10INV    (_SRFS_ADDR(1) + 0xB60C)
#define _C1FIFOCON11      (_SRFS_ADDR(1) + 0xB610)
#define _C1FIFOCON11CLR   (_SRFS_ADDR(1) + 0xB614)
#define _C1FIFOCON11SET   (_SRFS_ADDR(1) + 0xB618)
#define _C1FIFOCON11INV   (_SRFS_ADDR(1) + 0xB61C)
#define _C1FIFOINT11      (_SRFS_ADDR(1) + 0xB620)
#define _C1FIFOINT11CLR   (_SRFS_ADDR(1) + 0xB624)
#define _C1FIFOINT11SET   (_SRFS_ADDR(1) + 0xB628)
#define _C1FIFOINT11INV   (_SRFS_ADDR(1) + 0xB62C)
#define _C1FIFOUA11       (_SRFS_ADDR(1) + 0xB630)
#define _C1FIFOUA11CLR    (_SRFS_ADDR(1) + 0xB634)
#define _C1FIFOUA11SET    (_SRFS_ADDR(1) + 0xB638)
#define _C1FIFOUA11INV    (_SRFS_ADDR(1) + 0xB63C)
#define _C1FIFOCI11       (_SRFS_ADDR(1) + 0xB640)
#define _C1FIFOCI11CLR    (_SRFS_ADDR(1) + 0xB644)
#define _C1FIFOCI11SET    (_SRFS_ADDR(1) + 0xB648)
#define _C1FIFOCI11INV    (_SRFS_ADDR(1) + 0xB64C)
#define _C1FIFOCON12      (_SRFS_ADDR(1) + 0xB650)
#define _C1FIFOCON12CLR   (_SRFS_ADDR(1) + 0xB654)
#define _C1FIFOCON12SET   (_SRFS_ADDR(1) + 0xB658)
#define _C1FIFOCON12INV   (_SRFS_ADDR(1) + 0xB65C)
#define _C1FIFOINT12      (_SRFS_ADDR(1) + 0xB660)
#define _C1FIFOINT12CLR   (_SRFS_ADDR(1) + 0xB664)
#define _C1FIFOINT12SET   (_SRFS_ADDR(1) + 0xB668)
#define _C1FIFOINT12INV   (_SRFS_ADDR(1) + 0xB66C)
#define _C1FIFOUA12       (_SRFS_ADDR(1) + 0xB670)
#define _C1FIFOUA12CLR    (_SRFS_ADDR(1) + 0xB674)
#define _C1FIFOUA12SET    (_SRFS_ADDR(1) + 0xB678)
#define _C1FIFOUA12INV    (_SRFS_ADDR(1) + 0xB67C)
#define _C1FIFOCI12       (_SRFS_ADDR(1) + 0xB680)
#define _C1FIFOCI12CLR    (_SRFS_ADDR(1) + 0xB684)
#define _C1FIFOCI12SET    (_SRFS_ADDR(1) + 0xB688)
#define _C1FIFOCI12INV    (_SRFS_ADDR(1) + 0xB68C)
#define _C1FIFOCON13      (_SRFS_ADDR(1) + 0xB690)
#define _C1FIFOCON13CLR   (_SRFS_ADDR(1) + 0xB694)
#define _C1FIFOCON13SET   (_SRFS_ADDR(1) + 0xB698)
#define _C1FIFOCON13INV   (_SRFS_ADDR(1) + 0xB69C)
#define _C1FIFOINT13      (_SRFS_ADDR(1) + 0xB6A0)
#define _C1FIFOINT13CLR   (_SRFS_ADDR(1) + 0xB6A4)
#define _C1FIFOINT13SET   (_SRFS_ADDR(1) + 0xB6A8)
#define _C1FIFOINT13INV   (_SRFS_ADDR(1) + 0xB6AC)
#define _C1FIFOUA13       (_SRFS_ADDR(1) + 0xB6B0)
#define _C1FIFOUA13CLR    (_SRFS_ADDR(1) + 0xB6B4)
#define _C1FIFOUA13SET    (_SRFS_ADDR(1) + 0xB6B8)
#define _C1FIFOUA13INV    (_SRFS_ADDR(1) + 0xB6BC)
#define _C1FIFOCI13       (_SRFS_ADDR(1) + 0xB6C0)
#define _C1FIFOCI13CLR    (_SRFS_ADDR(1) + 0xB6C4)
#define _C1FIFOCI13SET    (_SRFS_ADDR(1) + 0xB6C8)
#define _C1FIFOCI13INV    (_SRFS_ADDR(1) + 0xB6CC)
#define _C1FIFOCON14      (_SRFS_ADDR(1) + 0xB6D0)
#define _C1FIFOCON14CLR   (_SRFS_ADDR(1) + 0xB6D4)
#define _C1FIFOCON14SET   (_SRFS_ADDR(1) + 0xB6D8)
#define _C1FIFOCON14INV   (_SRFS_ADDR(1) + 0xB6DC)
#define _C1FIFOINT14      (_SRFS_ADDR(1) + 0xB6E0)
#define _C1FIFOINT14CLR   (_SRFS_ADDR(1) + 0xB6E4)
#define _C1FIFOINT14SET   (_SRFS_ADDR(1) + 0xB6E8)
#define _C1FIFOINT14INV   (_SRFS_ADDR(1) + 0xB6EC)
#define _C1FIFOUA14       (_SRFS_ADDR(1) + 0xB6F0)
#define _C1FIFOUA14CLR    (_SRFS_ADDR(1) + 0xB6F4)
#define _C1FIFOUA14SET    (_SRFS_ADDR(1) + 0xB6F8)
#define _C1FIFOUA14INV    (_SRFS_ADDR(1) + 0xB6FC)
#define _C1FIFOCI14       (_SRFS_ADDR(1) + 0xB700)
#define _C1FIFOCI14CLR    (_SRFS_ADDR(1) + 0xB704)
#define _C1FIFOCI14SET    (_SRFS_ADDR(1) + 0xB708)
#define _C1FIFOCI14INV    (_SRFS_ADDR(1) + 0xB70C)
#define _C1FIFOCON15      (_SRFS_ADDR(1) + 0xB710)
#define _C1FIFOCON15CLR   (_SRFS_ADDR(1) + 0xB714)
#define _C1FIFOCON15SET   (_SRFS_ADDR(1) + 0xB718)
#define _C1FIFOCON15INV   (_SRFS_ADDR(1) + 0xB71C)
#define _C1FIFOINT15      (_SRFS_ADDR(1) + 0xB720)
#define _C1FIFOINT15CLR   (_SRFS_ADDR(1) + 0xB724)
#define _C1FIFOINT15SET   (_SRFS_ADDR(1) + 0xB728)
#define _C1FIFOINT15INV   (_SRFS_ADDR(1) + 0xB72C)
#define _C1FIFOUA15       (_SRFS_ADDR(1) + 0xB730)
#define _C1FIFOUA15CLR    (_SRFS_ADDR(1) + 0xB734)
#define _C1FIFOUA15SET    (_SRFS_ADDR(1) + 0xB738)
#define _C1FIFOUA15INV    (_SRFS_ADDR(1) + 0xB73C)
#define _C1FIFOCI15       (_SRFS_ADDR(1) + 0xB740)
#define _C1FIFOCI15CLR    (_SRFS_ADDR(1) + 0xB744)
#define _C1FIFOCI15SET    (_SRFS_ADDR(1) + 0xB748)
#define _C1FIFOCI15INV    (_SRFS_ADDR(1) + 0xB74C)
#define _C1FIFOCON16      (_SRFS_ADDR(1) + 0xB750)
#define _C1FIFOCON16CLR   (_SRFS_ADDR(1) + 0xB754)
#define _C1FIFOCON16SET   (_SRFS_ADDR(1) + 0xB758)
#define _C1FIFOCON16INV   (_SRFS_ADDR(1) + 0xB75C)
#define _C1FIFOINT16      (_SRFS_ADDR(1) + 0xB760)
#define _C1FIFOINT16CLR   (_SRFS_ADDR(1) + 0xB764)
#define _C1FIFOINT16SET   (_SRFS_ADDR(1) + 0xB768)
#define _C1FIFOINT16INV   (_SRFS_ADDR(1) + 0xB76C)
#define _C1FIFOUA16       (_SRFS_ADDR(1) + 0xB770)
#define _C1FIFOUA16CLR    (_SRFS_ADDR(1) + 0xB774)
#define _C1FIFOUA16SET    (_SRFS_ADDR(1) + 0xB778)
#define _C1FIFOUA16INV    (_SRFS_ADDR(1) + 0xB77C)
#define _C1FIFOCI16       (_SRFS_ADDR(1) + 0xB780)
#define _C1FIFOCI16CLR    (_SRFS_ADDR(1) + 0xB784)
#define _C1FIFOCI16SET    (_SRFS_ADDR(1) + 0xB788)
#define _C1FIFOCI16INV    (_SRFS_ADDR(1) + 0xB78C)
#define _C1FIFOCON17      (_SRFS_ADDR(1) + 0xB790)
#define _C1FIFOCON17CLR   (_SRFS_ADDR(1) + 0xB794)
#define _C1FIFOCON17SET   (_SRFS_ADDR(1) + 0xB798)
#define _C1FIFOCON17INV   (_SRFS_ADDR(1) + 0xB79C)
#define _C1FIFOINT17      (_SRFS_ADDR(1) + 0xB7A0)
#define _C1FIFOINT17CLR   (_SRFS_ADDR(1) + 0xB7A4)
#define _C1FIFOINT17SET   (_SRFS_ADDR(1) + 0xB7A8)
#define _C1FIFOINT17INV   (_SRFS_ADDR(1) + 0xB7AC)
#define _C1FIFOUA17       (_SRFS_ADDR(1) + 0xB7B0)
#define _C1FIFOUA17CLR    (_SRFS_ADDR(1) + 0xB7B4)
#define _C1FIFOUA17SET    (_SRFS_ADDR(1) + 0xB7B8)
#define _C1FIFOUA17INV    (_SRFS_ADDR(1) + 0xB7BC)
#define _C1FIFOCI17       (_SRFS_ADDR(1) + 0xB7C0)
#define _C1FIFOCI17CLR    (_SRFS_ADDR(1) + 0xB7C4)
#define _C1FIFOCI17SET    (_SRFS_ADDR(1) + 0xB7C8)
#define _C1FIFOCI17INV    (_SRFS_ADDR(1) + 0xB7CC)
#define _C1FIFOCON18      (_SRFS_ADDR(1) + 0xB7D0)
#define _C1FIFOCON18CLR   (_SRFS_ADDR(1) + 0xB7D4)
#define _C1FIFOCON18SET   (_SRFS_ADDR(1) + 0xB7D8)
#define _C1FIFOCON18INV   (_SRFS_ADDR(1) + 0xB7DC)
#define _C1FIFOINT18      (_SRFS_ADDR(1) + 0xB7E0)
#define _C1FIFOINT18CLR   (_SRFS_ADDR(1) + 0xB7E4)
#define _C1FIFOINT18SET   (_SRFS_ADDR(1) + 0xB7E8)
#define _C1FIFOINT18INV   (_SRFS_ADDR(1) + 0xB7EC)
#define _C1FIFOUA18       (_SRFS_ADDR(1) + 0xB7F0)
#define _C1FIFOUA18CLR    (_SRFS_ADDR(1) + 0xB7F4)
#define _C1FIFOUA18SET    (_SRFS_ADDR(1) + 0xB7F8)
#define _C1FIFOUA18INV    (_SRFS_ADDR(1) + 0xB7FC)
#define _C1FIFOCI18       (_SRFS_ADDR(1) + 0xB800)
#define _C1FIFOCI18CLR    (_SRFS_ADDR(1) + 0xB804)
#define _C1FIFOCI18SET    (_SRFS_ADDR(1) + 0xB808)
#define _C1FIFOCI18INV    (_SRFS_ADDR(1) + 0xB80C)
#define _C1FIFOCON19      (_SRFS_ADDR(1) + 0xB810)
#define _C1FIFOCON19CLR   (_SRFS_ADDR(1) + 0xB814)
#define _C1FIFOCON19SET   (_SRFS_ADDR(1) + 0xB818)
#define _C1FIFOCON19INV   (_SRFS_ADDR(1) + 0xB81C)
#define _C1FIFOINT19      (_SRFS_ADDR(1) + 0xB820)
#define _C1FIFOINT19CLR   (_SRFS_ADDR(1) + 0xB824)
#define _C1FIFOINT19SET   (_SRFS_ADDR(1) + 0xB828)
#define _C1FIFOINT19INV   (_SRFS_ADDR(1) + 0xB82C)
#define _C1FIFOUA19       (_SRFS_ADDR(1) + 0xB830)
#define _C1FIFOUA19CLR    (_SRFS_ADDR(1) + 0xB834)
#define _C1FIFOUA19SET    (_SRFS_ADDR(1) + 0xB838)
#define _C1FIFOUA19INV    (_SRFS_ADDR(1) + 0xB83C)
#define _C1FIFOCI19       (_SRFS_ADDR(1) + 0xB840)
#define _C1FIFOCI19CLR    (_SRFS_ADDR(1) + 0xB844)
#define _C1FIFOCI19SET    (_SRFS_ADDR(1) + 0xB848)
#define _C1FIFOCI19INV    (_SRFS_ADDR(1) + 0xB84C)
#define _C1FIFOCON20      (_SRFS_ADDR(1) + 0xB850)
#define _C1FIFOCON20CLR   (_SRFS_ADDR(1) + 0xB854)
#define _C1FIFOCON20SET   (_SRFS_ADDR(1) + 0xB858)
#define _C1FIFOCON20INV   (_SRFS_ADDR(1) + 0xB85C)
#define _C1FIFOINT20      (_SRFS_ADDR(1) + 0xB860)
#define _C1FIFOINT20CLR   (_SRFS_ADDR(1) + 0xB864)
#define _C1FIFOINT20SET   (_SRFS_ADDR(1) + 0xB868)
#define _C1FIFOINT20INV   (_SRFS_ADDR(1) + 0xB86C)
#define _C1FIFOUA20       (_SRFS_ADDR(1) + 0xB870)
#define _C1FIFOUA20CLR    (_SRFS_ADDR(1) + 0xB874)
#define _C1FIFOUA20SET    (_SRFS_ADDR(1) + 0xB878)
#define _C1FIFOUA20INV    (_SRFS_ADDR(1) + 0xB87C)
#define _C1FIFOCI20       (_SRFS_ADDR(1) + 0xB880)
#define _C1FIFOCI20CLR    (_SRFS_ADDR(1) + 0xB884)
#define _C1FIFOCI20SET    (_SRFS_ADDR(1) + 0xB888)
#define _C1FIFOCI20INV    (_SRFS_ADDR(1) + 0xB88C)
#define _C1FIFOCON21      (_SRFS_ADDR(1) + 0xB890)
#define _C1FIFOCON21CLR   (_SRFS_ADDR(1) + 0xB894)
#define _C1FIFOCON21SET   (_SRFS_ADDR(1) + 0xB898)
#define _C1FIFOCON21INV   (_SRFS_ADDR(1) + 0xB89C)
#define _C1FIFOINT21      (_SRFS_ADDR(1) + 0xB8A0)
#define _C1FIFOINT21CLR   (_SRFS_ADDR(1) + 0xB8A4)
#define _C1FIFOINT21SET   (_SRFS_ADDR(1) + 0xB8A8)
#define _C1FIFOINT21INV   (_SRFS_ADDR(1) + 0xB8AC)
#define _C1FIFOUA21       (_SRFS_ADDR(1) + 0xB8B0)
#define _C1FIFOUA21CLR    (_SRFS_ADDR(1) + 0xB8B4)
#define _C1FIFOUA21SET    (_SRFS_ADDR(1) + 0xB8B8)
#define _C1FIFOUA21INV    (_SRFS_ADDR(1) + 0xB8BC)
#define _C1FIFOCI21       (_SRFS_ADDR(1) + 0xB8C0)
#define _C1FIFOCI21CLR    (_SRFS_ADDR(1) + 0xB8C4)
#define _C1FIFOCI21SET    (_SRFS_ADDR(1) + 0xB8C8)
#define _C1FIFOCI21INV    (_SRFS_ADDR(1) + 0xB8CC)
#define _C1FIFOCON22      (_SRFS_ADDR(1) + 0xB8D0)
#define _C1FIFOCON22CLR   (_SRFS_ADDR(1) + 0xB8D4)
#define _C1FIFOCON22SET   (_SRFS_ADDR(1) + 0xB8D8)
#define _C1FIFOCON22INV   (_SRFS_ADDR(1) + 0xB8DC)
#define _C1FIFOINT22      (_SRFS_ADDR(1) + 0xB8E0)
#define _C1FIFOINT22CLR   (_SRFS_ADDR(1) + 0xB8E4)
#define _C1FIFOINT22SET   (_SRFS_ADDR(1) + 0xB8E8)
#define _C1FIFOINT22INV   (_SRFS_ADDR(1) + 0xB8EC)
#define _C1FIFOUA22       (_SRFS_ADDR(1) + 0xB8F0)
#define _C1FIFOUA22CLR    (_SRFS_ADDR(1) + 0xB8F4)
#define _C1FIFOUA22SET    (_SRFS_ADDR(1) + 0xB8F8)
#define _C1FIFOUA22INV    (_SRFS_ADDR(1) + 0xB8FC)
#define _C1FIFOCI22       (_SRFS_ADDR(1) + 0xB900)
#define _C1FIFOCI22CLR    (_SRFS_ADDR(1) + 0xB904)
#define _C1FIFOCI22SET    (_SRFS_ADDR(1) + 0xB908)
#define _C1FIFOCI22INV    (_SRFS_ADDR(1) + 0xB90C)
#define _C1FIFOCON23      (_SRFS_ADDR(1) + 0xB910)
#define _C1FIFOCON23CLR   (_SRFS_ADDR(1) + 0xB914)
#define _C1FIFOCON23SET   (_SRFS_ADDR(1) + 0xB918)
#define _C1FIFOCON23INV   (_SRFS_ADDR(1) + 0xB91C)
#define _C1FIFOINT23      (_SRFS_ADDR(1) + 0xB920)
#define _C1FIFOINT23CLR   (_SRFS_ADDR(1) + 0xB924)
#define _C1FIFOINT23SET   (_SRFS_ADDR(1) + 0xB928)
#define _C1FIFOINT23INV   (_SRFS_ADDR(1) + 0xB92C)
#define _C1FIFOUA23       (_SRFS_ADDR(1) + 0xB930)
#define _C1FIFOUA23CLR    (_SRFS_ADDR(1) + 0xB934)
#define _C1FIFOUA23SET    (_SRFS_ADDR(1) + 0xB938)
#define _C1FIFOUA23INV    (_SRFS_ADDR(1) + 0xB93C)
#define _C1FIFOCI23       (_SRFS_ADDR(1) + 0xB940)
#define _C1FIFOCI23CLR    (_SRFS_ADDR(1) + 0xB944)
#define _C1FIFOCI23SET    (_SRFS_ADDR(1) + 0xB948)
#define _C1FIFOCI23INV    (_SRFS_ADDR(1) + 0xB94C)
#define _C1FIFOCON24      (_SRFS_ADDR(1) + 0xB950)
#define _C1FIFOCON24CLR   (_SRFS_ADDR(1) + 0xB954)
#define _C1FIFOCON24SET   (_SRFS_ADDR(1) + 0xB958)
#define _C1FIFOCON24INV   (_SRFS_ADDR(1) + 0xB95C)
#define _C1FIFOINT24      (_SRFS_ADDR(1) + 0xB960)
#define _C1FIFOINT24CLR   (_SRFS_ADDR(1) + 0xB964)
#define _C1FIFOINT24SET   (_SRFS_ADDR(1) + 0xB968)
#define _C1FIFOINT24INV   (_SRFS_ADDR(1) + 0xB96C)
#define _C1FIFOUA24       (_SRFS_ADDR(1) + 0xB970)
#define _C1FIFOUA24CLR    (_SRFS_ADDR(1) + 0xB974)
#define _C1FIFOUA24SET    (_SRFS_ADDR(1) + 0xB978)
#define _C1FIFOUA24INV    (_SRFS_ADDR(1) + 0xB97C)
#define _C1FIFOCI24       (_SRFS_ADDR(1) + 0xB980)
#define _C1FIFOCI24CLR    (_SRFS_ADDR(1) + 0xB984)
#define _C1FIFOCI24SET    (_SRFS_ADDR(1) + 0xB988)
#define _C1FIFOCI24INV    (_SRFS_ADDR(1) + 0xB98C)
#define _C1FIFOCON25      (_SRFS_ADDR(1) + 0xB990)
#define _C1FIFOCON25CLR   (_SRFS_ADDR(1) + 0xB994)
#define _C1FIFOCON25SET   (_SRFS_ADDR(1) + 0xB998)
#define _C1FIFOCON25INV   (_SRFS_ADDR(1) + 0xB99C)
#define _C1FIFOINT25      (_SRFS_ADDR(1) + 0xB9A0)
#define _C1FIFOINT25CLR   (_SRFS_ADDR(1) + 0xB9A4)
#define _C1FIFOINT25SET   (_SRFS_ADDR(1) + 0xB9A8)
#define _C1FIFOINT25INV   (_SRFS_ADDR(1) + 0xB9AC)
#define _C1FIFOUA25       (_SRFS_ADDR(1) + 0xB9B0)
#define _C1FIFOUA25CLR    (_SRFS_ADDR(1) + 0xB9B4)
#define _C1FIFOUA25SET    (_SRFS_ADDR(1) + 0xB9B8)
#define _C1FIFOUA25INV    (_SRFS_ADDR(1) + 0xB9BC)
#define _C1FIFOCI25       (_SRFS_ADDR(1) + 0xB9C0)
#define _C1FIFOCI25CLR    (_SRFS_ADDR(1) + 0xB9C4)
#define _C1FIFOCI25SET    (_SRFS_ADDR(1) + 0xB9C8)
#define _C1FIFOCI25INV    (_SRFS_ADDR(1) + 0xB9CC)
#define _C1FIFOCON26      (_SRFS_ADDR(1) + 0xB9D0)
#define _C1FIFOCON26CLR   (_SRFS_ADDR(1) + 0xB9D4)
#define _C1FIFOCON26SET   (_SRFS_ADDR(1) + 0xB9D8)
#define _C1FIFOCON26INV   (_SRFS_ADDR(1) + 0xB9DC)
#define _C1FIFOINT26      (_SRFS_ADDR(1) + 0xB9E0)
#define _C1FIFOINT26CLR   (_SRFS_ADDR(1) + 0xB9E4)
#define _C1FIFOINT26SET   (_SRFS_ADDR(1) + 0xB9E8)
#define _C1FIFOINT26INV   (_SRFS_ADDR(1) + 0xB9EC)
#define _C1FIFOUA26       (_SRFS_ADDR(1) + 0xB9F0)
#define _C1FIFOUA26CLR    (_SRFS_ADDR(1) + 0xB9F4)
#define _C1FIFOUA26SET    (_SRFS_ADDR(1) + 0xB9F8)
#define _C1FIFOUA26INV    (_SRFS_ADDR(1) + 0xB9FC)
#define _C1FIFOCI26       (_SRFS_ADDR(1) + 0xBA00)
#define _C1FIFOCI26CLR    (_SRFS_ADDR(1) + 0xBA04)
#define _C1FIFOCI26SET    (_SRFS_ADDR(1) + 0xBA08)
#define _C1FIFOCI26INV    (_SRFS_ADDR(1) + 0xBA0C)
#define _C1FIFOCON27      (_SRFS_ADDR(1) + 0xBA10)
#define _C1FIFOCON27CLR   (_SRFS_ADDR(1) + 0xBA14)
#define _C1FIFOCON27SET   (_SRFS_ADDR(1) + 0xBA18)
#define _C1FIFOCON27INV   (_SRFS_ADDR(1) + 0xBA1C)
#define _C1FIFOINT27      (_SRFS_ADDR(1) + 0xBA20)
#define _C1FIFOINT27CLR   (_SRFS_ADDR(1) + 0xBA24)
#define _C1FIFOINT27SET   (_SRFS_ADDR(1) + 0xBA28)
#define _C1FIFOINT27INV   (_SRFS_ADDR(1) + 0xBA2C)
#define _C1FIFOUA27       (_SRFS_ADDR(1) + 0xBA30)
#define _C1FIFOUA27CLR    (_SRFS_ADDR(1) + 0xBA34)
#define _C1FIFOUA27SET    (_SRFS_ADDR(1) + 0xBA38)
#define _C1FIFOUA27INV    (_SRFS_ADDR(1) + 0xBA3C)
#define _C1FIFOCI27       (_SRFS_ADDR(1) + 0xBA40)
#define _C1FIFOCI27CLR    (_SRFS_ADDR(1) + 0xBA44)
#define _C1FIFOCI27SET    (_SRFS_ADDR(1) + 0xBA48)
#define _C1FIFOCI27INV    (_SRFS_ADDR(1) + 0xBA4C)
#define _C1FIFOCON28      (_SRFS_ADDR(1) + 0xBA50)
#define _C1FIFOCON28CLR   (_SRFS_ADDR(1) + 0xBA54)
#define _C1FIFOCON28SET   (_SRFS_ADDR(1) + 0xBA58)
#define _C1FIFOCON28INV   (_SRFS_ADDR(1) + 0xBA5C)
#define _C1FIFOINT28      (_SRFS_ADDR(1) + 0xBA60)
#define _C1FIFOINT28CLR   (_SRFS_ADDR(1) + 0xBA64)
#define _C1FIFOINT28SET   (_SRFS_ADDR(1) + 0xBA68)
#define _C1FIFOINT28INV   (_SRFS_ADDR(1) + 0xBA6C)
#define _C1FIFOUA28       (_SRFS_ADDR(1) + 0xBA70)
#define _C1FIFOUA28CLR    (_SRFS_ADDR(1) + 0xBA74)
#define _C1FIFOUA28SET    (_SRFS_ADDR(1) + 0xBA78)
#define _C1FIFOUA28INV    (_SRFS_ADDR(1) + 0xBA7C)
#define _C1FIFOCI28       (_SRFS_ADDR(1) + 0xBA80)
#define _C1FIFOCI28CLR    (_SRFS_ADDR(1) + 0xBA84)
#define _C1FIFOCI28SET    (_SRFS_ADDR(1) + 0xBA88)
#define _C1FIFOCI28INV    (_SRFS_ADDR(1) + 0xBA8C)
#define _C1FIFOCON29      (_SRFS_ADDR(1) + 0xBA90)
#define _C1FIFOCON29CLR   (_SRFS_ADDR(1) + 0xBA94)
#define _C1FIFOCON29SET   (_SRFS_ADDR(1) + 0xBA98)
#define _C1FIFOCON29INV   (_SRFS_ADDR(1) + 0xBA9C)
#define _C1FIFOINT29      (_SRFS_ADDR(1) + 0xBAA0)
#define _C1FIFOINT29CLR   (_SRFS_ADDR(1) + 0xBAA4)
#define _C1FIFOINT29SET   (_SRFS_ADDR(1) + 0xBAA8)
#define _C1FIFOINT29INV   (_SRFS_ADDR(1) + 0xBAAC)
#define _C1FIFOUA29       (_SRFS_ADDR(1) + 0xBAB0)
#define _C1FIFOUA29CLR    (_SRFS_ADDR(1) + 0xBAB4)
#define _C1FIFOUA29SET    (_SRFS_ADDR(1) + 0xBAB8)
#define _C1FIFOUA29INV    (_SRFS_ADDR(1) + 0xBABC)
#define _C1FIFOCI29       (_SRFS_ADDR(1) + 0xBAC0)
#define _C1FIFOCI29CLR    (_SRFS_ADDR(1) + 0xBAC4)
#define _C1FIFOCI29SET    (_SRFS_ADDR(1) + 0xBAC8)
#define _C1FIFOCI29INV    (_SRFS_ADDR(1) + 0xBACC)
#define _C1FIFOCON30      (_SRFS_ADDR(1) + 0xBAD0)
#define _C1FIFOCON30CLR   (_SRFS_ADDR(1) + 0xBAD4)
#define _C1FIFOCON30SET   (_SRFS_ADDR(1) + 0xBAD8)
#define _C1FIFOCON30INV   (_SRFS_ADDR(1) + 0xBADC)
#define _C1FIFOINT30      (_SRFS_ADDR(1) + 0xBAE0)
#define _C1FIFOINT30CLR   (_SRFS_ADDR(1) + 0xBAE4)
#define _C1FIFOINT30SET   (_SRFS_ADDR(1) + 0xBAE8)
#define _C1FIFOINT30INV   (_SRFS_ADDR(1) + 0xBAEC)
#define _C1FIFOUA30       (_SRFS_ADDR(1) + 0xBAF0)
#define _C1FIFOUA30CLR    (_SRFS_ADDR(1) + 0xBAF4)
#define _C1FIFOUA30SET    (_SRFS_ADDR(1) + 0xBAF8)
#define _C1FIFOUA30INV    (_SRFS_ADDR(1) + 0xBAFC)
#define _C1FIFOCI30       (_SRFS_ADDR(1) + 0xBB00)
#define _C1FIFOCI30CLR    (_SRFS_ADDR(1) + 0xBB04)
#define _C1FIFOCI30SET    (_SRFS_ADDR(1) + 0xBB08)
#define _C1FIFOCI30INV    (_SRFS_ADDR(1) + 0xBB0C)
#define _C1FIFOCON31      (_SRFS_ADDR(1) + 0xBB10)
#define _C1FIFOCON31CLR   (_SRFS_ADDR(1) + 0xBB14)
#define _C1FIFOCON31SET   (_SRFS_ADDR(1) + 0xBB18)
#define _C1FIFOCON31INV   (_SRFS_ADDR(1) + 0xBB1C)
#define _C1FIFOINT31      (_SRFS_ADDR(1) + 0xBB20)
#define _C1FIFOINT31CLR   (_SRFS_ADDR(1) + 0xBB24)
#define _C1FIFOINT31SET   (_SRFS_ADDR(1) + 0xBB28)
#define _C1FIFOINT31INV   (_SRFS_ADDR(1) + 0xBB2C)
#define _C1FIFOUA31       (_SRFS_ADDR(1) + 0xBB30)
#define _C1FIFOUA31CLR    (_SRFS_ADDR(1) + 0xBB34)
#define _C1FIFOUA31SET    (_SRFS_ADDR(1) + 0xBB38)
#define _C1FIFOUA31INV    (_SRFS_ADDR(1) + 0xBB3C)
#define _C1FIFOCI31       (_SRFS_ADDR(1) + 0xBB40)
#define _C1FIFOCI31CLR    (_SRFS_ADDR(1) + 0xBB44)
#define _C1FIFOCI31SET    (_SRFS_ADDR(1) + 0xBB48)
#define _C1FIFOCI31INV    (_SRFS_ADDR(1) + 0xBB4C)
#define _C2CON            (_SRFS_ADDR(1) + 0xC000)
#define _C2CONCLR         (_SRFS_ADDR(1) + 0xC004)
#define _C2CONSET         (_SRFS_ADDR(1) + 0xC008)
#define _C2CONINV         (_SRFS_ADDR(1) + 0xC00C)
#define _C2CFG            (_SRFS_ADDR(1) + 0xC010)
#define _C2CFGCLR         (_SRFS_ADDR(1) + 0xC014)
#define _C2CFGSET         (_SRFS_ADDR(1) + 0xC018)
#define _C2CFGINV         (_SRFS_ADDR(1) + 0xC01C)
#define _C2INT            (_SRFS_ADDR(1) + 0xC020)
#define _C2INTCLR         (_SRFS_ADDR(1) + 0xC024)
#define _C2INTSET         (_SRFS_ADDR(1) + 0xC028)
#define _C2INTINV         (_SRFS_ADDR(1) + 0xC02C)
#define _C2VEC            (_SRFS_ADDR(1) + 0xC030)
#define _C2VECCLR         (_SRFS_ADDR(1) + 0xC034)
#define _C2VECSET         (_SRFS_ADDR(1) + 0xC038)
#define _C2VECINV         (_SRFS_ADDR(1) + 0xC03C)
#define _C2TREC           (_SRFS_ADDR(1) + 0xC040)
#define _C2TRECCLR        (_SRFS_ADDR(1) + 0xC044)
#define _C2TRECSET        (_SRFS_ADDR(1) + 0xC048)
#define _C2TRECINV        (_SRFS_ADDR(1) + 0xC04C)
#define _C2FSTAT          (_SRFS_ADDR(1) + 0xC050)
#define _C2FSTATCLR       (_SRFS_ADDR(1) + 0xC054)
#define _C2FSTATSET       (_SRFS_ADDR(1) + 0xC058)
#define _C2FSTATINV       (_SRFS_ADDR(1) + 0xC05C)
#define _C2RXOVF          (_SRFS_ADDR(1) + 0xC060)
#define _C2RXOVFCLR       (_SRFS_ADDR(1) + 0xC064)
#define _C2RXOVFSET       (_SRFS_ADDR(1) + 0xC068)
#define _C2RXOVFINV       (_SRFS_ADDR(1) + 0xC06C)
#define _C2TMR            (_SRFS_ADDR(1) + 0xC070)
#define _C2TMRCLR         (_SRFS_ADDR(1) + 0xC074)
#define _C2TMRSET         (_SRFS_ADDR(1) + 0xC078)
#define _C2TMRINV         (_SRFS_ADDR(1) + 0xC07C)
#define _C2RXM0           (_SRFS_ADDR(1) + 0xC080)
#define _C2RXM0CLR        (_SRFS_ADDR(1) + 0xC084)
#define _C2RXM0SET        (_SRFS_ADDR(1) + 0xC088)
#define _C2RXM0INV        (_SRFS_ADDR(1) + 0xC08C)
#define _C2RXM1           (_SRFS_ADDR(1) + 0xC090)
#define _C2RXM1CLR        (_SRFS_ADDR(1) + 0xC094)
#define _C2RXM1SET        (_SRFS_ADDR(1) + 0xC098)
#define _C2RXM1INV        (_SRFS_ADDR(1) + 0xC09C)
#define _C2RXM2           (_SRFS_ADDR(1) + 0xC0A0)
#define _C2RXM2CLR        (_SRFS_ADDR(1) + 0xC0A4)
#define _C2RXM2SET        (_SRFS_ADDR(1) + 0xC0A8)
#define _C2RXM2INV        (_SRFS_ADDR(1) + 0xC0AC)
#define _C2RXM3           (_SRFS_ADDR(1) + 0xC0B0)
#define _C2RXM3CLR        (_SRFS_ADDR(1) + 0xC0B4)
#define _C2RXM3SET        (_SRFS_ADDR(1) + 0xC0B8)
#define _C2RXM3INV        (_SRFS_ADDR(1) + 0xC0BC)
#define _C2FLTCON0        (_SRFS_ADDR(1) + 0xC0C0)
#define _C2FLTCON0CLR     (_SRFS_ADDR(1) + 0xC0C4)
#define _C2FLTCON0SET     (_SRFS_ADDR(1) + 0xC0C8)
#define _C2FLTCON0INV     (_SRFS_ADDR(1) + 0xC0CC)
#define _C2FLTCON1        (_SRFS_ADDR(1) + 0xC0D0)
#define _C2FLTCON1CLR     (_SRFS_ADDR(1) + 0xC0D4)
#define _C2FLTCON1SET     (_SRFS_ADDR(1) + 0xC0D8)
#define _C2FLTCON1INV     (_SRFS_ADDR(1) + 0xC0DC)
#define _C2FLTCON2        (_SRFS_ADDR(1) + 0xC0E0)
#define _C2FLTCON2CLR     (_SRFS_ADDR(1) + 0xC0E4)
#define _C2FLTCON2SET     (_SRFS_ADDR(1) + 0xC0E8)
#define _C2FLTCON2INV     (_SRFS_ADDR(1) + 0xC0EC)
#define _C2FLTCON3        (_SRFS_ADDR(1) + 0xC0F0)
#define _C2FLTCON3CLR     (_SRFS_ADDR(1) + 0xC0F4)
#define _C2FLTCON3SET     (_SRFS_ADDR(1) + 0xC0F8)
#define _C2FLTCON3INV     (_SRFS_ADDR(1) + 0xC0FC)
#define _C2FLTCON4        (_SRFS_ADDR(1) + 0xC100)
#define _C2FLTCON4CLR     (_SRFS_ADDR(1) + 0xC104)
#define _C2FLTCON4SET     (_SRFS_ADDR(1) + 0xC108)
#define _C2FLTCON4INV     (_SRFS_ADDR(1) + 0xC10C)
#define _C2FLTCON5        (_SRFS_ADDR(1) + 0xC110)
#define _C2FLTCON5CLR     (_SRFS_ADDR(1) + 0xC114)
#define _C2FLTCON5SET     (_SRFS_ADDR(1) + 0xC118)
#define _C2FLTCON5INV     (_SRFS_ADDR(1) + 0xC11C)
#define _C2FLTCON6        (_SRFS_ADDR(1) + 0xC120)
#define _C2FLTCON6CLR     (_SRFS_ADDR(1) + 0xC124)
#define _C2FLTCON6SET     (_SRFS_ADDR(1) + 0xC128)
#define _C2FLTCON6INV     (_SRFS_ADDR(1) + 0xC12C)
#define _C2FLTCON7        (_SRFS_ADDR(1) + 0xC130)
#define _C2FLTCON7CLR     (_SRFS_ADDR(1) + 0xC134)
#define _C2FLTCON7SET     (_SRFS_ADDR(1) + 0xC138)
#define _C2FLTCON7INV     (_SRFS_ADDR(1) + 0xC13C)
#define _C2RXF0           (_SRFS_ADDR(1) + 0xC140)
#define _C2RXF0CLR        (_SRFS_ADDR(1) + 0xC144)
#define _C2RXF0SET        (_SRFS_ADDR(1) + 0xC148)
#define _C2RXF0INV        (_SRFS_ADDR(1) + 0xC14C)
#define _C2RXF1           (_SRFS_ADDR(1) + 0xC150)
#define _C2RXF1CLR        (_SRFS_ADDR(1) + 0xC154)
#define _C2RXF1SET        (_SRFS_ADDR(1) + 0xC158)
#define _C2RXF1INV        (_SRFS_ADDR(1) + 0xC15C)
#define _C2RXF2           (_SRFS_ADDR(1) + 0xC160)
#define _C2RXF2CLR        (_SRFS_ADDR(1) + 0xC164)
#define _C2RXF2SET        (_SRFS_ADDR(1) + 0xC168)
#define _C2RXF2INV        (_SRFS_ADDR(1) + 0xC16C)
#define _C2RXF3           (_SRFS_ADDR(1) + 0xC170)
#define _C2RXF3CLR        (_SRFS_ADDR(1) + 0xC174)
#define _C2RXF3SET        (_SRFS_ADDR(1) + 0xC178)
#define _C2RXF3INV        (_SRFS_ADDR(1) + 0xC17C)
#define _C2RXF4           (_SRFS_ADDR(1) + 0xC180)
#define _C2RXF4CLR        (_SRFS_ADDR(1) + 0xC184)
#define _C2RXF4SET        (_SRFS_ADDR(1) + 0xC188)
#define _C2RXF4INV        (_SRFS_ADDR(1) + 0xC18C)
#define _C2RXF5           (_SRFS_ADDR(1) + 0xC190)
#define _C2RXF5CLR        (_SRFS_ADDR(1) + 0xC194)
#define _C2RXF5SET        (_SRFS_ADDR(1) + 0xC198)
#define _C2RXF5INV        (_SRFS_ADDR(1) + 0xC19C)
#define _C2RXF6           (_SRFS_ADDR(1) + 0xC1A0)
#define _C2RXF6CLR        (_SRFS_ADDR(1) + 0xC1A4)
#define _C2RXF6SET        (_SRFS_ADDR(1) + 0xC1A8)
#define _C2RXF6INV        (_SRFS_ADDR(1) + 0xC1AC)
#define _C2RXF7           (_SRFS_ADDR(1) + 0xC1B0)
#define _C2RXF7CLR        (_SRFS_ADDR(1) + 0xC1B4)
#define _C2RXF7SET        (_SRFS_ADDR(1) + 0xC1B8)
#define _C2RXF7INV        (_SRFS_ADDR(1) + 0xC1BC)
#define _C2RXF8           (_SRFS_ADDR(1) + 0xC1C0)
#define _C2RXF8CLR        (_SRFS_ADDR(1) + 0xC1C4)
#define _C2RXF8SET        (_SRFS_ADDR(1) + 0xC1C8)
#define _C2RXF8INV        (_SRFS_ADDR(1) + 0xC1CC)
#define _C2RXF9           (_SRFS_ADDR(1) + 0xC1D0)
#define _C2RXF9CLR        (_SRFS_ADDR(1) + 0xC1D4)
#define _C2RXF9SET        (_SRFS_ADDR(1) + 0xC1D8)
#define _C2RXF9INV        (_SRFS_ADDR(1) + 0xC1DC)
#define _C2RXF10          (_SRFS_ADDR(1) + 0xC1E0)
#define _C2RXF10CLR       (_SRFS_ADDR(1) + 0xC1E4)
#define _C2RXF10SET       (_SRFS_ADDR(1) + 0xC1E8)
#define _C2RXF10INV       (_SRFS_ADDR(1) + 0xC1EC)
#define _C2RXF11          (_SRFS_ADDR(1) + 0xC1F0)
#define _C2RXF11CLR       (_SRFS_ADDR(1) + 0xC1F4)
#define _C2RXF11SET       (_SRFS_ADDR(1) + 0xC1F8)
#define _C2RXF11INV       (_SRFS_ADDR(1) + 0xC1FC)
#define _C2RXF12          (_SRFS_ADDR(1) + 0xC200)
#define _C2RXF12CLR       (_SRFS_ADDR(1) + 0xC204)
#define _C2RXF12SET       (_SRFS_ADDR(1) + 0xC208)
#define _C2RXF12INV       (_SRFS_ADDR(1) + 0xC20C)
#define _C2RXF13          (_SRFS_ADDR(1) + 0xC210)
#define _C2RXF13CLR       (_SRFS_ADDR(1) + 0xC214)
#define _C2RXF13SET       (_SRFS_ADDR(1) + 0xC218)
#define _C2RXF13INV       (_SRFS_ADDR(1) + 0xC21C)
#define _C2RXF14          (_SRFS_ADDR(1) + 0xC220)
#define _C2RXF14CLR       (_SRFS_ADDR(1) + 0xC224)
#define _C2RXF14SET       (_SRFS_ADDR(1) + 0xC228)
#define _C2RXF14INV       (_SRFS_ADDR(1) + 0xC22C)
#define _C2RXF15          (_SRFS_ADDR(1) + 0xC230)
#define _C2RXF15CLR       (_SRFS_ADDR(1) + 0xC234)
#define _C2RXF15SET       (_SRFS_ADDR(1) + 0xC238)
#define _C2RXF15INV       (_SRFS_ADDR(1) + 0xC23C)
#define _C2RXF16          (_SRFS_ADDR(1) + 0xC240)
#define _C2RXF16CLR       (_SRFS_ADDR(1) + 0xC244)
#define _C2RXF16SET       (_SRFS_ADDR(1) + 0xC248)
#define _C2RXF16INV       (_SRFS_ADDR(1) + 0xC24C)
#define _C2RXF17          (_SRFS_ADDR(1) + 0xC250)
#define _C2RXF17CLR       (_SRFS_ADDR(1) + 0xC254)
#define _C2RXF17SET       (_SRFS_ADDR(1) + 0xC258)
#define _C2RXF17INV       (_SRFS_ADDR(1) + 0xC25C)
#define _C2RXF18          (_SRFS_ADDR(1) + 0xC260)
#define _C2RXF18CLR       (_SRFS_ADDR(1) + 0xC264)
#define _C2RXF18SET       (_SRFS_ADDR(1) + 0xC268)
#define _C2RXF18INV       (_SRFS_ADDR(1) + 0xC26C)
#define _C2RXF19          (_SRFS_ADDR(1) + 0xC270)
#define _C2RXF19CLR       (_SRFS_ADDR(1) + 0xC274)
#define _C2RXF19SET       (_SRFS_ADDR(1) + 0xC278)
#define _C2RXF19INV       (_SRFS_ADDR(1) + 0xC27C)
#define _C2RXF20          (_SRFS_ADDR(1) + 0xC280)
#define _C2RXF20CLR       (_SRFS_ADDR(1) + 0xC284)
#define _C2RXF20SET       (_SRFS_ADDR(1) + 0xC288)
#define _C2RXF20INV       (_SRFS_ADDR(1) + 0xC28C)
#define _C2RXF21          (_SRFS_ADDR(1) + 0xC290)
#define _C2RXF21CLR       (_SRFS_ADDR(1) + 0xC294)
#define _C2RXF21SET       (_SRFS_ADDR(1) + 0xC298)
#define _C2RXF21INV       (_SRFS_ADDR(1) + 0xC29C)
#define _C2RXF22          (_SRFS_ADDR(1) + 0xC2A0)
#define _C2RXF22CLR       (_SRFS_ADDR(1) + 0xC2A4)
#define _C2RXF22SET       (_SRFS_ADDR(1) + 0xC2A8)
#define _C2RXF22INV       (_SRFS_ADDR(1) + 0xC2AC)
#define _C2RXF23          (_SRFS_ADDR(1) + 0xC2B0)
#define _C2RXF23CLR       (_SRFS_ADDR(1) + 0xC2B4)
#define _C2RXF23SET       (_SRFS_ADDR(1) + 0xC2B8)
#define _C2RXF23INV       (_SRFS_ADDR(1) + 0xC2BC)
#define _C2RXF24          (_SRFS_ADDR(1) + 0xC2C0)
#define _C2RXF24CLR       (_SRFS_ADDR(1) + 0xC2C4)
#define _C2RXF24SET       (_SRFS_ADDR(1) + 0xC2C8)
#define _C2RXF24INV       (_SRFS_ADDR(1) + 0xC2CC)
#define _C2RXF25          (_SRFS_ADDR(1) + 0xC2D0)
#define _C2RXF25CLR       (_SRFS_ADDR(1) + 0xC2D4)
#define _C2RXF25SET       (_SRFS_ADDR(1) + 0xC2D8)
#define _C2RXF25INV       (_SRFS_ADDR(1) + 0xC2DC)
#define _C2RXF26          (_SRFS_ADDR(1) + 0xC2E0)
#define _C2RXF26CLR       (_SRFS_ADDR(1) + 0xC2E4)
#define _C2RXF26SET       (_SRFS_ADDR(1) + 0xC2E8)
#define _C2RXF26INV       (_SRFS_ADDR(1) + 0xC2EC)
#define _C2RXF27          (_SRFS_ADDR(1) + 0xC2F0)
#define _C2RXF27CLR       (_SRFS_ADDR(1) + 0xC2F4)
#define _C2RXF27SET       (_SRFS_ADDR(1) + 0xC2F8)
#define _C2RXF27INV       (_SRFS_ADDR(1) + 0xC2FC)
#define _C2RXF28          (_SRFS_ADDR(1) + 0xC300)
#define _C2RXF28CLR       (_SRFS_ADDR(1) + 0xC304)
#define _C2RXF28SET       (_SRFS_ADDR(1) + 0xC308)
#define _C2RXF28INV       (_SRFS_ADDR(1) + 0xC30C)
#define _C2RXF29          (_SRFS_ADDR(1) + 0xC310)
#define _C2RXF29CLR       (_SRFS_ADDR(1) + 0xC314)
#define _C2RXF29SET       (_SRFS_ADDR(1) + 0xC318)
#define _C2RXF29INV       (_SRFS_ADDR(1) + 0xC31C)
#define _C2RXF30          (_SRFS_ADDR(1) + 0xC320)
#define _C2RXF30CLR       (_SRFS_ADDR(1) + 0xC324)
#define _C2RXF30SET       (_SRFS_ADDR(1) + 0xC328)
#define _C2RXF30INV       (_SRFS_ADDR(1) + 0xC32C)
#define _C2RXF31          (_SRFS_ADDR(1) + 0xC330)
#define _C2RXF31CLR       (_SRFS_ADDR(1) + 0xC334)
#define _C2RXF31SET       (_SRFS_ADDR(1) + 0xC338)
#define _C2RXF31INV       (_SRFS_ADDR(1) + 0xC33C)
#define _C2FIFOBA         (_SRFS_ADDR(1) + 0xC340)
#define _C2FIFOBACLR      (_SRFS_ADDR(1) + 0xC344)
#define _C2FIFOBASET      (_SRFS_ADDR(1) + 0xC348)
#define _C2FIFOBAINV      (_SRFS_ADDR(1) + 0xC34C)
#define _C2FIFOCON0       (_SRFS_ADDR(1) + 0xC350)
#define _C2FIFOCON0CLR    (_SRFS_ADDR(1) + 0xC354)
#define _C2FIFOCON0SET    (_SRFS_ADDR(1) + 0xC358)
#define _C2FIFOCON0INV    (_SRFS_ADDR(1) + 0xC35C)
#define _C2FIFOINT0       (_SRFS_ADDR(1) + 0xC360)
#define _C2FIFOINT0CLR    (_SRFS_ADDR(1) + 0xC364)
#define _C2FIFOINT0SET    (_SRFS_ADDR(1) + 0xC368)
#define _C2FIFOINT0INV    (_SRFS_ADDR(1) + 0xC36C)
#define _C2FIFOUA0        (_SRFS_ADDR(1) + 0xC370)
#define _C2FIFOUA0CLR     (_SRFS_ADDR(1) + 0xC374)
#define _C2FIFOUA0SET     (_SRFS_ADDR(1) + 0xC378)
#define _C2FIFOUA0INV     (_SRFS_ADDR(1) + 0xC37C)
#define _C2FIFOCI0        (_SRFS_ADDR(1) + 0xC380)
#define _C2FIFOCI0CLR     (_SRFS_ADDR(1) + 0xC384)
#define _C2FIFOCI0SET     (_SRFS_ADDR(1) + 0xC388)
#define _C2FIFOCI0INV     (_SRFS_ADDR(1) + 0xC38C)
#define _C2FIFOCON1       (_SRFS_ADDR(1) + 0xC390)
#define _C2FIFOCON1CLR    (_SRFS_ADDR(1) + 0xC394)
#define _C2FIFOCON1SET    (_SRFS_ADDR(1) + 0xC398)
#define _C2FIFOCON1INV    (_SRFS_ADDR(1) + 0xC39C)
#define _C2FIFOINT1       (_SRFS_ADDR(1) + 0xC3A0)
#define _C2FIFOINT1CLR    (_SRFS_ADDR(1) + 0xC3A4)
#define _C2FIFOINT1SET    (_SRFS_ADDR(1) + 0xC3A8)
#define _C2FIFOINT1INV    (_SRFS_ADDR(1) + 0xC3AC)
#define _C2FIFOUA1        (_SRFS_ADDR(1) + 0xC3B0)
#define _C2FIFOUA1CLR     (_SRFS_ADDR(1) + 0xC3B4)
#define _C2FIFOUA1SET     (_SRFS_ADDR(1) + 0xC3B8)
#define _C2FIFOUA1INV     (_SRFS_ADDR(1) + 0xC3BC)
#define _C2FIFOCI1        (_SRFS_ADDR(1) + 0xC3C0)
#define _C2FIFOCI1CLR     (_SRFS_ADDR(1) + 0xC3C4)
#define _C2FIFOCI1SET     (_SRFS_ADDR(1) + 0xC3C8)
#define _C2FIFOCI1INV     (_SRFS_ADDR(1) + 0xC3CC)
#define _C2FIFOCON2       (_SRFS_ADDR(1) + 0xC3D0)
#define _C2FIFOCON2CLR    (_SRFS_ADDR(1) + 0xC3D4)
#define _C2FIFOCON2SET    (_SRFS_ADDR(1) + 0xC3D8)
#define _C2FIFOCON2INV    (_SRFS_ADDR(1) + 0xC3DC)
#define _C2FIFOINT2       (_SRFS_ADDR(1) + 0xC3E0)
#define _C2FIFOINT2CLR    (_SRFS_ADDR(1) + 0xC3E4)
#define _C2FIFOINT2SET    (_SRFS_ADDR(1) + 0xC3E8)
#define _C2FIFOINT2INV    (_SRFS_ADDR(1) + 0xC3EC)
#define _C2FIFOUA2        (_SRFS_ADDR(1) + 0xC3F0)
#define _C2FIFOUA2CLR     (_SRFS_ADDR(1) + 0xC3F4)
#define _C2FIFOUA2SET     (_SRFS_ADDR(1) + 0xC3F8)
#define _C2FIFOUA2INV     (_SRFS_ADDR(1) + 0xC3FC)
#define _C2FIFOCI2        (_SRFS_ADDR(1) + 0xC400)
#define _C2FIFOCI2CLR     (_SRFS_ADDR(1) + 0xC404)
#define _C2FIFOCI2SET     (_SRFS_ADDR(1) + 0xC408)
#define _C2FIFOCI2INV     (_SRFS_ADDR(1) + 0xC40C)
#define _C2FIFOCON3       (_SRFS_ADDR(1) + 0xC410)
#define _C2FIFOCON3CLR    (_SRFS_ADDR(1) + 0xC414)
#define _C2FIFOCON3SET    (_SRFS_ADDR(1) + 0xC418)
#define _C2FIFOCON3INV    (_SRFS_ADDR(1) + 0xC41C)
#define _C2FIFOINT3       (_SRFS_ADDR(1) + 0xC420)
#define _C2FIFOINT3CLR    (_SRFS_ADDR(1) + 0xC424)
#define _C2FIFOINT3SET    (_SRFS_ADDR(1) + 0xC428)
#define _C2FIFOINT3INV    (_SRFS_ADDR(1) + 0xC42C)
#define _C2FIFOUA3        (_SRFS_ADDR(1) + 0xC430)
#define _C2FIFOUA3CLR     (_SRFS_ADDR(1) + 0xC434)
#define _C2FIFOUA3SET     (_SRFS_ADDR(1) + 0xC438)
#define _C2FIFOUA3INV     (_SRFS_ADDR(1) + 0xC43C)
#define _C2FIFOCI3        (_SRFS_ADDR(1) + 0xC440)
#define _C2FIFOCI3CLR     (_SRFS_ADDR(1) + 0xC444)
#define _C2FIFOCI3SET     (_SRFS_ADDR(1) + 0xC448)
#define _C2FIFOCI3INV     (_SRFS_ADDR(1) + 0xC44C)
#define _C2FIFOCON4       (_SRFS_ADDR(1) + 0xC450)
#define _C2FIFOCON4CLR    (_SRFS_ADDR(1) + 0xC454)
#define _C2FIFOCON4SET    (_SRFS_ADDR(1) + 0xC458)
#define _C2FIFOCON4INV    (_SRFS_ADDR(1) + 0xC45C)
#define _C2FIFOINT4       (_SRFS_ADDR(1) + 0xC460)
#define _C2FIFOINT4CLR    (_SRFS_ADDR(1) + 0xC464)
#define _C2FIFOINT4SET    (_SRFS_ADDR(1) + 0xC468)
#define _C2FIFOINT4INV    (_SRFS_ADDR(1) + 0xC46C)
#define _C2FIFOUA4        (_SRFS_ADDR(1) + 0xC470)
#define _C2FIFOUA4CLR     (_SRFS_ADDR(1) + 0xC474)
#define _C2FIFOUA4SET     (_SRFS_ADDR(1) + 0xC478)
#define _C2FIFOUA4INV     (_SRFS_ADDR(1) + 0xC47C)
#define _C2FIFOCI4        (_SRFS_ADDR(1) + 0xC480)
#define _C2FIFOCI4CLR     (_SRFS_ADDR(1) + 0xC484)
#define _C2FIFOCI4SET     (_SRFS_ADDR(1) + 0xC488)
#define _C2FIFOCI4INV     (_SRFS_ADDR(1) + 0xC48C)
#define _C2FIFOCON5       (_SRFS_ADDR(1) + 0xC490)
#define _C2FIFOCON5CLR    (_SRFS_ADDR(1) + 0xC494)
#define _C2FIFOCON5SET    (_SRFS_ADDR(1) + 0xC498)
#define _C2FIFOCON5INV    (_SRFS_ADDR(1) + 0xC49C)
#define _C2FIFOINT5       (_SRFS_ADDR(1) + 0xC4A0)
#define _C2FIFOINT5CLR    (_SRFS_ADDR(1) + 0xC4A4)
#define _C2FIFOINT5SET    (_SRFS_ADDR(1) + 0xC4A8)
#define _C2FIFOINT5INV    (_SRFS_ADDR(1) + 0xC4AC)
#define _C2FIFOUA5        (_SRFS_ADDR(1) + 0xC4B0)
#define _C2FIFOUA5CLR     (_SRFS_ADDR(1) + 0xC4B4)
#define _C2FIFOUA5SET     (_SRFS_ADDR(1) + 0xC4B8)
#define _C2FIFOUA5INV     (_SRFS_ADDR(1) + 0xC4BC)
#define _C2FIFOCI5        (_SRFS_ADDR(1) + 0xC4C0)
#define _C2FIFOCI5CLR     (_SRFS_ADDR(1) + 0xC4C4)
#define _C2FIFOCI5SET     (_SRFS_ADDR(1) + 0xC4C8)
#define _C2FIFOCI5INV     (_SRFS_ADDR(1) + 0xC4CC)
#define _C2FIFOCON6       (_SRFS_ADDR(1) + 0xC4D0)
#define _C2FIFOCON6CLR    (_SRFS_ADDR(1) + 0xC4D4)
#define _C2FIFOCON6SET    (_SRFS_ADDR(1) + 0xC4D8)
#define _C2FIFOCON6INV    (_SRFS_ADDR(1) + 0xC4DC)
#define _C2FIFOINT6       (_SRFS_ADDR(1) + 0xC4E0)
#define _C2FIFOINT6CLR    (_SRFS_ADDR(1) + 0xC4E4)
#define _C2FIFOINT6SET    (_SRFS_ADDR(1) + 0xC4E8)
#define _C2FIFOINT6INV    (_SRFS_ADDR(1) + 0xC4EC)
#define _C2FIFOUA6        (_SRFS_ADDR(1) + 0xC4F0)
#define _C2FIFOUA6CLR     (_SRFS_ADDR(1) + 0xC4F4)
#define _C2FIFOUA6SET     (_SRFS_ADDR(1) + 0xC4F8)
#define _C2FIFOUA6INV     (_SRFS_ADDR(1) + 0xC4FC)
#define _C2FIFOCI6        (_SRFS_ADDR(1) + 0xC500)
#define _C2FIFOCI6CLR     (_SRFS_ADDR(1) + 0xC504)
#define _C2FIFOCI6SET     (_SRFS_ADDR(1) + 0xC508)
#define _C2FIFOCI6INV     (_SRFS_ADDR(1) + 0xC50C)
#define _C2FIFOCON7       (_SRFS_ADDR(1) + 0xC510)
#define _C2FIFOCON7CLR    (_SRFS_ADDR(1) + 0xC514)
#define _C2FIFOCON7SET    (_SRFS_ADDR(1) + 0xC518)
#define _C2FIFOCON7INV    (_SRFS_ADDR(1) + 0xC51C)
#define _C2FIFOINT7       (_SRFS_ADDR(1) + 0xC520)
#define _C2FIFOINT7CLR    (_SRFS_ADDR(1) + 0xC524)
#define _C2FIFOINT7SET    (_SRFS_ADDR(1) + 0xC528)
#define _C2FIFOINT7INV    (_SRFS_ADDR(1) + 0xC52C)
#define _C2FIFOUA7        (_SRFS_ADDR(1) + 0xC530)
#define _C2FIFOUA7CLR     (_SRFS_ADDR(1) + 0xC534)
#define _C2FIFOUA7SET     (_SRFS_ADDR(1) + 0xC538)
#define _C2FIFOUA7INV     (_SRFS_ADDR(1) + 0xC53C)
#define _C2FIFOCI7        (_SRFS_ADDR(1) + 0xC540)
#define _C2FIFOCI7CLR     (_SRFS_ADDR(1) + 0xC544)
#define _C2FIFOCI7SET     (_SRFS_ADDR(1) + 0xC548)
#define _C2FIFOCI7INV     (_SRFS_ADDR(1) + 0xC54C)
#define _C2FIFOCON8       (_SRFS_ADDR(1) + 0xC550)
#define _C2FIFOCON8CLR    (_SRFS_ADDR(1) + 0xC554)
#define _C2FIFOCON8SET    (_SRFS_ADDR(1) + 0xC558)
#define _C2FIFOCON8INV    (_SRFS_ADDR(1) + 0xC55C)
#define _C2FIFOINT8       (_SRFS_ADDR(1) + 0xC560)
#define _C2FIFOINT8CLR    (_SRFS_ADDR(1) + 0xC564)
#define _C2FIFOINT8SET    (_SRFS_ADDR(1) + 0xC568)
#define _C2FIFOINT8INV    (_SRFS_ADDR(1) + 0xC56C)
#define _C2FIFOUA8        (_SRFS_ADDR(1) + 0xC570)
#define _C2FIFOUA8CLR     (_SRFS_ADDR(1) + 0xC574)
#define _C2FIFOUA8SET     (_SRFS_ADDR(1) + 0xC578)
#define _C2FIFOUA8INV     (_SRFS_ADDR(1) + 0xC57C)
#define _C2FIFOCI8        (_SRFS_ADDR(1) + 0xC580)
#define _C2FIFOCI8CLR     (_SRFS_ADDR(1) + 0xC584)
#define _C2FIFOCI8SET     (_SRFS_ADDR(1) + 0xC588)
#define _C2FIFOCI8INV     (_SRFS_ADDR(1) + 0xC58C)
#define _C2FIFOCON9       (_SRFS_ADDR(1) + 0xC590)
#define _C2FIFOCON9CLR    (_SRFS_ADDR(1) + 0xC594)
#define _C2FIFOCON9SET    (_SRFS_ADDR(1) + 0xC598)
#define _C2FIFOCON9INV    (_SRFS_ADDR(1) + 0xC59C)
#define _C2FIFOINT9       (_SRFS_ADDR(1) + 0xC5A0)
#define _C2FIFOINT9CLR    (_SRFS_ADDR(1) + 0xC5A4)
#define _C2FIFOINT9SET    (_SRFS_ADDR(1) + 0xC5A8)
#define _C2FIFOINT9INV    (_SRFS_ADDR(1) + 0xC5AC)
#define _C2FIFOUA9        (_SRFS_ADDR(1) + 0xC5B0)
#define _C2FIFOUA9CLR     (_SRFS_ADDR(1) + 0xC5B4)
#define _C2FIFOUA9SET     (_SRFS_ADDR(1) + 0xC5B8)
#define _C2FIFOUA9INV     (_SRFS_ADDR(1) + 0xC5BC)
#define _C2FIFOCI9        (_SRFS_ADDR(1) + 0xC5C0)
#define _C2FIFOCI9CLR     (_SRFS_ADDR(1) + 0xC5C4)
#define _C2FIFOCI9SET     (_SRFS_ADDR(1) + 0xC5C8)
#define _C2FIFOCI9INV     (_SRFS_ADDR(1) + 0xC5CC)
#define _C2FIFOCON10      (_SRFS_ADDR(1) + 0xC5D0)
#define _C2FIFOCON10CLR   (_SRFS_ADDR(1) + 0xC5D4)
#define _C2FIFOCON10SET   (_SRFS_ADDR(1) + 0xC5D8)
#define _C2FIFOCON10INV   (_SRFS_ADDR(1) + 0xC5DC)
#define _C2FIFOINT10      (_SRFS_ADDR(1) + 0xC5E0)
#define _C2FIFOINT10CLR   (_SRFS_ADDR(1) + 0xC5E4)
#define _C2FIFOINT10SET   (_SRFS_ADDR(1) + 0xC5E8)
#define _C2FIFOINT10INV   (_SRFS_ADDR(1) + 0xC5EC)
#define _C2FIFOUA10       (_SRFS_ADDR(1) + 0xC5F0)
#define _C2FIFOUA10CLR    (_SRFS_ADDR(1) + 0xC5F4)
#define _C2FIFOUA10SET    (_SRFS_ADDR(1) + 0xC5F8)
#define _C2FIFOUA10INV    (_SRFS_ADDR(1) + 0xC5FC)
#define _C2FIFOCI10       (_SRFS_ADDR(1) + 0xC600)
#define _C2FIFOCI10CLR    (_SRFS_ADDR(1) + 0xC604)
#define _C2FIFOCI10SET    (_SRFS_ADDR(1) + 0xC608)
#define _C2FIFOCI10INV    (_SRFS_ADDR(1) + 0xC60C)
#define _C2FIFOCON11      (_SRFS_ADDR(1) + 0xC610)
#define _C2FIFOCON11CLR   (_SRFS_ADDR(1) + 0xC614)
#define _C2FIFOCON11SET   (_SRFS_ADDR(1) + 0xC618)
#define _C2FIFOCON11INV   (_SRFS_ADDR(1) + 0xC61C)
#define _C2FIFOINT11      (_SRFS_ADDR(1) + 0xC620)
#define _C2FIFOINT11CLR   (_SRFS_ADDR(1) + 0xC624)
#define _C2FIFOINT11SET   (_SRFS_ADDR(1) + 0xC628)
#define _C2FIFOINT11INV   (_SRFS_ADDR(1) + 0xC62C)
#define _C2FIFOUA11       (_SRFS_ADDR(1) + 0xC630)
#define _C2FIFOUA11CLR    (_SRFS_ADDR(1) + 0xC634)
#define _C2FIFOUA11SET    (_SRFS_ADDR(1) + 0xC638)
#define _C2FIFOUA11INV    (_SRFS_ADDR(1) + 0xC63C)
#define _C2FIFOCI11       (_SRFS_ADDR(1) + 0xC640)
#define _C2FIFOCI11CLR    (_SRFS_ADDR(1) + 0xC644)
#define _C2FIFOCI11SET    (_SRFS_ADDR(1) + 0xC648)
#define _C2FIFOCI11INV    (_SRFS_ADDR(1) + 0xC64C)
#define _C2FIFOCON12      (_SRFS_ADDR(1) + 0xC650)
#define _C2FIFOCON12CLR   (_SRFS_ADDR(1) + 0xC654)
#define _C2FIFOCON12SET   (_SRFS_ADDR(1) + 0xC658)
#define _C2FIFOCON12INV   (_SRFS_ADDR(1) + 0xC65C)
#define _C2FIFOINT12      (_SRFS_ADDR(1) + 0xC660)
#define _C2FIFOINT12CLR   (_SRFS_ADDR(1) + 0xC664)
#define _C2FIFOINT12SET   (_SRFS_ADDR(1) + 0xC668)
#define _C2FIFOINT12INV   (_SRFS_ADDR(1) + 0xC66C)
#define _C2FIFOUA12       (_SRFS_ADDR(1) + 0xC670)
#define _C2FIFOUA12CLR    (_SRFS_ADDR(1) + 0xC674)
#define _C2FIFOUA12SET    (_SRFS_ADDR(1) + 0xC678)
#define _C2FIFOUA12INV    (_SRFS_ADDR(1) + 0xC67C)
#define _C2FIFOCI12       (_SRFS_ADDR(1) + 0xC680)
#define _C2FIFOCI12CLR    (_SRFS_ADDR(1) + 0xC684)
#define _C2FIFOCI12SET    (_SRFS_ADDR(1) + 0xC688)
#define _C2FIFOCI12INV    (_SRFS_ADDR(1) + 0xC68C)
#define _C2FIFOCON13      (_SRFS_ADDR(1) + 0xC690)
#define _C2FIFOCON13CLR   (_SRFS_ADDR(1) + 0xC694)
#define _C2FIFOCON13SET   (_SRFS_ADDR(1) + 0xC698)
#define _C2FIFOCON13INV   (_SRFS_ADDR(1) + 0xC69C)
#define _C2FIFOINT13      (_SRFS_ADDR(1) + 0xC6A0)
#define _C2FIFOINT13CLR   (_SRFS_ADDR(1) + 0xC6A4)
#define _C2FIFOINT13SET   (_SRFS_ADDR(1) + 0xC6A8)
#define _C2FIFOINT13INV   (_SRFS_ADDR(1) + 0xC6AC)
#define _C2FIFOUA13       (_SRFS_ADDR(1) + 0xC6B0)
#define _C2FIFOUA13CLR    (_SRFS_ADDR(1) + 0xC6B4)
#define _C2FIFOUA13SET    (_SRFS_ADDR(1) + 0xC6B8)
#define _C2FIFOUA13INV    (_SRFS_ADDR(1) + 0xC6BC)
#define _C2FIFOCI13       (_SRFS_ADDR(1) + 0xC6C0)
#define _C2FIFOCI13CLR    (_SRFS_ADDR(1) + 0xC6C4)
#define _C2FIFOCI13SET    (_SRFS_ADDR(1) + 0xC6C8)
#define _C2FIFOCI13INV    (_SRFS_ADDR(1) + 0xC6CC)
#define _C2FIFOCON14      (_SRFS_ADDR(1) + 0xC6D0)
#define _C2FIFOCON14CLR   (_SRFS_ADDR(1) + 0xC6D4)
#define _C2FIFOCON14SET   (_SRFS_ADDR(1) + 0xC6D8)
#define _C2FIFOCON14INV   (_SRFS_ADDR(1) + 0xC6DC)
#define _C2FIFOINT14      (_SRFS_ADDR(1) + 0xC6E0)
#define _C2FIFOINT14CLR   (_SRFS_ADDR(1) + 0xC6E4)
#define _C2FIFOINT14SET   (_SRFS_ADDR(1) + 0xC6E8)
#define _C2FIFOINT14INV   (_SRFS_ADDR(1) + 0xC6EC)
#define _C2FIFOUA14       (_SRFS_ADDR(1) + 0xC6F0)
#define _C2FIFOUA14CLR    (_SRFS_ADDR(1) + 0xC6F4)
#define _C2FIFOUA14SET    (_SRFS_ADDR(1) + 0xC6F8)
#define _C2FIFOUA14INV    (_SRFS_ADDR(1) + 0xC6FC)
#define _C2FIFOCI14       (_SRFS_ADDR(1) + 0xC700)
#define _C2FIFOCI14CLR    (_SRFS_ADDR(1) + 0xC704)
#define _C2FIFOCI14SET    (_SRFS_ADDR(1) + 0xC708)
#define _C2FIFOCI14INV    (_SRFS_ADDR(1) + 0xC70C)
#define _C2FIFOCON15      (_SRFS_ADDR(1) + 0xC710)
#define _C2FIFOCON15CLR   (_SRFS_ADDR(1) + 0xC714)
#define _C2FIFOCON15SET   (_SRFS_ADDR(1) + 0xC718)
#define _C2FIFOCON15INV   (_SRFS_ADDR(1) + 0xC71C)
#define _C2FIFOINT15      (_SRFS_ADDR(1) + 0xC720)
#define _C2FIFOINT15CLR   (_SRFS_ADDR(1) + 0xC724)
#define _C2FIFOINT15SET   (_SRFS_ADDR(1) + 0xC728)
#define _C2FIFOINT15INV   (_SRFS_ADDR(1) + 0xC72C)
#define _C2FIFOUA15       (_SRFS_ADDR(1) + 0xC730)
#define _C2FIFOUA15CLR    (_SRFS_ADDR(1) + 0xC734)
#define _C2FIFOUA15SET    (_SRFS_ADDR(1) + 0xC738)
#define _C2FIFOUA15INV    (_SRFS_ADDR(1) + 0xC73C)
#define _C2FIFOCI15       (_SRFS_ADDR(1) + 0xC740)
#define _C2FIFOCI15CLR    (_SRFS_ADDR(1) + 0xC744)
#define _C2FIFOCI15SET    (_SRFS_ADDR(1) + 0xC748)
#define _C2FIFOCI15INV    (_SRFS_ADDR(1) + 0xC74C)
#define _C2FIFOCON16      (_SRFS_ADDR(1) + 0xC750)
#define _C2FIFOCON16CLR   (_SRFS_ADDR(1) + 0xC754)
#define _C2FIFOCON16SET   (_SRFS_ADDR(1) + 0xC758)
#define _C2FIFOCON16INV   (_SRFS_ADDR(1) + 0xC75C)
#define _C2FIFOINT16      (_SRFS_ADDR(1) + 0xC760)
#define _C2FIFOINT16CLR   (_SRFS_ADDR(1) + 0xC764)
#define _C2FIFOINT16SET   (_SRFS_ADDR(1) + 0xC768)
#define _C2FIFOINT16INV   (_SRFS_ADDR(1) + 0xC76C)
#define _C2FIFOUA16       (_SRFS_ADDR(1) + 0xC770)
#define _C2FIFOUA16CLR    (_SRFS_ADDR(1) + 0xC774)
#define _C2FIFOUA16SET    (_SRFS_ADDR(1) + 0xC778)
#define _C2FIFOUA16INV    (_SRFS_ADDR(1) + 0xC77C)
#define _C2FIFOCI16       (_SRFS_ADDR(1) + 0xC780)
#define _C2FIFOCI16CLR    (_SRFS_ADDR(1) + 0xC784)
#define _C2FIFOCI16SET    (_SRFS_ADDR(1) + 0xC788)
#define _C2FIFOCI16INV    (_SRFS_ADDR(1) + 0xC78C)
#define _C2FIFOCON17      (_SRFS_ADDR(1) + 0xC790)
#define _C2FIFOCON17CLR   (_SRFS_ADDR(1) + 0xC794)
#define _C2FIFOCON17SET   (_SRFS_ADDR(1) + 0xC798)
#define _C2FIFOCON17INV   (_SRFS_ADDR(1) + 0xC79C)
#define _C2FIFOINT17      (_SRFS_ADDR(1) + 0xC7A0)
#define _C2FIFOINT17CLR   (_SRFS_ADDR(1) + 0xC7A4)
#define _C2FIFOINT17SET   (_SRFS_ADDR(1) + 0xC7A8)
#define _C2FIFOINT17INV   (_SRFS_ADDR(1) + 0xC7AC)
#define _C2FIFOUA17       (_SRFS_ADDR(1) + 0xC7B0)
#define _C2FIFOUA17CLR    (_SRFS_ADDR(1) + 0xC7B4)
#define _C2FIFOUA17SET    (_SRFS_ADDR(1) + 0xC7B8)
#define _C2FIFOUA17INV    (_SRFS_ADDR(1) + 0xC7BC)
#define _C2FIFOCI17       (_SRFS_ADDR(1) + 0xC7C0)
#define _C2FIFOCI17CLR    (_SRFS_ADDR(1) + 0xC7C4)
#define _C2FIFOCI17SET    (_SRFS_ADDR(1) + 0xC7C8)
#define _C2FIFOCI17INV    (_SRFS_ADDR(1) + 0xC7CC)
#define _C2FIFOCON18      (_SRFS_ADDR(1) + 0xC7D0)
#define _C2FIFOCON18CLR   (_SRFS_ADDR(1) + 0xC7D4)
#define _C2FIFOCON18SET   (_SRFS_ADDR(1) + 0xC7D8)
#define _C2FIFOCON18INV   (_SRFS_ADDR(1) + 0xC7DC)
#define _C2FIFOINT18      (_SRFS_ADDR(1) + 0xC7E0)
#define _C2FIFOINT18CLR   (_SRFS_ADDR(1) + 0xC7E4)
#define _C2FIFOINT18SET   (_SRFS_ADDR(1) + 0xC7E8)
#define _C2FIFOINT18INV   (_SRFS_ADDR(1) + 0xC7EC)
#define _C2FIFOUA18       (_SRFS_ADDR(1) + 0xC7F0)
#define _C2FIFOUA18CLR    (_SRFS_ADDR(1) + 0xC7F4)
#define _C2FIFOUA18SET    (_SRFS_ADDR(1) + 0xC7F8)
#define _C2FIFOUA18INV    (_SRFS_ADDR(1) + 0xC7FC)
#define _C2FIFOCI18       (_SRFS_ADDR(1) + 0xC800)
#define _C2FIFOCI18CLR    (_SRFS_ADDR(1) + 0xC804)
#define _C2FIFOCI18SET    (_SRFS_ADDR(1) + 0xC808)
#define _C2FIFOCI18INV    (_SRFS_ADDR(1) + 0xC80C)
#define _C2FIFOCON19      (_SRFS_ADDR(1) + 0xC810)
#define _C2FIFOCON19CLR   (_SRFS_ADDR(1) + 0xC814)
#define _C2FIFOCON19SET   (_SRFS_ADDR(1) + 0xC818)
#define _C2FIFOCON19INV   (_SRFS_ADDR(1) + 0xC81C)
#define _C2FIFOINT19      (_SRFS_ADDR(1) + 0xC820)
#define _C2FIFOINT19CLR   (_SRFS_ADDR(1) + 0xC824)
#define _C2FIFOINT19SET   (_SRFS_ADDR(1) + 0xC828)
#define _C2FIFOINT19INV   (_SRFS_ADDR(1) + 0xC82C)
#define _C2FIFOUA19       (_SRFS_ADDR(1) + 0xC830)
#define _C2FIFOUA19CLR    (_SRFS_ADDR(1) + 0xC834)
#define _C2FIFOUA19SET    (_SRFS_ADDR(1) + 0xC838)
#define _C2FIFOUA19INV    (_SRFS_ADDR(1) + 0xC83C)
#define _C2FIFOCI19       (_SRFS_ADDR(1) + 0xC840)
#define _C2FIFOCI19CLR    (_SRFS_ADDR(1) + 0xC844)
#define _C2FIFOCI19SET    (_SRFS_ADDR(1) + 0xC848)
#define _C2FIFOCI19INV    (_SRFS_ADDR(1) + 0xC84C)
#define _C2FIFOCON20      (_SRFS_ADDR(1) + 0xC850)
#define _C2FIFOCON20CLR   (_SRFS_ADDR(1) + 0xC854)
#define _C2FIFOCON20SET   (_SRFS_ADDR(1) + 0xC858)
#define _C2FIFOCON20INV   (_SRFS_ADDR(1) + 0xC85C)
#define _C2FIFOINT20      (_SRFS_ADDR(1) + 0xC860)
#define _C2FIFOINT20CLR   (_SRFS_ADDR(1) + 0xC864)
#define _C2FIFOINT20SET   (_SRFS_ADDR(1) + 0xC868)
#define _C2FIFOINT20INV   (_SRFS_ADDR(1) + 0xC86C)
#define _C2FIFOUA20       (_SRFS_ADDR(1) + 0xC870)
#define _C2FIFOUA20CLR    (_SRFS_ADDR(1) + 0xC874)
#define _C2FIFOUA20SET    (_SRFS_ADDR(1) + 0xC878)
#define _C2FIFOUA20INV    (_SRFS_ADDR(1) + 0xC87C)
#define _C2FIFOCI20       (_SRFS_ADDR(1) + 0xC880)
#define _C2FIFOCI20CLR    (_SRFS_ADDR(1) + 0xC884)
#define _C2FIFOCI20SET    (_SRFS_ADDR(1) + 0xC888)
#define _C2FIFOCI20INV    (_SRFS_ADDR(1) + 0xC88C)
#define _C2FIFOCON21      (_SRFS_ADDR(1) + 0xC890)
#define _C2FIFOCON21CLR   (_SRFS_ADDR(1) + 0xC894)
#define _C2FIFOCON21SET   (_SRFS_ADDR(1) + 0xC898)
#define _C2FIFOCON21INV   (_SRFS_ADDR(1) + 0xC89C)
#define _C2FIFOINT21      (_SRFS_ADDR(1) + 0xC8A0)
#define _C2FIFOINT21CLR   (_SRFS_ADDR(1) + 0xC8A4)
#define _C2FIFOINT21SET   (_SRFS_ADDR(1) + 0xC8A8)
#define _C2FIFOINT21INV   (_SRFS_ADDR(1) + 0xC8AC)
#define _C2FIFOUA21       (_SRFS_ADDR(1) + 0xC8B0)
#define _C2FIFOUA21CLR    (_SRFS_ADDR(1) + 0xC8B4)
#define _C2FIFOUA21SET    (_SRFS_ADDR(1) + 0xC8B8)
#define _C2FIFOUA21INV    (_SRFS_ADDR(1) + 0xC8BC)
#define _C2FIFOCI21       (_SRFS_ADDR(1) + 0xC8C0)
#define _C2FIFOCI21CLR    (_SRFS_ADDR(1) + 0xC8C4)
#define _C2FIFOCI21SET    (_SRFS_ADDR(1) + 0xC8C8)
#define _C2FIFOCI21INV    (_SRFS_ADDR(1) + 0xC8CC)
#define _C2FIFOCON22      (_SRFS_ADDR(1) + 0xC8D0)
#define _C2FIFOCON22CLR   (_SRFS_ADDR(1) + 0xC8D4)
#define _C2FIFOCON22SET   (_SRFS_ADDR(1) + 0xC8D8)
#define _C2FIFOCON22INV   (_SRFS_ADDR(1) + 0xC8DC)
#define _C2FIFOINT22      (_SRFS_ADDR(1) + 0xC8E0)
#define _C2FIFOINT22CLR   (_SRFS_ADDR(1) + 0xC8E4)
#define _C2FIFOINT22SET   (_SRFS_ADDR(1) + 0xC8E8)
#define _C2FIFOINT22INV   (_SRFS_ADDR(1) + 0xC8EC)
#define _C2FIFOUA22       (_SRFS_ADDR(1) + 0xC8F0)
#define _C2FIFOUA22CLR    (_SRFS_ADDR(1) + 0xC8F4)
#define _C2FIFOUA22SET    (_SRFS_ADDR(1) + 0xC8F8)
#define _C2FIFOUA22INV    (_SRFS_ADDR(1) + 0xC8FC)
#define _C2FIFOCI22       (_SRFS_ADDR(1) + 0xC900)
#define _C2FIFOCI22CLR    (_SRFS_ADDR(1) + 0xC904)
#define _C2FIFOCI22SET    (_SRFS_ADDR(1) + 0xC908)
#define _C2FIFOCI22INV    (_SRFS_ADDR(1) + 0xC90C)
#define _C2FIFOCON23      (_SRFS_ADDR(1) + 0xC910)
#define _C2FIFOCON23CLR   (_SRFS_ADDR(1) + 0xC914)
#define _C2FIFOCON23SET   (_SRFS_ADDR(1) + 0xC918)
#define _C2FIFOCON23INV   (_SRFS_ADDR(1) + 0xC91C)
#define _C2FIFOINT23      (_SRFS_ADDR(1) + 0xC920)
#define _C2FIFOINT23CLR   (_SRFS_ADDR(1) + 0xC924)
#define _C2FIFOINT23SET   (_SRFS_ADDR(1) + 0xC928)
#define _C2FIFOINT23INV   (_SRFS_ADDR(1) + 0xC92C)
#define _C2FIFOUA23       (_SRFS_ADDR(1) + 0xC930)
#define _C2FIFOUA23CLR    (_SRFS_ADDR(1) + 0xC934)
#define _C2FIFOUA23SET    (_SRFS_ADDR(1) + 0xC938)
#define _C2FIFOUA23INV    (_SRFS_ADDR(1) + 0xC93C)
#define _C2FIFOCI23       (_SRFS_ADDR(1) + 0xC940)
#define _C2FIFOCI23CLR    (_SRFS_ADDR(1) + 0xC944)
#define _C2FIFOCI23SET    (_SRFS_ADDR(1) + 0xC948)
#define _C2FIFOCI23INV    (_SRFS_ADDR(1) + 0xC94C)
#define _C2FIFOCON24      (_SRFS_ADDR(1) + 0xC950)
#define _C2FIFOCON24CLR   (_SRFS_ADDR(1) + 0xC954)
#define _C2FIFOCON24SET   (_SRFS_ADDR(1) + 0xC958)
#define _C2FIFOCON24INV   (_SRFS_ADDR(1) + 0xC95C)
#define _C2FIFOINT24      (_SRFS_ADDR(1) + 0xC960)
#define _C2FIFOINT24CLR   (_SRFS_ADDR(1) + 0xC964)
#define _C2FIFOINT24SET   (_SRFS_ADDR(1) + 0xC968)
#define _C2FIFOINT24INV   (_SRFS_ADDR(1) + 0xC96C)
#define _C2FIFOUA24       (_SRFS_ADDR(1) + 0xC970)
#define _C2FIFOUA24CLR    (_SRFS_ADDR(1) + 0xC974)
#define _C2FIFOUA24SET    (_SRFS_ADDR(1) + 0xC978)
#define _C2FIFOUA24INV    (_SRFS_ADDR(1) + 0xC97C)
#define _C2FIFOCI24       (_SRFS_ADDR(1) + 0xC980)
#define _C2FIFOCI24CLR    (_SRFS_ADDR(1) + 0xC984)
#define _C2FIFOCI24SET    (_SRFS_ADDR(1) + 0xC988)
#define _C2FIFOCI24INV    (_SRFS_ADDR(1) + 0xC98C)
#define _C2FIFOCON25      (_SRFS_ADDR(1) + 0xC990)
#define _C2FIFOCON25CLR   (_SRFS_ADDR(1) + 0xC994)
#define _C2FIFOCON25SET   (_SRFS_ADDR(1) + 0xC998)
#define _C2FIFOCON25INV   (_SRFS_ADDR(1) + 0xC99C)
#define _C2FIFOINT25      (_SRFS_ADDR(1) + 0xC9A0)
#define _C2FIFOINT25CLR   (_SRFS_ADDR(1) + 0xC9A4)
#define _C2FIFOINT25SET   (_SRFS_ADDR(1) + 0xC9A8)
#define _C2FIFOINT25INV   (_SRFS_ADDR(1) + 0xC9AC)
#define _C2FIFOUA25       (_SRFS_ADDR(1) + 0xC9B0)
#define _C2FIFOUA25CLR    (_SRFS_ADDR(1) + 0xC9B4)
#define _C2FIFOUA25SET    (_SRFS_ADDR(1) + 0xC9B8)
#define _C2FIFOUA25INV    (_SRFS_ADDR(1) + 0xC9BC)
#define _C2FIFOCI25       (_SRFS_ADDR(1) + 0xC9C0)
#define _C2FIFOCI25CLR    (_SRFS_ADDR(1) + 0xC9C4)
#define _C2FIFOCI25SET    (_SRFS_ADDR(1) + 0xC9C8)
#define _C2FIFOCI25INV    (_SRFS_ADDR(1) + 0xC9CC)
#define _C2FIFOCON26      (_SRFS_ADDR(1) + 0xC9D0)
#define _C2FIFOCON26CLR   (_SRFS_ADDR(1) + 0xC9D4)
#define _C2FIFOCON26SET   (_SRFS_ADDR(1) + 0xC9D8)
#define _C2FIFOCON26INV   (_SRFS_ADDR(1) + 0xC9DC)
#define _C2FIFOINT26      (_SRFS_ADDR(1) + 0xC9E0)
#define _C2FIFOINT26CLR   (_SRFS_ADDR(1) + 0xC9E4)
#define _C2FIFOINT26SET   (_SRFS_ADDR(1) + 0xC9E8)
#define _C2FIFOINT26INV   (_SRFS_ADDR(1) + 0xC9EC)
#define _C2FIFOUA26       (_SRFS_ADDR(1) + 0xC9F0)
#define _C2FIFOUA26CLR    (_SRFS_ADDR(1) + 0xC9F4)
#define _C2FIFOUA26SET    (_SRFS_ADDR(1) + 0xC9F8)
#define _C2FIFOUA26INV    (_SRFS_ADDR(1) + 0xC9FC)
#define _C2FIFOCI26       (_SRFS_ADDR(1) + 0xCA00)
#define _C2FIFOCI26CLR    (_SRFS_ADDR(1) + 0xCA04)
#define _C2FIFOCI26SET    (_SRFS_ADDR(1) + 0xCA08)
#define _C2FIFOCI26INV    (_SRFS_ADDR(1) + 0xCA0C)
#define _C2FIFOCON27      (_SRFS_ADDR(1) + 0xCA10)
#define _C2FIFOCON27CLR   (_SRFS_ADDR(1) + 0xCA14)
#define _C2FIFOCON27SET   (_SRFS_ADDR(1) + 0xCA18)
#define _C2FIFOCON27INV   (_SRFS_ADDR(1) + 0xCA1C)
#define _C2FIFOINT27      (_SRFS_ADDR(1) + 0xCA20)
#define _C2FIFOINT27CLR   (_SRFS_ADDR(1) + 0xCA24)
#define _C2FIFOINT27SET   (_SRFS_ADDR(1) + 0xCA28)
#define _C2FIFOINT27INV   (_SRFS_ADDR(1) + 0xCA2C)
#define _C2FIFOUA27       (_SRFS_ADDR(1) + 0xCA30)
#define _C2FIFOUA27CLR    (_SRFS_ADDR(1) + 0xCA34)
#define _C2FIFOUA27SET    (_SRFS_ADDR(1) + 0xCA38)
#define _C2FIFOUA27INV    (_SRFS_ADDR(1) + 0xCA3C)
#define _C2FIFOCI27       (_SRFS_ADDR(1) + 0xCA40)
#define _C2FIFOCI27CLR    (_SRFS_ADDR(1) + 0xCA44)
#define _C2FIFOCI27SET    (_SRFS_ADDR(1) + 0xCA48)
#define _C2FIFOCI27INV    (_SRFS_ADDR(1) + 0xCA4C)
#define _C2FIFOCON28      (_SRFS_ADDR(1) + 0xCA50)
#define _C2FIFOCON28CLR   (_SRFS_ADDR(1) + 0xCA54)
#define _C2FIFOCON28SET   (_SRFS_ADDR(1) + 0xCA58)
#define _C2FIFOCON28INV   (_SRFS_ADDR(1) + 0xCA5C)
#define _C2FIFOINT28      (_SRFS_ADDR(1) + 0xCA60)
#define _C2FIFOINT28CLR   (_SRFS_ADDR(1) + 0xCA64)
#define _C2FIFOINT28SET   (_SRFS_ADDR(1) + 0xCA68)
#define _C2FIFOINT28INV   (_SRFS_ADDR(1) + 0xCA6C)
#define _C2FIFOUA28       (_SRFS_ADDR(1) + 0xCA70)
#define _C2FIFOUA28CLR    (_SRFS_ADDR(1) + 0xCA74)
#define _C2FIFOUA28SET    (_SRFS_ADDR(1) + 0xCA78)
#define _C2FIFOUA28INV    (_SRFS_ADDR(1) + 0xCA7C)
#define _C2FIFOCI28       (_SRFS_ADDR(1) + 0xCA80)
#define _C2FIFOCI28CLR    (_SRFS_ADDR(1) + 0xCA84)
#define _C2FIFOCI28SET    (_SRFS_ADDR(1) + 0xCA88)
#define _C2FIFOCI28INV    (_SRFS_ADDR(1) + 0xCA8C)
#define _C2FIFOCON29      (_SRFS_ADDR(1) + 0xCA90)
#define _C2FIFOCON29CLR   (_SRFS_ADDR(1) + 0xCA94)
#define _C2FIFOCON29SET   (_SRFS_ADDR(1) + 0xCA98)
#define _C2FIFOCON29INV   (_SRFS_ADDR(1) + 0xCA9C)
#define _C2FIFOINT29      (_SRFS_ADDR(1) + 0xCAA0)
#define _C2FIFOINT29CLR   (_SRFS_ADDR(1) + 0xCAA4)
#define _C2FIFOINT29SET   (_SRFS_ADDR(1) + 0xCAA8)
#define _C2FIFOINT29INV   (_SRFS_ADDR(1) + 0xCAAC)
#define _C2FIFOUA29       (_SRFS_ADDR(1) + 0xCAB0)
#define _C2FIFOUA29CLR    (_SRFS_ADDR(1) + 0xCAB4)
#define _C2FIFOUA29SET    (_SRFS_ADDR(1) + 0xCAB8)
#define _C2FIFOUA29INV    (_SRFS_ADDR(1) + 0xCABC)
#define _C2FIFOCI29       (_SRFS_ADDR(1) + 0xCAC0)
#define _C2FIFOCI29CLR    (_SRFS_ADDR(1) + 0xCAC4)
#define _C2FIFOCI29SET    (_SRFS_ADDR(1) + 0xCAC8)
#define _C2FIFOCI29INV    (_SRFS_ADDR(1) + 0xCACC)
#define _C2FIFOCON30      (_SRFS_ADDR(1) + 0xCAD0)
#define _C2FIFOCON30CLR   (_SRFS_ADDR(1) + 0xCAD4)
#define _C2FIFOCON30SET   (_SRFS_ADDR(1) + 0xCAD8)
#define _C2FIFOCON30INV   (_SRFS_ADDR(1) + 0xCADC)
#define _C2FIFOINT30      (_SRFS_ADDR(1) + 0xCAE0)
#define _C2FIFOINT30CLR   (_SRFS_ADDR(1) + 0xCAE4)
#define _C2FIFOINT30SET   (_SRFS_ADDR(1) + 0xCAE8)
#define _C2FIFOINT30INV   (_SRFS_ADDR(1) + 0xCAEC)
#define _C2FIFOUA30       (_SRFS_ADDR(1) + 0xCAF0)
#define _C2FIFOUA30CLR    (_SRFS_ADDR(1) + 0xCAF4)
#define _C2FIFOUA30SET    (_SRFS_ADDR(1) + 0xCAF8)
#define _C2FIFOUA30INV    (_SRFS_ADDR(1) + 0xCAFC)
#define _C2FIFOCI30       (_SRFS_ADDR(1) + 0xCB00)
#define _C2FIFOCI30CLR    (_SRFS_ADDR(1) + 0xCB04)
#define _C2FIFOCI30SET    (_SRFS_ADDR(1) + 0xCB08)
#define _C2FIFOCI30INV    (_SRFS_ADDR(1) + 0xCB0C)
#define _C2FIFOCON31      (_SRFS_ADDR(1) + 0xCB10)
#define _C2FIFOCON31CLR   (_SRFS_ADDR(1) + 0xCB14)
#define _C2FIFOCON31SET   (_SRFS_ADDR(1) + 0xCB18)
#define _C2FIFOCON31INV   (_SRFS_ADDR(1) + 0xCB1C)
#define _C2FIFOINT31      (_SRFS_ADDR(1) + 0xCB20)
#define _C2FIFOINT31CLR   (_SRFS_ADDR(1) + 0xCB24)
#define _C2FIFOINT31SET   (_SRFS_ADDR(1) + 0xCB28)
#define _C2FIFOINT31INV   (_SRFS_ADDR(1) + 0xCB2C)
#define _C2FIFOUA31       (_SRFS_ADDR(1) + 0xCB30)
#define _C2FIFOUA31CLR    (_SRFS_ADDR(1) + 0xCB34)
#define _C2FIFOUA31SET    (_SRFS_ADDR(1) + 0xCB38)
#define _C2FIFOUA31INV    (_SRFS_ADDR(1) + 0xCB3C)
#define _C2FIFOCI31       (_SRFS_ADDR(1) + 0xCB40)
#define _C2FIFOCI31CLR    (_SRFS_ADDR(1) + 0xCB44)
#define _C2FIFOCI31SET    (_SRFS_ADDR(1) + 0xCB48)
#define _C2FIFOCI31INV    (_SRFS_ADDR(1) + 0xCB4C)
#define _DEVCFG3          0xBFC02FF0
#define _DEVCFG2          0xBFC02FF4
#define _DEVCFG1          0xBFC02FF8
#define _DEVCFG0          0xBFC02FFC
#endif /* _P32MX_7XX_REGS_H_ */
